Package: oligoClasses
Version: 1.74.0
Title: Classes for high-throughput arrays supported by oligo and crlmm
Author: Benilton Carvalho and Robert Scharpf
Maintainer: Benilton Carvalho <beniltoncarvalho@gmail.com> and Robert Scharpf <rscharpf@jhsph.edu>
Depends: R (>= 2.14)
Imports: BiocGenerics (>= 0.27.1), Biobase (>= 2.17.8), methods,
        graphics, IRanges (>= 2.5.17), GenomicRanges (>= 1.23.7),
        SummarizedExperiment, Biostrings (>= 2.23.6), affyio (>=
        1.23.2), foreach, BiocManager, utils, S4Vectors (>= 0.9.25),
        RSQLite, DBI, ff
Enhances: doMC, doMPI, doSNOW, doParallel, doRedis
Suggests: hapmapsnp5, hapmapsnp6, pd.genomewidesnp.6,
        pd.genomewidesnp.5, pd.mapping50k.hind240,
        pd.mapping50k.xba240, pd.mapping250k.sty, pd.mapping250k.nsp,
        genomewidesnp6Crlmm (>= 1.0.7), genomewidesnp5Crlmm (>= 1.0.6),
        RUnit, human370v1cCrlmm, VanillaICE, crlmm
Description: This package contains class definitions, validity checks, and initialization methods for classes used by the oligo and crlmm packages.
License: GPL (>= 2)
LazyLoad: yes
Collate: AllClasses.R AllGenerics.R utils-general.R utils-lds.R
        utils-parallel.R methods-gSet.R initialize-methods.R
        methods-AlleleSet.R methods-AnnotatedDataFrame.R
        methods-FeatureSet.R methods-AssayData.R
        methods-SnpFeatureSet.R methods-oligoSnpSet.R
        methods-CopyNumberSet.R methods-CNSet.R methods-PDInfo.R
        methods-RangedDataCNV.R methods-SnpSet.R
        methods-GenomeAnnotatedDataFrame.R methods-BeadStudioSet.R
        methods-BeadStudioSetList.R methods-gSetList.R
        methods-GRanges.R methods-SummarizedExperiment.R show-methods.R
        functions.R zzz.R
biocViews: Infrastructure
RoxygenNote: 6.1.1
git_url: https://git.bioconductor.org/packages/oligoClasses
git_branch: RELEASE_3_23
git_last_commit: 1febb80
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-28 23:38:29 UTC; biocbuild

## Only accessors for FeatureSet objects

## In addition to the slots inherited from eSet, FeatureSet has:
##   - manufacturer
##   - 'exprs' in assayData
##   - 'channel1' and 'channel2' in assayData

setMethod("manufacturer", signature(object="FeatureSet"),
          function(object) object@manufacturer)
setReplaceMethod("manufacturer", signature(object="FeatureSet"),
		function(object, value){
                  object@manufacturer <- value
                  object
})

setMethod("exprs",
          signature(object="FeatureSet"),
          function(object)
          assayDataElement(object,"exprs"))
setReplaceMethod("exprs",
		signature(object="FeatureSet"),
		function(object, value)
                 assayDataElementReplace(object, "exprs", value))

setMethod("db", "FeatureSet",
          function(object){
            db(get(annotation(object)))
          })

setMethod("kind", "FeatureSet",
          function(object){
            kind(get(annotation(object)))
          })

setMethod("geometry", "FeatureSet",
          function(object)
          geometry(getPD(object))
          )

integerMatrix <- function(x, scale=100) {
	if(!is(x, "matrix")) stop("argument x must be a matrix")
	dms <- dimnames(x)
	if(scale != 1){
		xx <- as.integer(x*scale)
	} else xx <- as.integer(x)
	x <- matrix(xx, nrow(x), ncol(x))
	dimnames(x) <- dms
	return(x)
}

numericMatrix <- function(x, scale=1/100) {
	return(x/scale)
}

integerArray <- function(x, scale=100){
	if(!is(x, "array")) stop("argument x must be an array")
	dims <- dim(x)
	dms <- dimnames(x)
	if(scale != 1){
		xx <- as.integer(x*scale)
	} else xx <- as.integer(x)
	x <- array(xx, dim=dims, dimnames=dms)
	return(x)
}

getSequenceLengths <- function(build){
	path <- system.file("extdata", package="oligoClasses")
	load(file.path(path, paste("seqlengths_", build, ".rda", sep="")))
	return(seqlengths)
}

setSequenceLengths <- function(build, names){ ## names are unique(seqnames(object))
	sl <- getSequenceLengths(build)
	sl[match(unique(names), names(sl))]
}

chromosome2integer <- function(chrom){
	chrom[chrom == "X"] <- 23; chrom[chrom == "Y"] <- 24; chrom[chrom == "XY"] <- 25; chrom[chrom=="M" | chrom == "MT" | chrom == "Mt"] <- 26
	as.integer(chrom)
}
integer2chromosome <- function(intChrom){
	charChrom <- as.character(intChrom)
	charChrom[charChrom=="23"] <- "X"
	charChrom[charChrom=="24"] <- "Y"
	charChrom[charChrom %in% c("MT", "Mt")] <- "M"
	charChrom
}

.getArm <- function(chrom, pos, genome){
  if(is.integer(chrom)) chrom <- paste("chr", integer2chromosome(chrom), sep="")
  path.gap <- system.file("extdata", package="oligoClasses")
  gfile <- list.files(path.gap,
                      pattern=paste("gap_", genome, ".rda", sep=""),
                      full.names=TRUE)
  gaps <- readRDS(gfile)
  centromere.starts <- start(gaps)
  centromere.ends <- end(gaps)
  names(centromere.ends) <- names(centromere.starts) <- seqnames(gaps)
  centromere.starts <- centromere.starts[chrom]
  centromere.ends <- centromere.ends[chrom]
  chr.arm <- arm <- rep(NA, length(pos))
  arm[pos <= centromere.starts] <- "p"
  arm[pos >= centromere.ends] <- "q"
  ##arm <- ifelse(pos <= centromere.starts, "p", "q")
  chr.arm[!is.na(arm)] <- paste(chrom[!is.na(arm)], arm[!is.na(arm)], sep="")
  chr.arm
}

## from xmapcore package
if( require( "RUnit", quietly=TRUE ) ) {
        ## loading Biobase below b/c we're simply Import:ing it, rather than Depend:ing on it
        ## then functions from there are not visible downstream
        library(Biobase)
	pkg <- "oligoClasses"

	if( Sys.getenv( "RCMDCHECK" ) == "FALSE" ) {
		path <- file.path( getwd(), "..", "inst", "unitTests" )
	} else {
		path <- system.file( package=pkg, "unitTests" )
	}

	cat( "\nRunning unit tests\n" )
	print( list( pkg=pkg, getwd=getwd(), pathToUnitTests=path ) )
	library( package=pkg, character.only=TRUE )

	##xmap.clear.cache()

	##Fail on warnings
	##options( warn=2 )
	options(warn=0)

	## Get the pattern (if there is one?)
	patt <- Sys.getenv( "RUNITFILEPATTERN" )
	if( is.null( patt ) || nchar( patt ) == 0 ) {
		testSuite <- defineTestSuite(name=paste( pkg, "unit testing" ),
					     dirs=path,
					     testFileRegexp=paste( "^test.+", patt, "\\.[rR]$", sep="" ))
	} else {
		##testSuite <- defineTestSuite( name=paste( pkg, "unit testing" ), testFileRegexp=paste( "^runit\\.", patt, "\\.[rR]$", sep="" ), dirs=path )
		testSuite <- defineTestSuite(name=paste( pkg, "unit testing" ),
					     testFileRegexp=paste( "^test.+", patt, "\\.[rR]$", sep="" ),
					     dirs=path )
	}
	tests <- runTestSuite( testSuite )

	pathReport <- file.path( path, "report" )

	cat( "------------------- UNIT TEST SUMMARY ---------------------\n\n" )
	printTextProtocol( tests, showDetails=FALSE )
	printTextProtocol( tests, showDetails=FALSE, fileName=paste( pathReport, "Summary.txt", sep="" ) )
	printTextProtocol( tests, showDetails=TRUE,  fileName=paste( pathReport, ".txt", sep="" ) )

	printHTMLProtocol( tests, fileName=paste( pathReport, ".html", sep="" ) )

	tmp <- getErrors( tests )
	if( tmp$nFail > 0 | tmp$nErr > 0 ){
		stop( paste( "\n\nunit testing failed (#test failures: ", tmp$nFail, ", #R errors: ",  tmp$nErr, ")\n\n", sep=""))
	}
} else {
	warning( "cannot run unit tests -- package RUnit is not available" )
}

##setMethod("copyNumber", "CopyNumberSet", function(object) assayData(object)[["copyNumber"]])
setMethod("copyNumber", "CopyNumberSet", function(object) {
	cn <- assayDataElement(object, "copyNumber")
	return(cn)
})

setReplaceMethod("copyNumber", signature(object="CopyNumberSet", value="matrix"),
                 function(object, value){
			 assayDataElementReplace(object, "copyNumber", value)
		 })

setMethod("cnConfidence", "CopyNumberSet", function(object) assayData(object)[["cnConfidence"]])
setReplaceMethod("cnConfidence", signature(object="CopyNumberSet", value="matrix"),
                 function(object, value){
			 assayDataElementReplace(object, "cnConfidence", value)
                 })



##setMethod("order", "CopyNumberSet",
##	  function(object, ..., na.last=TRUE, decreasing=FALSE){
##		  chromosomePositionOrder(...)
##	  })

setMethod("batchNames", "AssayData",
	  function(object){
		  ##should call method for AssayData
		  sampleNames(object)
	  })

setReplaceMethod("batchNames", "AssayData",
		 function(object, value){
			 sampleNames(object) <- value
			 return(object)
		 })

setMethod("nu", c("AssayData", "character"),
	  function(object, allele){
		  getValue <- function(allele){
			  switch(allele,
				 A="nuA",
				 B="nuB",
				 stop("allele must be 'A' or 'B'"))
		  }
		  val <- getValue(allele)
		  assayDataElement(object, val)
})



setMethod("phi", c("AssayData", "character"),
	  function(object, allele){
		  getValue <- function(allele){
			  switch(allele,
				 A="phiA",
				 B="phiB",
				 stop("allele must be 'A' or 'B'"))
		  }
		  val <- getValue(allele)
		  assayDataElement(object, val)
	  })

##setMethod("sigma2", c("AssayData", "character"),
##	  function(object, allele){
##		  getValue <- function(allele){
##			  switch(allele,
##				 A="sig2A",
##				 B="sig2B",
##				 stop("allele must be 'A' or 'B'"))
##		  }
##		  val <- getValue(allele)
##		  assayDataElement(object, val)
##	  })

##setMethod("tau2", c("AssayData", "character"),
##	  function(object, allele){
##		  getValue <- function(allele){
##			  switch(allele,
##				 A="tau2A",
##				 B="tau2B",
##				 stop("allele must be 'A' or 'B'"))
##		  }
##		  val <- getValue(allele)
##		  assayDataElement(object, val)
##	  })

##setMethod("corr", c("AssayData", "character"),
##	  function(object, allele){
##		  getValue <- function(allele){
##			  switch(allele,
##				 AA="corrAA",
##				 AB="corrAB",
##				 BB="corrBB",
##				 stop("allele must be 'AA', 'AB', or 'BB'"))
##		  }
##		  val <- getValue(allele)
##		  assayDataElement(object, val)
##	  })

setMethod("flags", signature(object="AssayData"), function(object) assayDataElement(object, "flags"))

AssayDataList <- function(storage.mode = c("lockedEnvironment", "environment", "list"), ...) {
  storage.mode <- match.arg(storage.mode) ## defaults to "lockedEnvironment"
  assayData <- switch(storage.mode,
                      lockedEnvironment =,
                      environment = new.env(parent=emptyenv()),
                      list = list())
  arglist <- list(...)
  for (nm in names(arglist)) assayData[[nm]] <- arglist[[nm]]
  ## FIX:  ::: not safe
  if (storage.mode == "lockedEnvironment") Biobase:::assayDataEnvLock(assayData)
  assayData
}

THISPKG <- "oligoClasses"
.oligoClassesPkgEnv <- new.env(parent=emptyenv())

.onAttach <- function(libname, pkgname) {
	version <- packageDescription("oligoClasses", fields="Version")
	packageStartupMessage("Welcome to oligoClasses version ", version)
	ldSetOptions()
##	bm <- ldStatus(TRUE)
##	snow <- ocParallelStatus()

	setHook(packageEvent("ff", "attach"),
		function(...){
			ldSetOptions(verbose=FALSE)
			ldStatus(TRUE)
		})

	setHook(packageEvent("foreach", "attach"),
		function(...){
			ocParallelStatus()
		})
}

setMethod("initialize", signature(.Object="BeadStudioSetList"),
	  function(.Object,
		   assayDataList=AssayDataList(baf=baf, lrr=lrr),
		   lrr=list(),
		   baf=lapply(lrr, function(x) matrix(nrow=nrow(x), ncol=ncol(x))),
		   featureDataList=GenomeAnnotatedDataFrameFrom(assayDataList, annotation, genome),
		   chromosome=vector("list", length(lrr)),
		   phenoData,
		   annotation=character(),
		   genome=character(),
		   ...){
		  if(missing(phenoData)){
			  if(length(lrr) > 0){
				  phenoData <- annotatedDataFrameFrom(lrr[[1]], byrow=FALSE)
			  } else {
				  phenoData <- new("AnnotatedDataFrame")
			  }
		  }
		  callNextMethod(.Object,
				 assayDataList=assayDataList,
				 featureDataList=featureDataList,
				 phenoData=phenoData,
				 chromosome=chromosome,
				 annotation=annotation,
				 genome=genome,
				 ...)
	  })

setMethod("updateObject", signature(object="BeadStudioSetList"),
          function(object, ..., verbose=FALSE) {
		  if (verbose) message("updateObject(object = 'BeadStudioSetList')")
		  obj <- tryCatch(callNextMethod(object), error=function(e) NULL)
		  if(is.null(obj)){
			  obj <- new("BeadStudioSetList",
				     assayDataList = assayDataList(object),
				     phenoData = phenoData(object),
				     annotation = updateObject(annotation(object),
				     ..., verbose=verbose),
				     featureDataList=featureDataList(object),
				     chromosome=chromosome(object),
				     genome=genomeBuild(object),
				     ...)
		  }
		  obj
          })
setMethod("[[", signature(x="BeadStudioSetList"),
	  function(x, i, j, ..., exact=TRUE){
		  if(missing(i)) return(x)
		  ad <- assayDataList(x)
		  fdlist <- featureData(x)
		  adnew <- switch(storage.mode(ad),
			  lockedEnvironment =,
				  environment = new.env(parent=emptyenv()),
				  list = list())
		  nms <- ls(ad)
		  if(length(i) == 1){
			  for (nm in ls(ad)){
				  elt <- ad[[nm]][[i]]
				  dimnames(elt) <- lapply(dimnames(elt), unname)
				  adnew[[nm]] <- elt
			  }
		  }
		  x <- new("BeadStudioSet",
			   assayData=adnew,
			   phenoData=phenoData(x),
			   featureData=fdlist[[i]],
			   genome=genomeBuild(x),
			   annotation=annotation(x))
	  })

setMethod("[[", signature(x="BafLrrSetList"),
	  function(x, i, j, ..., exact=TRUE){
		 x <- callNextMethod()
		 new("BafLrrSet",
		     assayData=assayData(x),
		     phenoData=phenoData(x),
		     featureData=featureData(x),
		     genome=genomeBuild(x),
		     annotation=annotation(x))
	  })

setMethod("[", signature(x="gSetList"),
	  function(x, i, j, ..., drop=TRUE){
		  if(missing(i) && missing(j)) return(x)
		  ad <- assayDataList(x)
		  if(!missing(i)){
			  fdlist <- featureData(x)[i]
		  }
		  adnew <- switch(storage.mode(ad),
			  lockedEnvironment =,
				  environment = new.env(parent=emptyenv()),
				  list = list())
		  nms <- ls(ad)
		  if(!missing(i)){
			  for (nm in ls(ad)){
				  elt <- ad[[nm]][i]
				  adnew[[nm]] <- elt
			  }
			  ad <- adnew
		  }
		  if(missing(j)){
			  x@featureDataList <- fdlist
			  x@chromosome <- x@chromosome[i]
		  } else {
			  for (nm in ls(ad)){
				  elt <- lapply(ad[[nm]], function(y, j) y[, j, drop=FALSE], j=j)
				  adnew[[nm]] <- elt
			  }
			  phenoData(x) <- phenoData(x)[j, ]
			  x@protocolData <- x@protocolData[j, ]
		  }
		  x@assayDataList <- adnew
		  return(x)
	  })

setReplaceMethod("[[", signature(x="BafLrrSetList", value="BafLrrSet"),
		 function(x, i, j, ..., value){
			 fdl <- x@featureDataList
			 fdl[[i]] <- featureData(value)
			 adl <- x@assayDataList
			 r <- adl[["lrr"]]
			 r[[i]] <- lrr(value)
			 b <- adl[["baf"]]
			 b[[i]] <- baf(value)
			 adl <- AssayDataList(lrr=r, baf=b)
			 new("BafLrrSetList",
			     assayDataList=adl,
			     featureDataList=fdl,
			     phenoData=phenoData(x),
			     chromosome=chromosome(x),
			     annotation=annotation(x),
			     genome=genomeBuild(x))
		 })


setReplaceMethod("assayData", signature=signature(object="BeadStudioSetList",
			      value="AssayData"),
                 function(object, value) {
			 object@assayDataList <- value
			 object
                 })


setMethod("baf", signature(object="oligoSetList"),
	  function(object) assayData(object)[["baf"]])
setMethod("baf", signature(object="BeadStudioSetList"),
	  function(object){
		  ##lapply(object, baf)
		  assayDataList(object)[["baf"]]
	  })

setMethod(baf, signature(object="BafLrrSetList"),
	  function(object){
            assayDataList(object)[["baf"]]
	  })

setMethod("calls", signature(object="oligoSetList"),
	  function(object) assayData(object)[["call"]])
setMethod("copyNumber", signature(object="oligoSetList"),
	  function(object) assayData(object)[["copyNumber"]])

setMethod("lrr", signature(object="BeadStudioSetList"),
	  function(object){
		  ##lapply(object, lrr)
		  assayDataList(object)[["lrr"]]
	  })

setMethod("lrr", signature(object="BafLrrSetList"),
	  function(object){
            ##lapply(object, lrr)
            assayDataList(object)[["lrr"]]
	  })


setReplaceMethod("lrr", signature(object="BafLrrSetList", value="matrix"),
	  function(object, value){
		  ## value can often be fewer columns than object
		  if(is.null(rownames(value))) stop("row.names is NULL")
		  if(is.null(colnames(value))) stop("col.names is NULL")
		  sample.index <- match(colnames(value), sampleNames(object))
		  for(j in seq_along(object)){
			  bset <- object[[j]]
			  k <- match(featureNames(bset), rownames(value))
			  lrr(bset)[, sample.index] <- value[k, , drop=FALSE]
			  object[[j]] <- bset
		  }
		  return(object)
	  })

##setMethod("ncol", signature(x="BeadStudioSetList"),
##	  function(x) ncol(assayDataList(x)[["lrr"]][[1]]))

setMethod("snpCallProbability", signature(object="oligoSetList"),
	  function(object) assayData(object)[["callProbability"]])


setMethod(clone2, "BafLrrSetList", function(object, id, prefix, ...){
	duplicateBLList(object, ids=id, prefix=prefix, ...)
})

duplicateBLList <- function(object, ids, prefix="waveAdj", empty=FALSE){
	##brList.copy <- object
	## duplicate the lrr ff objects.  Then do wave correction on the
	## duplicated files.
	if(missing(ids)) ids <- sampleNames(object)
	ids <- as.character(ids)
	r <- lrr(object)
	b <- baf(object)
	rcopy.list <- list()
	bcopy.list <- list()
	for(i in seq_along(r)){
		x <- r[[i]]
		y <- b[[i]]
		rcopy <- initializeBigMatrix(paste(prefix, "lrr", sep="-"), nrow(x), length(ids), vmode="integer")
		bcopy <- initializeBigMatrix(paste(prefix, "baf", sep="-"), nrow(x), length(ids), vmode="integer")
		dimnames(rcopy) <- list(rownames(x),
					ids)
		dimnames(bcopy) <- dimnames(rcopy)
		J <- match(ids, colnames(x))
		if(!empty){
			for(j in seq_along(J)){
				k <- J[j]
				rcopy[, j] <- x[, k]
				bcopy[, j] <- y[, k]
			}
		}
		rcopy.list[[i]] <- rcopy
		bcopy.list[[i]] <- bcopy
	}
	adl <- AssayDataList(baf=bcopy.list, lrr=rcopy.list)
	pd <- phenoData(object)[match(ids, sampleNames(object)), ]
	new("BafLrrSetList",
	    assayDataList=adl,
	    featureDataList=featureData(object),
	    phenoData=pd,
	    chromosome=chromosome(object),
	    annotation=annotation(object),
	    genome=genomeBuild(object))
}

setMethod("chromosome", signature(object="RangedSummarizedExperiment"),
	  function(object,...) as.character(seqnames(object)))
setMethod("isSnp", signature(object="RangedSummarizedExperiment"),
	  function(object,...) values(rowRanges(object))$isSnp)
setMethod("lrr", signature(object="RangedSummarizedExperiment"),
	  function(object){
		  assays(object)[[1]]
	  })
setMethod("baf", signature(object="RangedSummarizedExperiment"),
	  function(object){
		  assays(object)[[2]]
	  })

## Remove the methods below once the transition from SummarizedExperiment
## to RangedSummarizedExperiment is complete. [H. Pages - May 11, 2015]
setMethod("chromosome", signature(object="SummarizedExperiment"),
	  function(object,...) as.character(seqnames(object)))
setMethod("isSnp", signature(object="SummarizedExperiment"),
	  function(object,...) values(rowRanges(object))$isSnp)
setMethod("lrr", signature(object="SummarizedExperiment"),
	  function(object){
		  assays(object)[[1]]
	  })
setMethod("baf", signature(object="SummarizedExperiment"),
	  function(object){
		  assays(object)[[2]]
	  })

setMethod("chromosome", signature(object="AnnotatedDataFrame"),
	  function(object, na.rm=FALSE, ...){
		  chrom <- object$chromosome
		  if(!na.rm) return(chrom)
		  chrom[!is.na(chrom)]
	  })

setMethod("position", signature(object="AnnotatedDataFrame"),
	  function(object, na.rm=FALSE, ...) {
		  pos <- object$position
		  if(!na.rm){
			  return(pos)
		  }
		  pos[!is.na(pos)]
	})

##GRangesHMM <- function(seqnames = Rle(), ranges = IRanges(),
##		       strand = Rle("*", length(seqnames)),
##		       state=integer(),
##		       numberProbes=integer(),
##		       ...,
##		       seqlengths = # this default is more accurate than in newGRanges
##		       structure(rep(NA_integer_, length(unique(seqnames))),
##				 names = levels(as.factor(runValue(as(seqnames, "Rle")))))){
##	if(is.numeric(state)){
##		state <- Rle(factor(state))
##	} else {
##		if(!is(state, "Rle")) stop("state must be Rle or numeric")
##	}
##	if (missing(seqlengths)) # avoid potentially expensive seqnames conversion
##		GenomicRanges:::newGRanges("GRangesHMM", seqnames = seqnames, ranges = ranges, strand = strand,
##					   state=state,
##					   numberProbes=as.integer(numberProbes),
##					   ...)
##	else GenomicRanges:::newGRanges("GRangesHMM", seqnames = seqnames, ranges = ranges,
##					strand = strand,
##					state=state,
##					numberProbes=as.integer(numberProbes),
##					..., seqlengths = seqlengths)
##}
##setMethod("initialize", "GRangesHMM",
##	  function(.Object, numberProbes=integer(), state=Rle(), elementMetadata=DataFrame(state=state, numberProbes=numberProbes), ...){
##		  callNextMethod(.Object, elementMetadata=elementMetadata, ...)
##	  })
##setGeneric("as.GRangesHMM", function(x, seqlengths, ...) standardGeneric("as.GRangesHMM"))
##setAs("GRanges", "GRangesHMM",
##      function(from, to){
##	      state <- elementMetadata(from)$state
##	      numberProbes <- elementMetadata(from)$numberProbes
##	      gr <- GRangesHMM(paste("chr", chromosome(from), sep=""),
##			       IRanges(start(from), end(from)),
##			       state=state(from),
##			       numberProbes=coverage2(from))
##      })
##GRangesHMMList <- function(...)
##{
##    listData <- list(...)
##    if (length(listData) == 0L) {
##        unlistData <- GRangesHMM()
##    } else {
##        if (length(listData) == 1L && is.list(listData[[1L]]))
##            listData <- listData[[1L]]
##        if (!all(sapply(listData, is, "GRangesHMM")))
##            stop("all elements in '...' must be GRangeHMM objects")
##        unlistData <- suppressWarnings(do.call("c", unname(listData)))
##    }
##    end <- cumsum(elementNROWS(unname(listData)))
##    ans <- IRanges:::newCompressedList("GRangesHMMList",
##               unlistData,
##               end = end, NAMES = names(listData),
##               elementMetadata = new("DataFrame", nrows = length(listData)))
##    validObject(ans)
##    ans
##}

##---------------------------------------------------------------------------
##
## convenience functions for GRanges
##
##---------------------------------------------------------------------------
setMethod("chromosome", "GRanges", function(object) as.character(seqnames(object)))
setMethod("coverage2", "GRanges", function(object) elementMetadata(object)$numberProbes)
setMethod("numberProbes", "GRanges", function(object) elementMetadata(object)$numberProbes)
setMethod("sampleNames", "GRanges", function(object) as.character(elementMetadata(object)$sample))
setMethod("state", "GRanges", function(object) elementMetadata(object)$state)

##---------------------------------------------------------------------------
##
## convenience functions for GRangesList
##
##---------------------------------------------------------------------------
setMethod("chromosome", signature(object="GRangesList"), function(object) seqnames(object))
setMethod("coverage2", signature(object="GRangesList"), function(object) numberProbes(object))
setMethod("numberProbes", signature(object="GRangesList"), function(object){
	new2("CompressedRleList", unlistData=Rle(elementMetadata(object@unlistData)$numberProbes), partitioning=object@partitioning, check=FALSE)
})
setMethod("sampleNames", signature(object="GRangesList"), function(object) names(object))
setMethod("state", signature(object="GRangesList"), function(object){
	new2("CompressedRleList", unlistData=Rle(elementMetadata(object@unlistData)$state), partitioning=object@partitioning, check=FALSE)
})

## Adding toy examples
## Saving the script that creates the examples here
##   so we can improve later

NS <- 5
FS <- 9
rp <- 4
ids <- as.character(t(outer(1:FS, 1:rp, paste, sep=".")))
sns <- paste("sample", 1:NS, sep="")
fns <- paste("feature", ids, sep="")
set.seed(1)
tmpExprs <- matrix(as.integer(2^rnorm(NS*FS*rp, mean=12, sd=2)), nc=NS)
rownames(tmpExprs) <- fns
colnames(tmpExprs) <- sns

## ExpressionFeatureSet
efsExample <- new("ExpressionFeatureSet",
                  exprs=tmpExprs,
                  annotation="example")
save(efsExample, file="../../data/efsExample.rda")

## SnpFeatureSet
ids <- as.character(t(outer(1:FS, c("1-A", "2-A", "1-B", "2-B"), paste, sep=".")))
fns <- paste("SNP", ids, sep="")
rownames(tmpExprs) <- fns
sfsExample <- new("SnpFeatureSet",
                  exprs=tmpExprs,
                  annotation="example")
save(sfsExample, file="../../data/sfsExample.rda")

## SnpCnvFeatureSet

## TilingFeatureSet

## ExonFeatureSet

## GeneFeatureSet


## SnpQSet
set.seed(1)
NS <- 5
FS <- 9
ata <- matrix(rnorm(NS*FS, mean=12, sd=2), nc=NS)
atb <- matrix(rnorm(NS*FS, mean=12, sd=2), nc=NS)
sta <- matrix(rnorm(NS*FS, mean=12, sd=2), nc=NS)
stb <- matrix(rnorm(NS*FS, mean=12, sd=2), nc=NS)
rownames(ata) <- rownames(atb) <- rownames(sta) <- rownames(stb) <- paste("SNP", 1:FS, sep="")
colnames(ata) <- colnames(atb) <- colnames(sta) <- colnames(stb) <- paste("sample", 1:NS, sep="")
sqsExample <- new("SnpQSet",
                  antisenseThetaA=ata,
                  antisenseThetaB=atb,
                  senseThetaA=sta,
                  senseThetaB=stb,
                  annotation="example")
save(sqsExample, file="../../data/sqsExample.rda")

## SnpCnvQSet
scqsExample <- new("SnpCnvQSet",
                   thetaA=ata,
                   thetaB=atb,
                   annotation="example")
save(scqsExample, file="../../data/scqsExample.rda")

setMethod("show", "DBPDInfo", function(object) {
    cat("Class........:", class(object), "\n")
    cat("Manufacturer.:", manufacturer(object), "\n")
    cat("Genome Build.:", genomeBuild(object), "\n")
    cat("Chip Geometry:", geometry(object)[1], "rows x ", geometry(object)[2], "columns\n")
})

setMethod("show", "FeatureSet", function(object){
  callNextMethod()
  requireAnnotation(annotation(object))
})

setMethod("annotation", "DBPDInfo",
          function(object) object@annotation)

setMethod("initialize", "DBPDInfo",
          function(.Object, ...) {
            .Object <- callNextMethod()
            tInfo <- dbGetQuery(db(.Object), "select * from table_info")
            .Object@tableInfo <- tInfo
            .Object
          })

setMethod("manufacturer", "DBPDInfo",
          function(object) object@manufacturer)

setMethod("genomeBuild", "DBPDInfo",
          function(object) object@genomebuild)

setMethod("geometry", "DBPDInfo",
          function(object) object@geometry)

setMethod("db", signature(object="DBPDInfo"),
          function(object) object@getdb())

setMethod("kind", "GenericPDInfo",
          function(object){
              "generic"
          })

setMethod("kind", "AffySNPPDInfo",
          function(object) {
            "SNP"
          })
  
setMethod("kind", "AffyExpressionPDInfo",
          function(object) {
              "expression"
          })

setMethod("kind", "AffySNPCNVPDInfo",
          function(object) {
              "SNPCNV"
          })
 
setMethod("kind", "AffyGenePDInfo",
          function(object) {
              "gene"
          })

setMethod("kind", "AffyExonPDInfo",
          function(object) {
            "exon"
          })

setMethod("kind", "AffyHTAPDInfo",
          function(object) {
            "hta"
          })

setMethod("kind", "ExpressionPDInfo",
          function(object) {
            "expression"
          })

setMethod("kind", "TilingPDInfo",
          function(object) {
            "tiling"
          })

## utilities for Large Dataset Support
##
## Summary:
##   - is.ffmatrix: test specifically for ff_matrix
##   - ldStatus: TRUE if Large Dataset Support is available
##   - ldPath: where to save ff files
##   - createFF: creates an ff object setting path appropriately
##               (leaving out of fftempdir b/c parallel processes
##               access the object very easily)


initializeBigArray <- function(name=basename(tempfile()), dim=c(0L,0L,0L), vmode="integer", initdata=NA){
	if(isPackageLoaded("ff")){
		results <- createFF(name=name,
				    dim=dim,
				    vmode=vmode, initdata=initdata)
	} else {
		init <- switch(vmode,
			       integer=as.integer(initdata),
			       double=as.double(initdata),
			       character=as.character(initdata),
			       stop("Mode ", vmode, " not implemented for regular matrices"))
		results <- array(init, dim=dim)
	}
	return(results)
}


initializeBigMatrix <- function(name=basename(tempfile()), nr=0L, nc=0L, vmode="integer", initdata=NA){
  if(isPackageLoaded("ff") & (nr > 0 | nc > 0)){
    if(prod(nr, nc) > 2^31){
      ##Need multiple matrices
      ## -- use ffdf
      ## How many samples per ff object
      S <- floor(2^31/nr - 1)
      ## How many ff objects
      L <- ceiling(nc/S)
      name <- paste(name, 1:L, sep="_")
      resultsff <- vector("list", L)
      for(i in 1:(L-1)){  ## the Lth object may have fewer than nc columns
        resultsff[[i]] <- createFF(name=name[i],
                                   dim=c(nr, S),
                                   vmode=vmode, initdata=initdata)
      }
      ##the Lth element
      leftOver <- nc - ((L-1)*S)
      resultsff[[L]] <- createFF(name=name[L],
                                 dim=c(nr, leftOver),
                                 vmode=vmode, initdata=initdata)
      results <- do.call(ffdf, resultsff)
      rm(resultsff); gc()
    } else {
      results <- createFF(name=name,
                          dim=c(nr, nc),
                          vmode=vmode, initdata=initdata)
    }
   }  else {
    init <- switch(vmode,
                   integer=as.integer(initdata),
                   double=as.double(initdata),
                   character=as.character(initdata),
                   stop("Mode ", vmode, " not implemented for regular matrices"))
    results <- matrix(init, nr, nc)
}
  return(results)
}

initializeBigVector <- function(name=basename(tempfile()), n=0L, vmode="integer", initdata=NA){
  if(isPackageLoaded("ff")){
    results <- ff(initdata=initdata, vmode=vmode, length=n,
                  pattern=file.path(ldPath(), basename(name)))
  }  else {
    init <- switch(vmode,
                   integer=as.integer(initdata),
                    double=as.double(initdata),
                    character=as.character(initdata),
                    stop("Mode ", vmode, " not implemented for regular matrices"))
    results <- rep(init, n)
  }
  return(results)
}



createFF <- function(name, dim, vmode="double", initdata=NULL)
	ff(initdata=initdata, vmode=vmode, dim=dim, pattern=file.path(ldPath(), basename(name)))

## TODO: really safe to use :::?
setMethod("annotatedDataFrameFrom", "ff_matrix",
          Biobase:::annotatedDataFrameFromMatrix)

is.ffmatrix <- function(object)
  is(object, "ff_matrix")

isFF <- function(object){
	names <- ls(assayData(object))
	is(assayData(object)[[names[[1]]]], "ff") | is(assayData(object)[[names[[1]]]], "ffdf")
}

ldPath <- function(path){
  if (missing(path)){
    return(getOption("ldPath"))
  }else{
	  if(!is.character(path)) stop("path is not a character string")
##    stopifnot(is.character(path))
    options(ldPath=path)
  }
}

ldSetOptions <- function(nsamples=100, nprobesets=20000,
                         path=getwd(), verbose=FALSE){
  ocProbesets(nprobesets)
  ocSamples(nsamples)
  ldPath(path)
  ldStatus(verbose)
  TRUE
}

ldStatus <- function(verbose=FALSE){
  ld <- isPackageLoaded("ff")
  if (verbose){
    message(getBar())
    message("Large dataset support for 'oligo/crlmm': ", appendLF=FALSE)
    if (ld){
      message("Enabled")
      ns <- prettyNum(c(ocProbesets(), ocSamples()), big.mark=",")
      message("    - Probesets: ", ns[1])
      message("    - Samples..: ", ns[2])
      message("    - Path.....: ", ldPath())
    }else{
      message("Disabled")
      message("     - Load 'ff'")
    }
    message(getBar())
  }
  return(ld)
}

## does nothing if not an ff object
setMethod("open", "numeric", function(con, ...) return(NULL))
setMethod("open", "matrix", function(con, ...) return(NULL))
setMethod("open", "array", function(con, ...) return(NULL))
setMethod("close", "numeric", function(con, ...) return(NULL))
setMethod("close", "matrix", function(con, ...) return(NULL))
setMethod("close", "array", function(con, ...) return(NULL))

setMethod("show", "CNSet", function(object){
	is.ff <- is(calls(object), "ff_matrix") | is(calls(object), "ffdf")
	if(is.ff){
		if(!isPackageLoaded("ff")) warning("ff objects detected, but ff package is not loaded")
		##to avoid warnings
		if("SKW" %in% varLabels(object)) {
			if(is(object$SKW, "ff"))
				open(object$SKW)
		}
		if("SNR" %in% varLabels(object)){
			if(is(object$SNR, "ff"))
				open(object$SNR)
		}
		if("gender" %in% varLabels(object)){
			if(is(object$gender, "ff"))
				open(object$gender)
		}
	}
	ad.class <- class(A(object))[1]
	cat("CNSet (assayData/batchStatistics elements: ", ad.class, ")\n", sep="")
	callNextMethod(object)
	bns <- head(batchNames(object))
	##bns <- bns[-length(bns)]
	freq <- as.integer(table(batch(object)))
	index <- names(table(batch(object))) %in% bns
	freq <- freq[index]
	cat("batch:   ", paste(bns, ":", freq, sep="", collapse=", "), "\n")
	adim <- list(nrow(object), length(batchNames(object)))
	if(adim[[1]] > 0){
		cat("batchStatistics: ", length(ls(batchStatistics(object))), " elements, ", nrow(object), " features, ", length(unique(batch(object))), " batches\n")
	}
})

setMethod("updateObject", signature(object="CNSet"),
          function(object, ..., verbose=FALSE) {
		  if (verbose) message("updateObject(object = 'CNSet')")
		  obj <- tryCatch(callNextMethod(batch=batch(object)), error=function(e) NULL)
		  if(is.null(obj)){
			  ## must supply batch for batchStatistics to be added
			  if(is(calls(object), "ffdf") | is(calls(object), "ff_matrix"))
				  stopifnot(isPackageLoaded("ff"))
			  if(.hasSlot(object, "mixtureParams")){
				  obj <- new("CNSet",
					     assayData = updateObject(assayData(object),
					     ..., verbose=verbose),
					     phenoData = phenoData(object),
					     experimentData = experimentData(object),
					     annotation = updateObject(annotation(object),
					     ..., verbose=verbose),
					     featureData=updateObject(featureData(object), ..., verbose=verbose),
					     batch=as.character(batch(object)),
					     batchStatistics=batchStatistics(object),
					     mixtureParams=object@mixtureParams)
			  } else {
				  obj <- new("CNSet",
					     assayData = updateObject(assayData(object),
					     ..., verbose=verbose),
					     phenoData = phenoData(object),
					     experimentData = experimentData(object),
					     annotation = updateObject(annotation(object),
					     ..., verbose=verbose),
					     featureData=updateObject(featureData(object), ..., verbose=verbose),
					     batch=as.character(batch(object)),
					     batchStatistics=batchStatistics(object),
					     mixtureParams=matrix(NA, 4, ncol(object)))
			  }
			  if (isCurrent(obj)["CNSet"]) return(obj)
			  return(obj)
		  }
          })

setMethod("[", "CNSet", function(x, i, j, ..., drop=FALSE){
  openff(x)
  x <- callNextMethod(x, i, j, ..., drop=FALSE)
  isdf <- is(A(x), "data.frame")
  if(isdf){
    orig <- assayData(x)
    ##storage.mode <- Biobase:::assayDataStorageMode(orig)
    storage.mode <- storageMode(orig)
    assayData(x) <-
      switch(storage.mode,
             environment =,
             lockedEnvironment = {
               aData <- new.env(parent=emptyenv())
               for(nm in ls(orig)) aData[[nm]] <- as.matrix(orig[[nm]])##[i, j, ..., drop = drop]
               if ("lockedEnvironment" == storage.mode) Biobase:::assayDataEnvLock(aData)
               aData
             },
             list = {
               lapply(orig, as.matrix)
             })
  }
  if(missing(j)) j <- 1:ncol(x)
  if(missing(i)) i <- 1:nrow(x)
  x@batch <- batch(x)[j]
  nms <- sampleNames(batchStatistics(x))
  ## need to subset columns of LinearModelParameter
  ## Adapted from the '[' method for eSet in Biobase
  ## redefine 'j'
  j <- which(nms %in% unique(as.character(batch(x))))
  storage.mode <- storageMode(batchStatistics(x))
  ## i (if defined) is already subset by callNextMethod
  orig <- batchStatistics(x)
  batchStatistics(x) <-
    switch(storage.mode,
           environment =,
           lockedEnvironment = {
             aData <- new.env(parent=emptyenv())
             for(nm in ls(orig)) aData[[nm]] <- orig[[nm]][i, j, ..., drop = drop]
             if ("lockedEnvironment" == storage.mode) Biobase:::assayDataEnvLock(aData)
             aData
           },
           list = {
             lapply(orig, function(obj) obj[i, j, ..., drop = drop])
           })
  return(x)
})

setMethod("batch", "CNSet", function(object) object@batch)

setReplaceMethod("batch", signature=signature(object="CNSet"),
	 function(object, value){
		 object@batch <- as.character(value)
		 object
})


setMethod("batchNames", "CNSet", function(object)  batchNames(batchStatistics(object)))

setReplaceMethod("batchNames", "CNSet", function(object, value) {
	batchNames(batchStatistics(object)) <- value
	return(object)
})

setMethod("allele", "CNSet",
          function(object, allele){
            stopifnot(!missing(allele))
            allele <- match.arg(allele, c("A", "B"))
	    what <- paste("allele", allele, sep="")
            assayDataElement(object, what)
          })

setMethod("A", "CNSet", function(object, ...) allele(object, "A", ...))

setMethod("B", "CNSet", function(object, ...) allele(object, "B", ...))

setReplaceMethod("A", "CNSet", function(object, value) {
	obj <- assayDataElementReplace(object, "alleleA", value)
})

setReplaceMethod("B", "CNSet", function(object, value) {
	assayDataElementReplace(object, "alleleB", value)
})

setMethod("closeff",
	  signature(object="CNSet"), function(object){
	if(!isFF(object)) return()
	names <- ls(assayData(object))
	L <- length(names)
	for(i in 1:L) close(eval(substitute(assayData(object)[[NAME]], list(NAME=names[i]))))
	physical <- get("physical")
	names <- ls(batchStatistics(object))
	L <- length(names)
	for(i in 1:L) {
		tmp <- eval(substitute(assayData(object)[[NAME]], list(NAME=names[i])))
		if(!is.null(tmp)) close(tmp)
	}
})

setMethod("close", "CNSet", function(con, ...){
	object <- con
	closeff(object)
})

setMethod("openff", signature(object="CNSet"),
	  function(object){
		  if(isFF(object)){
			  names <- ls(assayData(object))
			  L <- length(names)
			  for(i in 1:L) open(eval(substitute(assayData(object)[[NAME]], list(NAME=names[i]))))
			  names <- assayDataElementNames(batchStatistics(object))
			  L <- length(names)
			  for(i in 1:L) open(eval(substitute(batchStatistics(object)[[NAME]], list(NAME=names[i]))))
		  }
		  if("SKW" %in% varLabels(object)){
			  if(is(object$SKW, "ff")) open(object$SKW)
		  }
		  if("SNR" %in% varLabels(object)){
			  if(is(object$SNR, "ff")) open(object$SNR)
		  }
		  if("SNR" %in% varLabels(object)){
			  if(is(object$gender, "ff")) open(object$gender)
		  }
	  })

setMethod("open", "CNSet", function(con, ...){
	object <- con
	openff(object)
	return(TRUE)
})

setMethod("nu", c("CNSet", "character"), function(object, allele) nu(batchStatistics(object), allele))
setMethod("phi", c("CNSet", "character"), function(object, allele) phi(batchStatistics(object), allele))
setMethod("sigma2", c("CNSet", "character"), function(object, allele) sigma2(batchStatistics(object), allele))
setMethod("flags", signature(object="CNSet"), function(object) flags(batchStatistics(object)))

setMethod("batchStatistics", signature=signature(object="CNSet"), function(object) object@batchStatistics)
setReplaceMethod("batchStatistics", signature=signature(object="CNSet", value="AssayData"),
	 function(object, value){
		 object@batchStatistics <- value
		 object
	 })


setMethod(snpCall, "CNSet", function(object, ...) {
	assayDataElement(object, "call")
})

setMethod(snpCallProbability, "CNSet", function(object, ...) {
	assayDataElement(object, "callProbability")
})

setReplaceMethod("snpCall", c("CNSet", "matrix"),
                 function(object, ..., value)
	 {
		 assayDataElementReplace(object, "call", value)
	 })

setReplaceMethod("snpCallProbability", c("CNSet", "matrix"),
                 function(object, ..., value)
{
	assayDataElementReplace(object, "callProbability", value)
})

setMethod("calls", "CNSet", function(object) assayData(object)$call)
setReplaceMethod("calls", signature(object="CNSet", value="matrix"),
                 function(object, value)
                 assayDataElementReplace(object, "call", value))

setMethod("confs", "CNSet", function(object, transform=TRUE) {
	X <- snpCallProbability(object)
	if(is(X, "ff_matrix") | is(X, "ffdf")){
		warningMsg(X)
		return(X)
	}
	if (transform){
		X <- i2p(X)
	}
	return(X)
})

setReplaceMethod("confs", signature(object="CNSet", value="matrix"),
		 function(object, value){
			 ##convert probability to integer
			 if(max(value) > 1){
				 X <- matrix(p2i(value), nrow(X), ncol(X),
					     dimnames=dimnames(value))
			 } else {
				 X <- value
			 }
			 assayDataElementReplace(object, "callProbability", X)
		 })

##setMethod("genomeBuild", "CNSet", function(object) object@genome)
##setReplaceMethod("genomeBuild", signature(object="CNSet", value="character"),
##		 function(object, value){
##			 object@genome <- value
##			 return(object)
##		 })

setMethod("initialize", signature(.Object="GenomeAnnotatedDataFrame"),
	  function(.Object,
		   position=integer(),
		   isSnp=vector("logical", length(position)),
		   chromosome=vector("integer", length(position)),
		   row.names=NULL,
		   data,
		   varMetadata,
		   ...){
		  if(missing(data))
			  data <- data.frame(isSnp=isSnp, position=position, chromosome=chromosome, ..., row.names=row.names)
		  if(missing(varMetadata)){
			  nms <- names(list(...))
			  varMetadata <- data.frame(labelDescription=c("SNP indicator", "physical position", "chromosome", nms))
		  }
		  .Object <- callNextMethod(.Object, data=data, varMetadata=varMetadata)
	  })

setMethod("updateObject", signature(object="GenomeAnnotatedDataFrame"),
	  function(object, ..., verbose=FALSE){
		  ##as(object, "GenomeAnnotatedDataFrame")
		  ADF2GDF(object)
	 })

setMethod("coerce", signature(from="AnnotatedDataFrame", to="GenomeAnnotatedDataFrame"),
	  function(from, to){
		  new("GenomeAnnotatedDataFrame",
		      isSnp=as.logical(from$isSnp),
		      position=as.integer(from$position),
		      chromosome=as.integer(from$chromosome),
		      row.names=featureNames(from))
	  })

ADF2GDF <- function(object){
	new("GenomeAnnotatedDataFrame",
	    isSnp=as.logical(object$isSnp),
	    position=as.integer(object$position),
	    chromosome=as.integer(object$chromosome),
	    row.names=featureNames(object))
}


isValidGenomeAnnotatedDataFrame <- function(object){
		    if(!all(c("isSnp", "position", "chromosome") %in% varLabels(object)))
			    return("'isSnp', 'position', and 'chromosome' are required varLabels of the AnnotatedDataFrame for features")
		    if(!is(chromosome(object), "integer") || !is(position(object), "integer"))
			    return("chromosome and position must be integers. See function 'chromosome2integer'")
		    if(!is.logical(isSnp(object))){
			    return("isSnp must be logical")
		    }
		    TRUE
}

setValidity("GenomeAnnotatedDataFrame",
	    function(object){
		    msg <- isValidGenomeAnnotatedDataFrame(object)
		    if(is.character(msg)) return(msg)
	    })

setMethod("GenomeAnnotatedDataFrameFrom",
	  signature(object="ff_or_matrix"),
	  function(object, annotationPkg, genome="hg19", ...){
		  GenomeAnnotatedDataFrameFromMatrix(object=object, annotationPkg=annotationPkg, genome=genome, ...)
})

setMethod("GenomeAnnotatedDataFrameFrom", signature(object="array"),
	  function(object, annotationPkg, genome="hg19", ...){
		  GenomeAnnotatedDataFrameFromArray(object, annotationPkg, genome=genome,  ...)
	  })

setMethod("GenomeAnnotatedDataFrameFrom",
	  signature(object="NULL"),
	  function(object, annotationPkg, genome="hg19", ...){
		  GenomeAnnotatedDataFrameFromNULL(object)
})

setMethod("GenomeAnnotatedDataFrameFrom",
	  signature(object="list"),
	  function(object, annotationPkg, genome="hg19", ...){
		  GenomeAnnotatedDataFrameFromList(object, annotationPkg, genome=genome, ...)
	  })

setMethod("GenomeAnnotatedDataFrameFrom",
	  signature(object="AssayData"),
	  function(object, annotationPkg, genome="hg19", ...){
		  GenomeAnnotatedDataFrameFromAssayData(object=object, annotationPkg=annotationPkg, genome=genome, ...)
})

GenomeAnnotatedDataFrameFromMatrix <- function(object,
					       annotationPkg,
					       genome,
					       ...){
  dims <- dim(object)
  if (is.null(dims) || all(dims==0)){
    object <- GenomeAnnotatedDataFrameFrom(NULL, ...)
  } else {
    nms <- rownames(object)
    if(!is.null(nms)){
      if(any(is.na(nms))) warning("NA's in rownames")
    }
    if(length(annotationPkg)==0 | is.null(nms)){
      n <- dims[1]
      data <- data.frame(position=integer(n),
                         chromosome=integer(n),
                         isSnp=logical(n),
                         row.names=nms)
      object <- new("GenomeAnnotatedDataFrame", data=data)
    } else {
      stopifnot(isSupportedAnnotation(annotationPkg))
      is.pd <- isPdAnnotationPkg(annotationPkg)
      if(is.pd){
        object <- addFeatureAnnotation.pd2(annotationPkg, featureNames=rownames(object), genome=genome,...)
      } else {
        object <- addFeatureAnnotation.crlmm2(annotationPkg, featureNames=rownames(object), genome=genome, ...)
      }
    }
  }
  return(object)
}



GenomeAnnotatedDataFrameFromArray <- function(object, annotationPkg, ...){
  ## coerce to matrix
  dims <- dim(object)
  is.array <- length(dims) == 3
  if(is.array){
    res <- GenomeAnnotatedDataFrameFromMatrix(object[, , 1], annotationPkg, ...)
  } else {
    ##dim(object) <- dim(object)[c(1,2)]
    res <- GenomeAnnotatedDataFrameFromMatrix(object, annotationPkg, ...)
  }
  res
}

GenomeAnnotatedDataFrameFromList <- function(object, annotationPkg, genome){
	##if(length(object)==0) return(GenomeAnnotatedDataFrameFromNULL(NULL))
	if(length(object)==0) return(object)
	nms <- ls(object)
	elt <- object[[nms[1]]]
	fdlist <- vector("list", length(elt))
	for(i in seq_along(elt)){
		fdlist[[i]] <- GenomeAnnotatedDataFrameFrom(elt[[i]], annotationPkg, genome)
	}
	return(fdlist)
}

GenomeAnnotatedDataFrameFromNULL <- function(object, byrow=TRUE, ...) {
	new("GenomeAnnotatedDataFrame")
}

GenomeAnnotatedDataFrameFromAssayData <- function(object, annotationPkg, ...) {
    eltNames <-
        if (is(object, "environment")) ls(object)
        else names(object)
    if (length(eltNames)==0)
	    GenomeAnnotatedDataFrameFrom(NULL)
    else
        GenomeAnnotatedDataFrameFrom(object[[eltNames[1]]], annotationPkg, ...)
}



setMethod("isSnp", signature(object="GenomeAnnotatedDataFrame"),
	  function(object) object$isSnp)
setMethod("position", signature(object="GenomeAnnotatedDataFrame"),
	  function(object, ...) object$position)
setMethod("chromosome", signature(object="GenomeAnnotatedDataFrame"),
	  function(object, ...) object$chromosome)
setReplaceMethod("chromosome", signature(object="GenomeAnnotatedDataFrame",
					 value="integer"),
		 function(object, value){
			 fData(object)$chromosome <-  value
			 object
		 })
setReplaceMethod("isSnp", signature(object="GenomeAnnotatedDataFrame",
				    value="logical"),
		 function(object, value){
			 Biobase::fData(object)$isSnp <-  value
			 object
		 })
setReplaceMethod("position", signature(object="GenomeAnnotatedDataFrame",
				       value="integer"),
		 function(object, value){
			 Biobase::fData(object)$position <-  value
			 object
		 })

isPdAnnotationPkg <- function(object) length(grep("pd.", object)) >= 1

addFeatureAnnotation.pd2 <- function(annotation, featureNames, genome){
	##message("Adding required feature annotation (chromosome, position, isSnp) to featureData slot")
	fs <- featureNames
	tmp <- paste("('", paste(fs, collapse="', '"), "')", sep="")
	fD <- matrix(integer(), length(fs), 3)
	rownames(fD) <- fs
	colnames(fD) <- c("chromosome", "position", "isSnp")
	sql <- paste("SELECT man_fsetid, chrom, physical_pos FROM featureSet WHERE man_fsetid IN ", tmp)
	##Check if two objects have been combined
	pkgs <- strsplit(annotation, ",")[[1]]
	snps <- snp.index <- nps <- np.index <- vector("list", length(pkgs))
	for(i in seq(along=pkgs)){
		annotation <- pkgs[i]
		requireAnnotation(annotation)
		annoObject <- get(annotation)
		gb <- tolower(genomeBuild(annoObject))
		if(gb != genome){
			stop(paste("Genome build in package ",
				   annotation, " is ", gb, ", but build ",
				   genome, " is requested.", sep=""))
		}
                snps[[i]] <- dbGetQuery(annoObject@getdb(), sql)
		snp.index[[i]] <- match(snps[[i]]$man_fsetid, rownames(fD))
		if("featureSetCNV" %in% dbListTables(annoObject@getdb())){
			sql <- paste("SELECT man_fsetid, chrom, chrom_start FROM featureSetCNV WHERE man_fsetid IN ", tmp)
			nps[[i]] <- dbGetQuery(annoObject@getdb(), sql)
			np.index[[i]] <- match(nps[[i]]$man_fsetid, rownames(fD))
		}
	}
	if(length(snps) > 1){
		snps <- do.call(rbind, snps)
		snp.index <- unlist(snp.index)
		if("featureSetCNV" %in% dbListTables(annoObject@getdb())){
			nps <- do.call(rbind, nps)
			np.index <- unlist(np.index)
		}
	} else {
		snps <- snps[[1]]
		snp.index <- snp.index[[1]]
		if("featureSetCNV" %in% dbListTables(annoObject@getdb())){
			nps <- nps[[1]]
			np.index <- np.index[[1]]
		}
	}
	fD[snp.index, "isSnp"] <- as.integer(1)
	fD[snp.index, "chromosome"] <- chromosome2integer(snps$chrom)
	fD[snp.index, "position"] <- as.integer(snps$physical_pos)
	if("featureSetCNV" %in% dbListTables(annoObject@getdb())){
		fD[np.index, "isSnp"] <- as.integer(0)
		fD[np.index, "chromosome"] <- chromosome2integer(nps$chrom)
		fD[np.index, "position"] <- as.integer(nps$chrom_start)
	}
	featureData <- new("GenomeAnnotatedDataFrame",
			   isSnp=as.logical(fD[, "isSnp"]),
			   chromosome=as.integer(fD[, "chromosome"]),
			   position=as.integer(fD[, "position"]),
			   row.names=featureNames)
	return(featureData)
}




addFeatureAnnotation.crlmm2 <- function(object, featureNames, genome="hg19", ...){
  nm <- grep("Crlmm", object, ignore.case=TRUE)
  if(length(nm) == 0){
    pkgname <- paste(object, "Crlmm", sep="")
  } else pkgname <- object
  path <- system.file("extdata", package=pkgname)
  if(path=="") stop("Are you sure ", pkgname, " is installed?")
  ## Most of our annotation packages have only hg19 build
  snpBuilds <- list.files(path, pattern="snpProbes_")
  build <- gsub(".rda", "", gsub("snpProbes_", "", snpBuilds))
  if(length(build) > 1){
    if(genome %in% build){
      build <- genome
    } else 	{ ## genome not in build
      message(paste("Builds", paste(build, collapse=","), "are available. Use genome=[build] to specify which build to use for annotation."))
      build <- build[1]
    }
  }
  if(length(build)==1){
    if(build != genome){
      message(paste("Build", genome, "requested, but only build", build, "is available."))
    }
    loader(paste("cnProbes_", build, ".rda", sep=""), pkgname=pkgname, envir=.oligoClassesPkgEnv)
    loader(paste("snpProbes_", build, ".rda", sep=""), pkgname=pkgname, envir=.oligoClassesPkgEnv)
  } else { ## length of build is zero
    ## file not found (older version of annotation packages).  allow processing to continue
    loader("cnProbes.rda", pkgname=pkgname, envir=.oligoClassesPkgEnv)
    loader("snpProbes.rda", pkgname=pkgname, envir=.oligoClassesPkgEnv)
  }
  cnProbes <- get("cnProbes", envir=.oligoClassesPkgEnv)
  snpProbes <- get("snpProbes", envir=.oligoClassesPkgEnv)
  snpProbes <- snpProbes[rownames(snpProbes) %in% featureNames, , drop=FALSE]
  cnProbes <- cnProbes[rownames(cnProbes) %in% featureNames, , drop=FALSE]
  ##Feature Data
  isSnp <- 1L-as.integer(featureNames %in% rownames(cnProbes))
  names(isSnp) <- featureNames
  if(any(isSnp)){
    snps <- featureNames[isSnp == 1]
    index <- match(snps, rownames(snpProbes))
    position.snp <- snpProbes[index, "position"]
    names(position.snp) <- snps
    J <- grep("chr", colnames(snpProbes))
    chr.snp <- snpProbes[index, J]
  } else{
    warning("None of the featureNames in the object match SNP probes for the indicated annotation package.  Either the annotation package is misspecified, or the featureNames of the object are incorrect")
    message("The annotation for the object is ", object)
    chr.snp <- position.snp <- integer()
  }
  if(any(!isSnp)){
    nps <- featureNames[isSnp == 0]
    index <- match(nps, rownames(cnProbes))
    position.np <- cnProbes[index, "position"]
    names(position.np) <- nps
    chr.np <- cnProbes[index, J]
  } else {
    chr.np <- position.np <- integer()
  }
  position <- c(position.snp, position.np)
  chrom <- c(chr.snp, chr.np)
  ##We may not have annotation for all of the snps
  if(!all(featureNames %in% names(position))){
    warning("physical position not available for all featureNames")
  }
  ix <- match(featureNames, names(position))
  position <- position[ix]
  chrom <- chrom[ix]
  ##require(SNPchip)
  chrom <- chromosome2integer(chrom)
  stopifnot(identical(names(position), featureNames))
  if(sum(duplicated(names(position))) > 0){
    warning("Removing rows with NA identifiers...")
    ##RS: fix this
    I <- which(!is.na(names(position)))
  }  else I <- seq(along=names(position))
  new("GenomeAnnotatedDataFrame",
      isSnp=as.logical(isSnp[I]),
      position=as.integer(position[I]),
      chromosome=as.integer(chrom[I]),
      row.names=featureNames)
}

cleancdfname <- function(x) strsplit(x, "Crlmm")[[1]][[1]]

isSupportedAnnotation <- function(x){
	validAnn <- annotationPackages()
	validAnn <- validAnn[-grep(",", validAnn)]
	stripCrlmm <- sapply(validAnn, cleancdfname)
	validAnn <- unique(c(validAnn, stripCrlmm))
	x <- strsplit(x, ",")[[1]]
	for(i in seq_along(x)) match.arg(x[i], validAnn)
	return(TRUE)
}

annotationPackages <- function(){
	c("pd.mapping50k.hind240", "pd.mapping50k.xba240",
	  "pd.mapping50k.hind240,pd.mapping50k.xba240",
	  "pd.mapping250k.nsp",
	  "pd.mapping250k.sty",
	  "pd.mapping250k.nsp,pd.mapping250k.sty",
	  "pd.genomewidesnp.5",
	  "pd.genomewidesnp.6",
	  "genomewidesnp6Crlmm",
	  "genomewidesnp5Crlmm",
	  "human370v1cCrlmm",
	  "human370quadv3cCrlmm",
	  "human550v3bCrlmm",
	  "human650v3aCrlmm",
	  "human610quadv1bCrlmm",
	  "human660quadv1aCrlmm",
	  "human1mduov3bCrlmm",
	  "humanomni1quadv1bCrlmm")
}

affyPlatforms <- function(){
  platforms <- c("pd.mapping50k.xba240",
                 "pd.mapping50k.hind240",
                 "pd.mapping250k.nsp",
                 "pd.mapping250k.sty",
                 "pd.genomewidesnp.5",
                 "pd.genomewidesnp.6")
  combined <- rep(NA, 2)
  combined[1] <- paste(sort(platforms[1:2]), collapse=",")
  combined[2] <- paste(sort(platforms[3:4]), collapse=",")
  platforms <- c(platforms, combined)
  platforms
}


checkAnnotation <- function(x){
	if(length(x) == 0) return(FALSE)
	x <- strsplit(x, ",")[[1]]
	if(length(x) == 1){
		istrue <- isSupportedAnnotation(x)
	} else {
		istrue <- sapply(x, isSupportedAnnotation)
		istrue <- all(istrue)
	}
	return(istrue)
}

setReplaceMethod("position", signature(object="oligoSnpSet", value="integer"),
		 function(object, value){
			 position(featureData(object)) <- value
			 object
		 })

setReplaceMethod("position", signature(object="GenomeAnnotatedDataFrame", value="integer"),
		 function(object, value){
			 object$position <- value
			 object
		 })

setMethod("makeFeatureGRanges", signature(object="GenomeAnnotatedDataFrame"),
	  function(object, genome, ...){
		  chr.names <- c(paste("chr", 1:22, sep=""), "chrX", "chrY")
		  sl <- getSequenceLengths(genome)
		  sl <- sl[chr.names]
		  chrom <- paste("chr", integer2chromosome(chromosome(object)), sep="")
		  if(!all(chrom %in% chr.names)) stop("chromosomes must be chr1, ... chr22, chrX, or chrY")
		  gr <- GRanges(chrom,
				IRanges(position(object), width=1),
				seqlengths=sl)
		  names(gr) <- sampleNames(object)
		  metadata(gr) <- list(genome=genome)
		  return(gr)
	  })

setMethod("getArm", signature(object="GenomeAnnotatedDataFrame"), function(object, genome){
	genome <- match.arg(genome, c("hg18","hg19"))
	.getArm(chromosome(object), position(object), genome)
})

setMethod("bothStrands", "SnpFeatureSet",
          function(object){
            pkg <- annotation(object)
            set1 <- c("pd.mapping50k.xba240",
                      "pd.mapping50k.hind240",
                      "pd.mapping250k.sty",
                      "pd.mapping250k.nsp")
            set2 <- c("pd.genomewidesnp.5",
                      "pd.genomewidesnp.6")
            if (pkg %in% set1){
              return(TRUE)
            }else if (pkg %in% set2){
              return(FALSE)
            }else{
              return(NA)
            }
          })

setMethod("allele", "SnpFeatureSet",
          function(object, allele, strand){
              allele <- match.arg(allele, c("A", "B"))
              axiom <- length(grep("axiom", annotation(object))) == 1

              ## remember: select different than value below (works also
              ## on axiom)
              ac <- switch(allele, A=1, B=0)
              cc <- switch(allele, A='channel2', B='channel1')
              ccc <- setdiff(c('channel1', 'channel2'), cc)
              if (axiom){
                  sql <- paste('SELECT man_fsetid, fsetid, fid, allele, allelea, alleleb, count',
                               'FROM pmfeature',
                               'INNER JOIN featureSet USING(fsetid)',
                               'WHERE allele != ', ac)
                  tmp <- dbGetQuery(db(object), sql)
                  tmp <- tmp[order(tmp[['count']], tmp[['fsetid']], tmp[['fid']]),]
                  rownames(tmp) <- NULL

                  ## easy SNPs: [A/C] [A/G] [T/C] [T/G]
                  ##   alleleA: fid channel1
                  ##   alleleB: fid channel2
                  ## hard grn.: [A/T]
                  ##   alleleA: fid channel1
                  ##   alleleB: fid channel1 (probe2)
                  ## hard cyan: [C/G]
                  ##   alleleA: fid channel2
                  ##   alleleB: fid channel2 (probe2)
                  ## indel grn: [-/A] [-/T]
                  ##   need Angela
                  ##   alleleA: fid channel1
                  ##   alleleB: fid channel2
                  ## indel cyn: [-/C] [-/G]
                  ##   need Angela
                  ##   alleleA: fid channel2
                  ##   alleleB: fid channel1

                  easy <- c("AC", "AG", "TC", "TG")
                  hgrn <- "AT"
                  hcyn <- "CG"
                  indelg <- c("-A", "-T")
                  indelc <- c("-C", "-G")
                  types <- paste(tmp[['allelea']], tmp[['alleleb']], sep='')
                  i1 <- which(types %in% easy)
                  i2 <- which(types %in% hgrn)
                  i3 <- which(types %in% hcyn)
                  i4 <- which(types %in% indelg)
                  i5 <- which(types %in% indelc)

                  a1 <- assayDataElement(object, cc)[tmp[i1, 'fid'],,drop=FALSE]
                  a2 <- assayDataElement(object, cc)[tmp[i2, 'fid'],,drop=FALSE]
                  a3 <- assayDataElement(object, ccc)[tmp[i3, 'fid'],,drop=FALSE]
                  a4 <- assayDataElement(object, cc)[tmp[i4, 'fid'],,drop=FALSE]
                  a5 <- assayDataElement(object, ccc)[tmp[i5, 'fid'],,drop=FALSE]

                  result <- rbind(a1, a2, a3, a4, a5)
                  i <- c(i1, i2, i3, i4, i5)
                  tmp2 <- tmp[i,]
                  rownames(result) <- tmp2[, 'man_fsetid']
                  o <- order(tmp2[['fsetid']], tmp2[['fid']])
                  rm(tmp2)
                  result <- result[o,, drop=FALSE]
                  return(result)
              }else{
                  stop("Not yet implemented")
              }
              
              
          })

###########################################################################
## General DBPDInfo Classes
###########################################################################
setClass("DBPDInfo",
         representation=representation(
           getdb="function",
           tableInfo="data.frame",
           geometry="integer",
           manufacturer="character",
           genomebuild="character",
           annotation="character"))

setClass("GenericPDInfo", contains="DBPDInfo")

setClass("SNPPDInfo", contains="DBPDInfo")
setClass("SNPCNVPDInfo", contains="SNPPDInfo")
setClass("ExpressionPDInfo", contains="DBPDInfo")
setClass("TilingPDInfo", contains="DBPDInfo")
setClass("stArrayDBPDInfo", contains="DBPDInfo")
setClass("ExonPDInfo", contains="stArrayDBPDInfo")
setClass("GenePDInfo", contains="stArrayDBPDInfo")
setClass("HTAPDInfo", contains="stArrayDBPDInfo")

###########################################################################
## Manufacturer-specific PDInfo Classes
###########################################################################
setClass("AffyTilingPDInfo", contains="TilingPDInfo",
         prototype=list(manufacturer="Affymetrix"))
setClass("AffyExpressionPDInfo", contains="ExpressionPDInfo",
         prototype=list(manufacturer="Affymetrix"))

setClass("AffyGenePDInfo", contains="GenePDInfo",
         prototype=list(manufacturer="Affymetrix"))
setClass("AffyExonPDInfo", contains="ExonPDInfo",
         prototype=list(manufacturer="Affymetrix"))
setClass("AffySTPDInfo", contains="AffyExpressionPDInfo")
setClass("AffyHTAPDInfo", contains="HTAPDInfo")

setClass("AffySNPPDInfo", contains="SNPPDInfo",
         prototype=list(manufacturer="Affymetrix"))
setClass("AffySNPCNVPDInfo", contains="AffySNPPDInfo")

setClass("NgsExpressionPDInfo", contains="ExpressionPDInfo",
         prototype=list(manufacturer="NimbleGen"))
setClass("NgsTilingPDInfo", contains="TilingPDInfo",
         prototype=list(manufacturer="NimbleGen"))

###########################################################################
##Feature-level classes
###########################################################################
setClass("FeatureSet",
         representation=representation(
           manufacturer="character",
           intensityFile="character",
           "VIRTUAL"),
         contains="NChannelSet",
         prototype=prototype(
           manufacturer=NA_character_,
           intensityFile=NA_character_))

setClass("GenericFeatureSet", contains="FeatureSet")
setClass("ExpressionFeatureSet", contains="FeatureSet")
setClass("SnpFeatureSet", contains="FeatureSet")
setClass("SnpCnvFeatureSet", contains="SnpFeatureSet")
setClass("TilingFeatureSet", contains="FeatureSet")
setClass("ExonFeatureSet", contains="FeatureSet")
setClass("GeneFeatureSet", contains="FeatureSet")
setClass("HTAFeatureSet", contains="FeatureSet")


setClass("AlleleSet", contains="eSet")

###########################################################################
## Combo classes - SNP Summaries - alleles + calls/conf
###########################################################################
## RS is no longer using this class
setClass("SnpSuperSet", contains=c("AlleleSet", "SnpSet"))

###########################################################################
## GenomeAnnotatedDataFrame
###########################################################################
setClass("GenomeAnnotatedDataFrame", contains="AnnotatedDataFrame")

###########################################################################
##SNP-level classes
###########################################################################
setClass("gSet", contains="eSet",
	 representation(##featureData="GenomeAnnotatedDataFrame",
			genome="character",
			"VIRTUAL"))
setClass("SnpSet2", contains="gSet")
##setClass("SnpSet2", contains="SnpSet")
setClass("oligoSnpSet", contains="SnpSet2") ##representation(featureData="GenomeAnnotatedDataFrame"))
setClass("CopyNumberSet", contains="gSet") ## total copy number (no genotypes available)
setClass("BeadStudioSet", contains="gSet")
setClass("BafLrrSet", contains="BeadStudioSet")

#setClass("SomeClass", contains="SnpSet2") ## why will this not work??

###########################################################################
##Summary-level classes - CNP
###########################################################################
setOldClass("ffdf")
setOldClass("ff_matrix")
setClassUnion("list_or_ffdf", c("list", "ffdf"))
setClassUnion("ff_or_matrix", c("ffdf", "ff_matrix", "matrix"))
setClass("CNSet", contains="gSet",
	 representation(batch="character",
			batchStatistics="AssayData",
			mixtureParams="ff_or_matrix",
	                datadir="list"))##,
##	 prototype = prototype(
##	 new("VersionedBiobase",
##	     versions=c(classVersion("SnpSet"), CNSet="1.0.6"))))

setClass("CNSetLM")
setMethod("initialize", "CNSetLM", function(.Object, ...){
	.Defunct(msg="The CNSetLM class is defunct")
})

## SetList classes
setClass("gSetList",
	 representation(assayDataList="AssayData",
			phenoData="AnnotatedDataFrame",
			protocolData="AnnotatedDataFrame",
			experimentData="MIAME",
			featureDataList="list",  ## could be GRangesList...
			chromosome="vector",
			annotation="character",
			genome="character", "VIRTUAL"))
setClass("BeadStudioSetList", contains="gSetList")
setClass("BafLrrSetList", contains="BeadStudioSetList")

setClass("oligoSetList", contains="gSetList")

##---------------------------------------------------------------------------
## classes for ranges
## deprecated now
## setClass("RangedDataCopyNumber", contains="RangedData",
## 	 representation("VIRTUAL"))
## setClass("RangedDataCNV", contains="RangedDataCopyNumber")
## setClass("RangedDataCBS", contains="RangedDataCNV")
## setClass("RangedDataHMM", contains="RangedDataCNV")

##setClass("GRangesHMM", contains="GRanges")
##setClass("GRangesHMMList", contains="GRangesList")


##setClass("GRangesList",
##    contains=c("CompressedList", "GenomicRangesList"),
##    representation(
##        unlistData="GRanges",
##        elementMetadata="DataFrame"
##    ),
##    prototype(
##        elementType="GRanges"
##    )
##)

test_dataExamples <- function(){
	library(Biobase)
	data(oligoSetExample)
	checkTrue(validObject(oligoSet))
	obj <- new("oligoSnpSet",
		   copyNumber=copyNumber(oligoSet),
		   call=calls(oligoSet),
		   featureData=featureData(oligoSet),
		   phenoData=phenoData(oligoSet))
	obj <- new("oligoSnpSet",
		   copyNumber=copyNumber(oligoSet),
		   call=calls(oligoSet),
		   featureData=featureData(oligoSet),
		   phenoData=phenoData(oligoSet),
		   genome="hg18")
	checkIdentical(genomeBuild(obj), "hg18")
}

test_GenomeAnnotatedDataFrame_construction <- function(){
	checkTrue(validObject(new("GenomeAnnotatedDataFrame")))
	checkTrue(validObject(GenomeAnnotatedDataFrameFrom(NULL)))
	data(locusLevelData)
	if(require(pd.mapping50k.hind240)){
		## might be an exception in the future
		GenomeAnnotatedDataFrameFrom(locusLevelData[["genotypes"]],
					     annotationPkg=locusLevelData[["platform"]])
		tmp <- GenomeAnnotatedDataFrameFrom(locusLevelData[["genotypes"]],
						    annotationPkg=locusLevelData[["platform"]],
						    genome="hg19")
		checkException(GenomeAnnotatedDataFrameFrom(locusLevelData[["genotypes"]],
							    annotationPkg=locusLevelData[["platform"]],
							    genome="hg18"), silent=TRUE)
		checkTrue(validObject(tmp))
	}
}

test_oligoSnpSet_construction <- function(){
	checkTrue(validObject(new("oligoSnpSet")))
	library(Biobase)
	data(locusLevelData)
	require(pd.mapping50k.hind240)
	require(pd.mapping50k.xba240)
	cn <- integerMatrix(log2(locusLevelData[["copynumber"]]/100), 100)
	oligoSet <- new("oligoSnpSet",
			copyNumber=cn,
			call=locusLevelData[["genotypes"]],
			callProbability=locusLevelData[["crlmmConfidence"]],
			annotation=locusLevelData[["platform"]],
			genome="hg19")
	checkTrue(validObject(oligoSet))
	b <- matrix(dunif(nrow(oligoSet)*ncol(oligoSet)), nrow(oligoSet), ncol(oligoSet))
	dimnames(b) <- list(featureNames(oligoSet), sampleNames(oligoSet))
	b <- integerMatrix(b, 1000)
	## with BAFs
	oligoSet <- new("oligoSnpSet",
			copyNumber=integerMatrix(log2(locusLevelData[["copynumber"]]/100),100),
			call=locusLevelData[["genotypes"]],
			callProbability=locusLevelData[["crlmmConfidence"]],
			baf=b,
			annotation=locusLevelData[["platform"]],
			genome="hg19")
	checkTrue(validObject(oligoSet))
	## instantiate oligoSnpSet with 0-row featureData
	oligoSet <- new("oligoSnpSet",
			copyNumber=integerMatrix(log2(locusLevelData[["copynumber"]]/100),100),
			call=locusLevelData[["genotypes"]],
			callProbability=locusLevelData[["crlmmConfidence"]],
			genome=genomeBuild(oligoSet))
	checkTrue(validObject(oligoSet))
}

test_CopyNumberSet_construction <- function(){
	checkTrue(validObject(new("CopyNumberSet")))
	data(locusLevelData)
	##trace(oligoClasses:::addFeatureAnnotation.pd2, browser)
	cnset <- new("CopyNumberSet",
		     copyNumber=integerMatrix(log2(locusLevelData[["copynumber"]]/100),100),
		     annotation=locusLevelData[["platform"]],
		     genome="hg19")
	checkTrue(validObject(cnset))
	## instantiate oligoSnpSet with 0-row featureData
	cnset <- new("CopyNumberSet",
		     copyNumber=integerMatrix(log2(locusLevelData[["copynumber"]]/100), 100),
		     genome=genomeBuild(cnset))
	checkTrue(validObject(cnset))
}

test_GenomeAnnotatedDataFrameWithFF <- function(){
	## test instantiation from an object of class ff_matrix
	data(oligoSetExample)
	data(locusLevelData)
	fdFromMatrix <- GenomeAnnotatedDataFrameFrom(locusLevelData[["genotypes"]],
						     annotationPkg=locusLevelData[["platform"]],
						     genome="hg19")

	if(require(ff)){
		ldPath(tempdir())
		gtMatrix <- locusLevelData[["genotypes"]]
		gts <- initializeBigMatrix(name="genotypes", initdata=gtMatrix, nr=nrow(gtMatrix), nc=ncol(gtMatrix), vmode="integer")
		rownames(gts) <- rownames(gtMatrix)
		fdFromFF <- GenomeAnnotatedDataFrameFrom(gts,
							 annotationPkg=locusLevelData[["platform"]],
							 genome="hg19")
		checkTrue(identical(fdFromMatrix, fdFromFF))
	}
}


test_CNSet_construction <- function(){
	library(oligoClasses);library(RUnit)
	checkTrue(validObject(new("CNSet")))
	a <- matrix(1:25, 5, 5, dimnames=list(letters[1:5], LETTERS[1:5]))
	tmp <- new("CNSet", alleleA=a, batch=rep("a", 5))
	checkTrue(validObject(tmp))
	tmp2 <- tmp[1:3, 1:2]
	checkTrue(validObject(tmp2))

	tmp2 <- new("CNSet", alleleA=a, batch=c(rep("a", 3), "b", "b"))
	checkTrue(validObject(tmp2))
	checkTrue(identical(batchNames(tmp2), c("a", "b", "grandMean")))


	require("genomewidesnp6Crlmm")
	fns <- c("SNP_A-2131660", "SNP_A-1967418", "SNP_A-1969580", "SNP_A-4263484",
		 "SNP_A-1978185", "SNP_A-4264431", "SNP_A-1980898", "SNP_A-1983139",
		 "SNP_A-4265735", "SNP_A-1995832")
	theCalls <- matrix(2, nc=2, nrow=10)
	A <- matrix(sample(1:1000, 20), 10,2)
	B <- matrix(sample(1:1000, 20), 10,2)
	p <- matrix(runif(20), nc=2)
	theConfs <- round(-1000*log2(1-p))
	rownames(A) <- rownames(B) <- rownames(theConfs) <- fns
	batch <- rep("a", ncol(A))
	##trace("initialize", signature="CNSet", browser)
	obj <- new("CNSet",
		   alleleA=A,
		   alleleB=B,
		   call=theCalls,
		   callProbability=theConfs,
		   batch=batch,
		   annotation="genomewidesnp6",
		   genome="hg19")
	checkTrue(validObject(obj))
	checkTrue(identical(sampleNames(batchStatistics(obj)), batchNames(obj)))
	checkTrue(!is.null(batchNames(obj)))
	checkTrue(all(chromosome(obj) == 1))
}



test_BeadStudioSet <- function(){
  checkTrue(validObject(new("BafLrrSet")))
}

test_BafLrrSetList <- function(){
  checkTrue(validObject(new("BafLrrSetList")))
}

## utilities for parallel computing (now (20Mar2012) via foreach)
##
## NOTE: Using this framework, it is possible to allow for parallel
## computing WITHOUT the ff package. The problem with this is to
## overload the system as operations will pottentially copy the same
## data over and over and over. Therefore, I chose to allow parallel
## computing only when ff is loaded.
##
## Summary (useful when coding):
##   - parStatus: TRUE if requirements for parallel are met
##   - ocProbesets: number of probesets to process at a time (batch)
##   - ocSamples: number of samples to process at a time (batch)
##   - ocPath: path where ff objects are to be saved

parStatus <- function()
    getDoParRegistered() & isPackageLoaded('ff')

ocParallelStatus <- function(verbose=TRUE){
  cl <- parStatus()
  if (verbose){
      message("Parallel computing support for 'oligo/crlmm': ", appendLF=FALSE)
      if (!cl){
          message("Disabled")
          message("     - Load 'ff'")
          message("     - Load and register a 'foreach' adaptor")
          message("        Example - Using 'multicore' for 2 cores:")
          message("             library(doMC)")
          message("             registerDoMC(2)")
      }else{
          message("Enabled")
          ocProbesets(getOption('ocProbesets'))
          ocSamples(getOption('ocSamples'))
      }
      message(getBar())
  }
  return(cl)
}

ocProbesets <- function(n){
  if (missing(n)){
    return(getOption("ocProbesets"))
  }else{
    options(ocProbesets=n)
    invisible(TRUE)
  }
}

ocSamples <- function(n){
  if (missing(n)){
    return(getOption("ocSamples"))
  }else{
    options(ocSamples=n)
    invisible(TRUE)
  }
}

ocLapply <- function(X, FUN, ..., neededPkgs){
    if(missing(neededPkgs)) neededPkgs <- 'ff'
    else neededPkgs <- unique(c('ff', neededPkgs))
    x <- NULL ## to make NOTE go away in R's package checker
    if (parStatus()){
       res <- foreach(x=X, .packages=neededPkgs) %dopar% FUN(x, ...)
    }else{
       res <- lapply(X, FUN, ...)
    }
  return(res)
}

splitIndicesByLength <- function(x, lg, balance=FALSE){
	lx <- length(x)
	split(x, rep(seq(1,lx), each=lg, length.out=lx))
}

splitIndicesByNode <- function(x){
    split(x, sort(rep(1:getDoParWorkers(), length.out=length(x))))
}

## deprecated
setCluster <- function(...){
    msg <- paste('To set cluster for oligo/crlmm/friends,',
                 'use the "foreach" package and one adaptor like "doMC" or "doMPI."',
                 'Then, register the adaptor via registerDo*().')
    .Deprecated(msg=msg)
}

delCluster <- function(){
    msg <- paste('Use the recommendations used by the "foreach" package.')
    .Deprecated(msg=msg)
}


getCluster <- function(){
    .Deprecated('getDoParWorkers')
}

requireClusterPkgSet <- function(packages){
    .Deprecated(msg='Function no longer needed. Replaced by proper argument of foreach')
}

requireClusterPkg <- function(pkg, character.only=TRUE){
    .Deprecated(msg='Function no longer needed. Replaced by proper argument of foreach')
}

setMethod("updateObject", signature(object="BeadStudioSet"),
          function(object, ..., verbose=FALSE) {
		  if (verbose) message("updateObject(object = 'BeadStudioSet')")
		  obj <- tryCatch(callNextMethod(object), error=function(e) NULL)
		  if(is.null(obj)){
			  obj <- new("BeadStudioSet",
				     assayData = updateObject(assayData(object),
				     ..., verbose=verbose),
				     phenoData = phenoData(object),
				     experimentData = updateObject(experimentData(object),
				     ..., verbose=verbose),
				     annotation = updateObject(annotation(object),
				     ..., verbose=verbose),
				     featureData=updateObject(featureData(object), ..., verbose=FALSE),
				     ...)
		  }
		  if (all(isCurrent(obj))) return(obj)
		  obj
          })

setMethod("lrr", "BeadStudioSet", function(object){
	return(assayDataElement(object, "lrr"))
})

setMethod("copyNumber", "BeadStudioSet", function(object)
	  lrr(object))

setReplaceMethod("lrr", c("BeadStudioSet", "ANY"),
		 function(object, value) {
			 assayDataElementReplace(object, "lrr", value)
	 })

setReplaceMethod("lrr", c("BafLrrSet", "ANY"),
		 function(object, value) {
			 assayDataElementReplace(object, "lrr", value)
	 })

setReplaceMethod("copyNumber", c("BeadStudioSet", "ANY"),
		 function(object, value) {
			 lrr(object) <- value
			 object
	 })

setMethod("baf", "BeadStudioSet",
	  function(object) {
		  return(assayDataElement(object, "baf"))
	  })

setReplaceMethod("baf", c("BeadStudioSet", "ANY"),
		 function(object, value) {
			 assayDataElementReplace(object, "BAF", value)
	 })

setAs("BeadStudioSet", "data.frame",
      function(from, to){
	      cn <- as.numeric(lrr(from))/100
	      bf <- as.numeric(baf(from))/1000
	      x <- rep(position(from)/1e6, ncol(from))
	      ##x <- rep(position(object)[marker.index], 4)/1e6
	      is.snp <- rep(isSnp(from), ncol(from))
	      id <- rep(sampleNames(from), each=nrow(from))
	      df <- data.frame(x=x, lrr=cn, baf=bf, id=id,
			       is.snp=is.snp,
			       stringsAsFactors=FALSE)
	      df$id <- factor(df$id, ordered=TRUE, levels=unique(df$id))
	      return(df)
      })

setMethod("show", signature(object="BeadStudioSet"), function(object){
	callNextMethod(object)
	##cat("Genome Build: ", genomeBuild(object), "\n")
	##cat("Integer representation of BAF/LRR: ", isInteger(object), "\n")
})

setMethod("initialize", signature(.Object="gSetList"),
	  function(.Object,
		   assayDataList=AssayDataList(...),
		   featureDataList=GenomeAnnotatedDataFrameFromList(assayDataList),
		   chromosome=integer(),
		   phenoData=annotatedDataFrameFrom(assayDataList, byrow=FALSE),
		   protocolData=phenoData[, integer(0)],
		   experimentData=new("MIAME"),
		   annotation=character(),
		   genome=character(),
		   ...){
		  callNextMethod(.Object,
				 assayDataList=assayDataList,
				 featureDataList=featureDataList,
				 phenoData=phenoData,
				 chromosome=chromosome,
				 annotation=annotation,
				 genome=genome,
				 protocolData=protocolData,
				 experimentData=experimentData,
				 ...)
	  })

setMethod("[", signature(x="gSetList"),
	  function(x, i, j, ..., drop=FALSE){
		  ## using 'i' to subset markers does not really make
		  ## sense
		  ##
		  ## Use i to subset the list. example, x[1] is still a BeadStudioSetList, but is one chromosome
		  ##
		  if(!missing(i) & !missing(j)){
			  ##browser()
			  ad <- assayDataList(x)
			  nms <- ls(ad)
			  for(k in seq_along(nms)){
				  elt <- nms[k]
				  tmp <- ad[[elt]][i]
				  tmp <- lapply(tmp, function(x, j) {
					  x[, j, drop=FALSE]
				  }, j=j)
				  x <- assayDataElementReplace(x, elt, tmp)
			  }
			  x@chromosome <- chromosome(x)[i]
			  x@featureDataList <- featureDataList(x)[i]
			  x@phenoData <- phenoData(x)[j, ]
		  }
		  if(!missing(i) & missing(j)){
			  ad <- assayDataList(x)
			  nms <- ls(ad)
			  for(k in seq_along(nms)){
				  elt <- nms[k]
				  tmp <- ad[[elt]][i]
				  x <- assayDataElementReplace(x, elt, tmp)
			  }
			  x@chromosome <- chromosome(x)[i]
			  x@featureDataList <- featureDataList(x)[i]
		  }
		  if(missing(i) & !missing(j)){
			  ad <- assayDataList(x)
			  nms <- ls(ad)
			  for(k in seq_along(nms)){
				  elt <- nms[k]
				  tmp <- lapply(ad[[elt]], function(x, j) {
					  x[, j, drop=FALSE]
				  }, j=j)
				  x <- assayDataElementReplace(x, elt, tmp)
			  }
			  x@phenoData <- phenoData(x)[j, ]
		  }
		  return(x)
	  })

setAs("gSetList", "list", function(from){
	to <- vector("list", length(from))
	for(i in seq_along(from)){
		to[[i]] <- from[[i]]
	}
	return(to)
})

setMethod("$", signature(x="gSetList"),
	  function(x, name){
            eval(substitute(phenoData(x)$NAME_ARG, list(NAME_ARG=name)))
	  })

setReplaceMethod("$", "gSetList", function(x, name, value) {
	phenoData(x)[[name]] = value
	x
})

setMethod("annotation", signature(object="gSetList"), function(object) object@annotation)


setMethod("assayData", signature(object="gSetList"),
	  function(object) assayDataList(object))

setMethod("assayDataList", signature(object="gSetList"),
	  function(object)  object@assayDataList)

setMethod("assayDataList", signature(object="oligoSetList"),
	  function(object)  object@assayDataList)

setMethod("chromosome", signature(object="gSetList"),
	  function(object, as.list=FALSE, ...){
		  ##lapply(object, chromosome)
		  if(!as.list) object@chromosome else chromosomeList(object)
	  })

setMethod("dims", signature(x="gSetList"), function(x){
	nchr <- length(chromosome(x))
	nr <- sum(elementNROWS(x))
	ns <- ncol(x)
	ds <- c(nr, nchr, ns)
	names(ds) <- c("features (total)", "list elements", "samples")
	return(ds)
})

setReplaceMethod("featureData", signature(object="gSetList", value="list"),
		 function(object, value){
			 object@featureDataList <- value
			 object
		 })

setMethod("featureData", signature(object="gSetList"),
		 function(object){
			 object@featureDataList
		 })

setMethod("fvarLabels", signature(object="gSetList"),
	  function(object){
		  varLabels(featureData(object)[[1]])
	  })

setMethod("featureDataList", signature(object="gSetList"),
	  function(object)  object@featureDataList)

setMethod("featureNames", signature(object="gSetList"),
	  function(object){
		  lapply(featureDataList(object), featureNames)
	  })

setMethod("genomeBuild", signature(object="gSetList"), function(object) object@genome)
setReplaceMethod("genomeBuild", signature(object="gSetList", value="character"), function(object, value){
	object@genome <- value
	object
})

setMethod("length", signature(x="gSetList"), function(x) length(x@chromosome))

setMethod("order", signature(...="gSetList"),
	  function(..., na.last=TRUE,decreasing=FALSE){
		  x <- list(...)[[1]]
		  for(i in seq_along(x)){
			  x[[i]] <- chromosomePositionOrder(x[[i]])
		  }
		  return(x)
	  })

setMethod("pData", signature(object="gSetList"),
	  function(object) pData(phenoData(object)))

setMethod("phenoData", signature(object="gSetList"),
	  function(object) object@phenoData)

setReplaceMethod("phenoData",
                 signature=signature(
		 object="gSetList",
                   value="AnnotatedDataFrame"),
                 function(object, value) {
			 object@phenoData <- value
			 object
                 })

setReplaceMethod("pData",
                 signature=signature(
		 object="gSetList",
                   value="data.frame"),
                 function(object, value) {
			 pd <- phenoData(object)
			 pData(pd) <- value
			 phenoData(object) <- pd
			 object
                 })

setMethod("position", signature(object="gSetList"),
	  function(object){
		  lapply(featureDataList(object), position)
	  })

setMethod("sampleNames", signature(object="gSetList"),
	  function(object) sampleNames(phenoData(object)))

setReplaceMethod("sampleNames", signature(object="gSetList", value="character"),
		 function(object,value){
			 sampleNamesGSetList(object, value)
		 })

sampleNamesGSetList <- function(object, value){
	pd <- phenoData(object)
	sampleNames(pd) <- value
	object@phenoData <- pd
	adl <- object@assayDataList
	lrrlist <- adl[["lrr"]]
	baflist <- adl[["baf"]]
	relabel <- function(object, names){
		colnames(object) <- names
		object
	}
	if(length(lrrlist) > 0){
		lrrlist <- lapply(lrrlist, relabel, names=value)
		baflist <- lapply(baflist, relabel, names=value)
	}
	assayData <- new.env(parent=emptyenv())
	assayData[["lrr"]] <- lrrlist
	assayData[["baf"]] <- baflist
	##	adl[["lrr"]] <- lrrlist
	##	adl[["baf"]] <- baflist
	object@assayDataList <- assayData
	return(object)
}

setMethod("sapply", signature(X="gSetList"),
	  function(X, FUN, ..., simplify=TRUE, USE.NAMES=TRUE){
		  listobject <- as(X, "list")
		  sapply(listobject, FUN, ..., simplify=simplify, USE.NAMES=USE.NAMES)
	  })

setMethod("show", signature(object="gSetList"),
	  function(object){
		  nm <- ls(assayData(object))[[1]]
		  lo <- length(assayData(object)[[nm]])
		  cat(class(object), " of length ", lo, "\n", sep="")
	  })

setMethod("storageMode", "gSetList", function(object) storageMode(assayData(object)))

setMethod("varLabels", signature(object="gSetList"),
	  function(object) varLabels(phenoData(object)))

setMethod("makeFeatureGRanges", signature(object="gSetList"),
	  function(object, ...){
		  fdl <- featureData(object)
		  pos <- unlist(position(object))
		  snp <- unlist(lapply(fdl, isSnp))
		  chr <- unlist(lapply(fdl, chromosome))
		  df <- data.frame(position=pos, isSnp=snp, chromosome=chr)
		  rownames(df) <- unlist(featureNames(object))
		  fd <- as(df, "AnnotatedDataFrame")
		  fd2 <- as(fd, "GenomeAnnotatedDataFrame")
		  makeFeatureGRanges(fd2, genomeBuild(object))
	  })

setMethod("elementNROWS", signature(x="gSetList"),
	  function(x){
		  adl <- assayDataList(x)
		  nm <- ls(adl)[[1]]
		  sapply(assayDataList(x)[[nm]], nrow)
	  })

setMethod("ncol", signature(x="gSetList"),
	  function(x){
		  adl <- assayDataList(x)
		  nm <- ls(adl)[[1]]
		  ncol(assayDataList(x)[[nm]][[1]])
	  })

setMethod("initialize", signature(.Object="gSet"),
          function(.Object,
                   assayData = assayDataNew(...),
                   phenoData = annotatedDataFrameFrom(assayData, byrow=FALSE),
                   experimentData = new("MIAME"),
                   annotation = character(),
                   protocolData = phenoData[,integer(0)],
		   genome=c("hg19", "hg18"),
		   featureData,
                   ...) {
		  genome <- match.arg(genome)
		  if(missing(featureData))
			  featureData <- GenomeAnnotatedDataFrameFrom(assayData, annotation, genome=genome)
		  .Object@genome <- genome
		  .Object <- callNextMethod(.Object,
					    assayData = assayData,
					    phenoData = phenoData,
					    featureData = featureData,
					    experimentData = experimentData,
					    annotation = annotation,
					    protocolData = protocolData)
		  return(.Object)
          })

##setValidity("gSet", function(object){
##	if(nrow(object) == 0) return(TRUE)
##	sl <- getSequenceLengths(genomeBuild(object))
##	charChrom <- unique(integer2chromosome(chromosome(object)))
##	fr <- makeFeatureGRanges(object, seqlengths=sl[charChrom])
##	fr2 <-
##})


setMethod("isSnp", signature(object="gSet"),
	  function(object, ...) {
		  isSnp(featureData(object))
	  })

setMethod("isSnp", signature(object="character"),
	  function(object, pkgname, ...){
		  path <- system.file("extdata", package=pkgname)
		  load(file.path(path, "snpProbes.rda"))
		  snpProbes <- get("snpProbes")
		  object %in% snpProbes
	  })

setMethod("db", "gSet",
          function(object) {
		  requireAnnotation(annotation(object)) || stop(paste(annotation(object), "package not available"))
		  get(annotation(object))@getdb()
	  })

setMethod("chromosome", "gSet",
	  function(object, na.rm=FALSE, ...){
		  chromosome(featureData(object), na.rm)
	  })

setReplaceMethod("chromosome", signature(object="gSet", value="integer"),
		 function(object, value){
			 fData(object)$chromosome <-  value
			 object
		 })


setMethod("position", "gSet",
          function(object, na.rm=FALSE, ...){
		  position(featureData(object), na.rm)
          })

setMethod("checkOrder", signature(object="gSet"),
	  function(object, verbose=FALSE){
		  .checkOrder(object, verbose)
	  })


.checkOrder <- function(object, verbose=FALSE){
	d <- diff(order(chromosome(object), position(object)))
	if(any(d < 0)){
		if(verbose)
			warning("Object should be ordered by chromosome and physical position.\n",
				"Try \n",
				"> object <- order(object) \n")
		return(FALSE)
	}
	TRUE
}

chromosomePositionOrder <- function(object, ...){
	is.ordered <- checkOrder(object)
	if(!is.ordered){
		##if(verbose) message("Ordering ", class(object), " object by chromosome and physical position")
		index <- order(chromosome(object), position(object), ...)
		object <- object[index, ]
	}
	return(object)
}

setMethod("genomeBuild", signature(object="gSet"), function(object) object@genome)
setReplaceMethod("genomeBuild", signature(object="gSet", value="character"),
		 function(object, value){
			 object@genome <- value
			 return(object)
		 })

setMethod("show", signature(object="gSet"),
	  function(object){
		  callNextMethod(object)
		  cat("genome: ", genomeBuild(object), "\n")
	  })


setMethod("makeFeatureGRanges", signature(object="gSet"),
	  function(object, ...){
		  makeFeatureGRanges(featureData(object), genomeBuild(object))
##		  sl <- getSequenceLengths(genomeBuild(object))
##		  gr <- GRanges(paste("chr", chromosome(object), sep=""),
##				IRanges(position(object), width=1))
##		  seqlengths(gr) <- sl[match(unique(seqnames(gr)), names(sl))]
##		  return(gr)
	  })

setMethod("getArm", signature(object="gSet"), function(object, ...){
	.getArm(chromosome(object), position(object), genomeBuild(object))
})

##
## Directly from Biobase
##
setMethod("initialize", "SnpSet2",
          function(.Object,
                   assayData = assayDataNew(call = call,
                                            callProbability = callProbability, ...),
                   phenoData = annotatedDataFrameFrom(assayData, byrow=FALSE),
                   featureData,## = annotatedDataFrameFrom(assayData, byrow=TRUE),
                   experimentData = new("MIAME"),
                   annotation = character(),
                   protocolData = phenoData[,integer(0)],
                   call = new("matrix"),
                   callProbability = matrix(numeric(),
                                            nrow=nrow(call), ncol=ncol(call),
                                            dimnames=dimnames(call)),
		   genome=c("hg19", "hg18"),
                   ...) {
		  genome <- match.arg(genome)
		  if(missing(featureData))
			  featureData <- GenomeAnnotatedDataFrameFrom(assayData, annotation, genome=genome)
		  callNextMethod(.Object,
				 assayData = assayData,
				 phenoData = phenoData,
				 featureData = featureData,
				 experimentData = experimentData,
				 annotation = annotation,
				 protocolData = protocolData, ...)
          })

setMethod(snpCall, "SnpSet2", function(object, ...) {
    assayDataElement(object, "call")
})

setMethod(snpCallProbability, "SnpSet2", function(object, ...) {
    assayDataElement(object, "callProbability")
})



setReplaceMethod("snpCall", c("SnpSet2", "matrix"),
                 function(object, ..., value){
			 assayDataElementReplace(object, "call", value)
		 })

setReplaceMethod("snpCallProbability", c("SnpSet2", "matrix"),
                 function(object, ..., value){
			 assayDataElementReplace(object, "callProbability", value)
		 })

##-----------------------
## new methods for SnpSet2
##
setMethod("calls", "SnpSet2", function(object) assayData(object)$call)
setReplaceMethod("calls", signature(object="SnpSet2", value="matrix"),
                 function(object, value)
                 assayDataElementReplace(object, "call", value))

setMethod("calls", "SnpSet", function(object) assayData(object)$call)
setReplaceMethod("calls", signature(object="SnpSet", value="matrix"),
                 function(object, value)
                 assayDataElementReplace(object, "call", value))


p2i <- function(p)
  as.integer(-1000*log(1-p))

i2p <- function(i)
  1-exp(-i/1000)

warningMsg <- function(X){
	.class=class(X)
	warning("callProbability slot is of class ", .class, ".\n")
	cat("\nTo obtain the confidence scores, the data needs to be extracted from disk and represented as a matrix. The '[' method does both.  For example,\n", fill=TRUE)
	message("> x <- confs(object)[,] ## 'x' is a matrix\n")
	cat("* Note however that 'x' may be very large and swamp  the available RAM. A better approach would be to specify which rows (i) and columns (j) are read only those rows and columns from disk.\n", fill=TRUE)
	message("> x < confs(object)[i, j] \n")
	message("Finally, 'x' still needs to be translated to a probability.  This can be done by", fill=TRUE)
	message("> p <- i2p(x)")
}

setMethod("confs", "SnpSet2", function(object, transform=TRUE) {
	X <- snpCallProbability(object)
	if(is(X, "ff_matrix") | is(X, "ffdf")){
		warningMsg(X)
		return(X)
	}
	if (transform){
		X <- i2p(X)
	}
	return(X)
})

setReplaceMethod("confs", signature(object="SnpSet2", value="matrix"),
		 function(object, value){
			 ##convert probability to integer
			 if(max(value) > 1){
				 X <- matrix(p2i(value), nrow(X), ncol(X),
					     dimnames=dimnames(value))
			 } else {
				 X <- value
			 }
			 assayDataElementReplace(object, "callProbability", X)
		 })

setMethod("confs", "SnpSet", function(object, transform=TRUE) {
	X <- snpCallProbability(object)
	if(is(X, "ff_matrix") | is(X, "ffdf")){
		warningMsg(X)
		return(X)
	}
	if (transform){
		X <- i2p(X)
	}
	return(X)
})

setReplaceMethod("confs", signature(object="SnpSet", value="matrix"),
		 function(object, value){
			 ##convert probability to integer
			 if(max(value) > 1){
				 X <- matrix(p2i(value), nrow(X), ncol(X),
					     dimnames=dimnames(value))
			 } else {
				 X <- value
			 }
			 assayDataElementReplace(object, "callProbability", X)
		 })



setMethod("combine", signature=signature(x="SnpSet2", y="SnpSet2"),
          function(x, y, ...){
		  ##Check that both x and y are valid objects
		  if(!validObject(x)) stop("x is not a valid object")
		  if(!validObject(y)) stop("y is not a valid object")
		  annot <- paste(sort(c(annotation(x), annotation(y))), collapse=",")
		  annotation(x) <- annotation(y) <- annot

		  if(class(x) != class(y)){
			  stop("objects must have the same class")
		  }
		  if(storageMode(assayData(x)) != storageMode(assayData(y))){
			  stop("objects must have same storage mode for assayData")
		  }

		  fd <- combine(featureData(x), featureData(y))
		  pd <- combine(phenoData(x), phenoData(y))
		  ad.x <- as.list(assayData(x))
		  ad.y <- as.list(assayData(y))
		  ad.xy <- mapply(rbind, ad.x, ad.y, SIMPLIFY=FALSE)
		  id.x <- match(rownames(ad.xy[[1]]), featureNames(fd))
		  ee <- combine(experimentData(x), experimentData(y))
		  assayData(x) <- ad.xy
		  storageMode(assayData(x)) <- storageMode(assayData(y))
		  experimentData(x) <- ee
		  featureData(x) <- fd
		  phenoData(x) <- pd
		  x
          })


## setMethod("featuresInRange", signature(object="SnpSet2", range="RangedDataCNV"),
## 	  function(object, range, FRAME=0, FRAME.LEFT, FRAME.RIGHT, ...){
## 		  .Defunct("featuresInRange has been deprecated. Use findOverlaps.")
## 	  })

test_conversions <- function(){
	p <- matrix(runif(20), nc=2)
	integerRepresentation <- as.integer(-1000*log(1-p))
	int2 <- p2i(p)
	checkTrue(all.equal(integerRepresentation, int2))
}

test_oligoSnpSet <- function(){
	data(oligoSetExample)
	checkTrue(validObject(as(oligoSet, "SnpSet2")))
}

test_makeFeatureRanges <- function(){
	data(oligoSetExample)
	gr <- makeFeatureGRanges(featureData(oligoSet), genome=genomeBuild(oligoSet))
	checkTrue(validObject(gr))
	gr2 <- makeFeatureGRanges(oligoSet)
	checkIdentical(gr, gr2)
}

##test_RangedDataHMM2GRanges <- function(){
##	if(require(VanillaICE)){
##		data(hmmResults, package="VanillaICE")
##		checkTrue(validObject(as(hmmResults, "GRanges")))
##		obj <- as(hmmResults, "GRangesList")
##		checkTrue(validObject(obj))
##		checkEquals(names(obj), unique(sampleNames(hmmResults)))
##	}
##}

setMethod("updateObject", signature(object="oligoSnpSet"),
          function(object, ..., verbose=FALSE) {
		  if (verbose) message("updateObject(object = 'oligoSnpSet')")
		  obj <- tryCatch(callNextMethod(object), error=function(e) NULL)
		  if(is.null(obj)){
			  obj <- new("oligoSnpSet",
				     assayData = updateObject(assayData(object),
				     ..., verbose=verbose),
				     phenoData = phenoData(object),
				     experimentData = updateObject(experimentData(object),
				     ..., verbose=verbose),
				     annotation = updateObject(annotation(object),
				     ..., verbose=verbose),
				     featureData=updateObject(featureData(object), ...,
				     genome=genomeBuild(object),
				     verbose=FALSE))
		  }
		  if (all(isCurrent(obj))) return(obj)
		  obj
          })

setReplaceMethod("baf", signature(object="oligoSnpSet"),
		     function(object, value){
			     if("baf" %in% assayDataElementNames(object)){
				     object <- assayDataElementReplace(object, "baf", value)
			     } else{
				     warning("assay data element 'baf' does not exist in oligoSnpSet object")
			     }
			     return(object)
		     })

setMethod("copyNumber", "oligoSnpSet", function(object) {
	cn <- assayDataElement(object, "copyNumber")
	return(cn)
})


setReplaceMethod("copyNumber", signature(object="oligoSnpSet", value="matrix"),
                 function(object, value){
			 assayDataElementReplace(object, "copyNumber", value)
		 })

setMethod("cnConfidence", "oligoSnpSet", function(object) assayData(object)[["cnConfidence"]])
setReplaceMethod("cnConfidence", signature(object="oligoSnpSet", value="matrix"),
                 function(object, value){
			 assayDataElementReplace(object, "cnConfidence", value)
                 })

setAs("oligoSnpSet", "data.frame",
      function(from, to){
	      cn <- copyNumber(from)/100
	      gt <- calls(from)
	      cn <- as.numeric(cn)
	      gt <- as.integer(gt)
	      baf.present <- "baf" %in% ls(assayData(from))
	      lrr.present <- "lrr" %in% ls(assayData(from))
	      if(baf.present){
		      bf <- as.numeric(assayDataElement(from, "baf"))/1000
	      }
	      if(lrr.present){
		      logRRatio <- as.numeric(assayDataElement(from, "lrr"))/100
	      }
	      x <- rep(position(from)/1e6, ncol(from))
	      ##x <- rep(position(object)[marker.index], 4)/1e6
	      is.snp <- rep(isSnp(from), ncol(from))
	      id <- rep(sampleNames(from), each=nrow(from))
	      if(!baf.present){
		      df <- data.frame(x=x, cn=cn, gt=gt, id=id,
				       is.snp=is.snp,
				       stringsAsFactors=FALSE)
	      } else {
		      df <- data.frame(x=x, cn=cn, gt=gt, baf=bf, id=id,
				       is.snp=is.snp,
				       stringsAsFactors=FALSE)
	      }
	      if(lrr.present){
		      df$lrr <- logRRatio
	      }
	      df$id <- factor(df$id, ordered=TRUE, levels=unique(df$id))
	      return(df)
      })

##setAs("oligoSnpSet", "SnpSet2", function(from, to){
##	new("SnpSet2",
##	    call=calls(from),
##	    callProbability=snpCallProbability(from),
##	    genome=genomeBuild(from),
##	    phenoData=phenoData(from),
##	    protocolData=protocolData(from),
##	    annotation=annotation(from),
##	    experimentData=experimentData(from),
##	    featureData=featureData(from))
##
##})

## ideally, oligoSnpSet would inherit from SnpSet2, but currently problems with GenomeAnnotatedDataFrame

##setMethod(snpCall, "oligoSnpSet", function(object, ...) {
##    assayDataElement(object, "call")
##})
##
##setMethod(snpCallProbability, "oligoSnpSet", function(object, ...) {
##    assayDataElement(object, "callProbability")
##})
##
##setReplaceMethod("snpCall", c("oligoSnpSet", "matrix"),
##                 function(object, ..., value)
##{
##    assayDataElementReplace(object, "call", value)
##})
##
##setReplaceMethod("snpCallProbability", c("oligoSnpSet", "matrix"),
##                 function(object, ..., value)
##{
##    assayDataElementReplace(object, "callProbability", value)
##})
##
####-----------------------
#### new methods for oligoSnpSet
####
##
##setMethod("calls", "oligoSnpSet", function(object) assayData(object)$call)
##setReplaceMethod("calls", signature(object="oligoSnpSet", value="matrix"),
##                 function(object, value)
##                 assayDataElementReplace(object, "call", value))

setGeneric("manufacturer",function(object) standardGeneric("manufacturer"))
setGeneric("manufacturer<-", function(object, value) standardGeneric("manufacturer<-"))
setGeneric("bothStrands", function(object) standardGeneric("bothStrands"))
setGeneric("allele", function(object, allele, strand) standardGeneric("allele"))
setGeneric("annotate", function(object) standardGeneric("annotate"))

## assayData accessors
setGeneric("getM", function(object) standardGeneric("getM"))
setGeneric("getA", function(object) standardGeneric("getA"))
setGeneric("A", function(object, ...) standardGeneric("A"))
setGeneric("B", function(object, ...) standardGeneric("B"))
setGeneric("A<-", function(object, value) standardGeneric("A<-"))
setGeneric("B<-", function(object, value) standardGeneric("B<-"))
setGeneric("calls<-", function(object, value) standardGeneric("calls<-"))
setGeneric("calls", function(object) standardGeneric("calls"))
setGeneric("confs", function(object, transform=TRUE) standardGeneric("confs"))
setGeneric("confs<-", function(object, value) standardGeneric("confs<-"))
setGeneric("cnConfidence", function(object) standardGeneric("cnConfidence"))
setGeneric("cnConfidence<-", function(object, value) standardGeneric("cnConfidence<-"))
setGeneric("copyNumber", function(object, ...) standardGeneric("copyNumber"))
setGeneric("copyNumber<-", function(object, value) standardGeneric("copyNumber<-"))
setGeneric("baf", function(object) standardGeneric("baf"))
setGeneric("lrr", function(object) standardGeneric("lrr"))
setGeneric("lrr<-", function(object,value) standardGeneric("lrr<-"))
setGeneric("baf<-", function(object,value) standardGeneric("baf<-"))


##GenomeAnnotatedDataFrame accessors
setGeneric("chromosome", function(object, ...) standardGeneric("chromosome"))
setGeneric("chromosome<-", function(object, value) standardGeneric("chromosome<-"))
setGeneric("db", function(object) standardGeneric("db"))
setGeneric("kind", function(object) standardGeneric("kind"))
setGeneric("position", function(object, ...) standardGeneric("position"))
setGeneric("position<-", function(object, value) standardGeneric("position<-"))
setGeneric("isSnp", function(object, ...) standardGeneric("isSnp"))
setGeneric("isSnp<-", function(object, value) standardGeneric("isSnp<-"))
##setGeneric("snpNames", function(object) standardGeneric("snpNames"))
setGeneric("getArm", function(object, ...) standardGeneric("getArm"))

setGeneric("genomeBuild", function(object) standardGeneric("genomeBuild"))
setGeneric("genomeBuild<-", function(object,value) standardGeneric("genomeBuild<-"))
setGeneric("geometry", function(object) standardGeneric("geometry"))


## batchStatistics/copynumber
setGeneric("batch", function(object) standardGeneric("batch"))
setGeneric("batch<-", function(object, value) standardGeneric("batch<-"))
setGeneric("batchNames", function(object) standardGeneric("batchNames"))
setGeneric("batchNames<-", function(object,value) standardGeneric("batchNames<-"))
setGeneric("nu", function(object, allele) standardGeneric("nu"))
setGeneric("phi", function(object, allele) standardGeneric("phi"))
setGeneric("sigma2", function(object, allele) standardGeneric("sigma2"))
setGeneric("batchStatistics", function(object) standardGeneric("batchStatistics"))
setGeneric("batchStatistics<-", function(object,value) standardGeneric("batchStatistics<-"))

setGeneric("flags", function(object) standardGeneric("flags"))
setGeneric("coverage2", function(object) standardGeneric("coverage2"))
setGeneric("state", function(object) standardGeneric("state"))

setGeneric("featuresInRange", function(object, range, FRAME=0, FRAME.LEFT, FRAME.RIGHT, ...)
	   standardGeneric("featuresInRange"))
setGeneric("openff", function(object) standardGeneric("openff"))
setGeneric("closeff", function(object) standardGeneric("closeff"))
setGeneric("checkOrder", function(object, verbose=FALSE) standardGeneric("checkOrder"))
##setGeneric("order2", function(object)  standardGeneric("order2"))
setGeneric("GenomeAnnotatedDataFrameFrom", function(object, annotationPkg, genome="hg19", ...) standardGeneric("GenomeAnnotatedDataFrameFrom"))
setGeneric("numberProbes", function(object) standardGeneric("numberProbes"))
setGeneric("makeFeatureGRanges", function(object, ...) standardGeneric("makeFeatureGRanges"))

## List classes
setGeneric("assayDataList", function(object) standardGeneric("assayDataList"))
setGeneric("featureDataList", function(object) standardGeneric("featureDataList"))

setGeneric("clone2", function(object, id, prefix="",...) standardGeneric("clone2"))

##setValidity("RangedDataCNV", function(object){
##	all(c("chrom", "id", "num.mark") %in% colnames(object))
##})
##setValidity("RangedDataCBS", function(object){
##	if(nrow(object) > 0){
##		all(c("seg.mean", "start.index", "end.index") %in% colnames(object))
##	}
##})
##setValidity("RangedDataHMM", function(object) "state" %in% colnames(object))
## RangedDataCNV <- function(ranges=IRanges(),
## 			  values,
## 			  start,
## 			  end,
## 			  chromosome,
## 			  coverage,
## 			  sampleId,
## 			  startIndexInChromosome,
## 			  endIndexInChromosome,
## 			  ...){
## 	.Defunct("RangedDataCNV is defunct. Use GenomicRanges instead.")
## }

## RangedDataCBS <- function(ranges=IRanges(),
## 			  seg.mean=vector("numeric", length(ranges)), ...){
## 	.Defunct("RangedDataCBS is defunct.  Use GRanges instead")
## }

## RangedDataHMM <- function(ranges=IRanges(),
## 			  state=vector("integer", length(ranges)), ...){
## 	.Defunct("RangedDataHMM is defunct. Use GRanges instead")
## }

## setMethod("state", signature(object="RangedDataCNV"), function(object) .Defunct())
## setMethod("coverage2", signature(object="RangedDataCNV"), function(object) .Defunct())
## setMethod("mean", signature(x="RangedDataCBS"), function(x,...) .Defunct())
## setMethod("sampleNames", signature(object="RangedDataCNV"), function(object) .Defunct())
## setMethod("chromosome", signature(object="RangedDataCNV"), function(object, na.rm=FALSE) .Defunct())
## setMethod("findOverlaps", signature(query="RangedDataCNV", subject="SnpSet"),
## 	  function (query, subject, maxgap = 0L, minoverlap = 1L, type = c("any",
## 								  "start", "end", "within", "equal"), select = c("all", "first",
## 												      "last", "arbitrary"), ...){
## 		  findOverlaps(query=query, subject=featureData(subject),
## 			       maxgap=maxgap,
## 			       minoverlap=minoverlap,
## 			       type=type,
## 			       select=select, ...)
## 		  .Defunct("findOvelaps method for RangedDataCNV and SnpSet is defunct")
## 	  })

## setMethod("findOverlaps", signature(query="RangedDataCNV", subject="CNSet"),
## 	  function (query, subject, maxgap = 0L, minoverlap = 1L, type = c("any",
## 								  "start", "end", "within", "equal"), select = c("all", "first",
## 												      "last", "arbitrary"), ...){
## 		  .Defunct("findOvelaps method for RangedDataCNV and CNSet is defunct")
## 	  })

## setMethod("findOverlaps", signature(query="RangedDataCNV", subject="AnnotatedDataFrame"),
## 	  function (query, subject, maxgap = 0L, minoverlap = 1L, type = c("any",
## 								  "start", "end", "within", "equal"), select = c("all", "first",
## 												      "last", "arbitrary"), ...){
## 		  .Defunct("findOverlaps for RangedDataCNV and AnnotatedDataFrame is defunct")
## 	  })

## setMethod("findOverlaps", signature(query="AnnotatedDataFrame", subject="RangedDataCNV"),
## 	  function (query, subject, maxgap = 0L, minoverlap = 1L, type = c("any",
## 								  "start", "end", "within", "equal"), select = c("all", "first",
## 												      "last", "arbitrary"), ...){
## 		  .Defunct("findOverlaps for AnnotatedDataFrame and RangedDataCNV is defunct")
## 	  })


## setMethod("findOverlaps", signature(query="RangedDataCNV",
## 				    subject="RangedDataCNV"),
## 	  function(query, subject, maxgap = 0L, minoverlap = 1L,
## 		   type = c("any", "start", "end", "within", "equal"),
## 		   select = c("all", "first", "last", "arbitrary"), ...){
## 		  .Defunct("findOverlaps for RangedDataCNV is defunct")
## 	  })

## setMethod("findOverlaps", signature(query="RangedDataHMM",
## 				    subject="RangedDataHMM"),
## 	  function(query, subject, maxgap = 0L, minoverlap = 1L,
## 		   type = c("any", "start", "end", "within", "equal"),
## 		   select = c("all", "first", "last", "arbitrary"), ...){
## 		  .Defunct("findOverlaps for RangedDataHMM is defunct")
## 	  })


## setReplaceMethod("sampleNames", signature(object="RangedDataCNV",
## 					  value="character"),
## 		 function(object, value){
## 			 .Defunct("sampleNames<- defunct for RangedDataCNV")
## 		 })
setMethod("genomeBuild", signature(object="GRanges"),
	  function(object) metadata(object)[["genome"]])


##setAs("RangedDataHMM", "GRangesList", function(from, to){
##	GRangesListFromRangedDataHMM(from)
##})
##
##setAs("RangedDataCNV", "GRangesList", function(from, to){
##	GRangesListFromRangedDataCNV(from)
##})
##GRangesListFromRangedDataCNV <- function(object, build, ...){
##	index <- split(seq_len(nrow(object)), sampleNames(object))
##	notmissingbuild <- !missing(build)
##	if(notmissingbuild) sl <- getSequenceLengths(build)
##	grl <- vector("list", length(index))
##	for(i in seq_along(index)){
##		j <- index[[i]]
##		gr <- GRanges(paste("chr", chromosome(object)[j], sep=""),
##			      IRanges(start(object)[j], end(object)[j]))
##		if(notmissingbuild) seqlengths(gr) <- sl[match(unique(seqnames(gr)), names(sl))]
##		elementMetadata(gr)$numberProbes <- coverage2(object)[j]
##		grl[[i]] <- gr
##	}
##	grl <- GRangesList(grl)
##	names(grl) <- names(index)
##	grl
##}
setMethod("findOverlaps", signature(query="GRangesList", subject="gSet"),
	  function (query, subject,
		    maxgap = 0L, minoverlap = 1L,
		    type = c("any", "start", "end", "within", "equal"),
		    select = c("all", "first", "last", "arbitrary"),
		    ...){
		  frange <- makeFeatureGRanges(subject)
		  findOverlaps(query, frange, maxgap=maxgap,
			       minoverlap=minoverlap,
			       type=match.arg(type),
			       select=match.arg(select),
			       ...)
	  })
setMethod("findOverlaps", signature(query="GRanges", subject="gSet"),
	  function (query, subject,
		    maxgap = 0L, minoverlap = 1L,
		    type = c("any", "start", "end", "within", "equal"),
		    select = c("all", "first", "last", "arbitrary"),
		    ...){
		  frange <- makeFeatureGRanges(subject)
		  findOverlaps(query, frange, maxgap=maxgap,
			       minoverlap=minoverlap,
			       type=match.arg(type),
			       select=match.arg(select),
			       ...)
	  })
coerceToGRanges <- function(range, build="hg18"){
	##chrlevels <- paste("chr", 1:22, sep="")
	chrlevels <- names(getSequenceLengths(build))
	chrom <- paste("chr", chromosome(range), sep="")
	chrlevels <- chrlevels[chrlevels %in% chrom]
	if(is(range, "RangedDataHMM")){
		gr <- GRanges(factor(chrom, levels=chrlevels),
			      IRanges(start(range), end(range)),
			      sample=sampleNames(range),
			      state=range$state,
			      numberProbes=coverage2(range),
			      seqlengths=setSequenceLengths(build, names=chrlevels))
	}
	if(is(range, "RangedDataCBS")){
		gr <- GRanges(factor(chrom, levels=chrlevels),
			      IRanges(start(range), end(range)),
			      sample=sampleNames(range),
			      seg.mean=range$seg.mean,
			      numberProbes=coverage2(range),
			      seqlengths=setSequenceLengths(build, names=chrlevels))
	}
	metadata(gr) <- list(genome=build)
	gr
	##sort(gr)
}

setMethod("db", "AlleleSet", function(object) db(get(annotation(object))))
setMethod("A", "AlleleSet", function(object, ...) allele(object, "A", ...))
setMethod("B", "AlleleSet", function(object, ...) allele(object, "B", ...))
setReplaceMethod("A", "AlleleSet", function(object, value) {
	assayDataElementReplace(object, "alleleA", value)
})
setReplaceMethod("B", "AlleleSet", function(object, value) {
	assayDataElementReplace(object, "alleleB", value)
})

setMethod("bothStrands", "AlleleSet",
          function(object){
            grp1 <- c("alleleA", "alleleB")
            grp2 <- c("senseAlleleA", "senseAlleleB",
                      "antisenseAlleleA", "antisenseAlleleB")
            elem <- assayDataElementNames(object)
	    if(all(grp1 %in% elem)){
              return(FALSE)
            }else if (all(grp2 %in% elem)){
              return(TRUE)
            }else{
              stop("Invalid 'AlleleSet' object.")
            }
    })

setMethod("allele", "AlleleSet",
          function(object, allele, strand){
            stopifnot(!missing(allele))
            allele <- match.arg(allele, c("A", "B"))
            both <- bothStrands(object)
            if (!both){
              what <- paste("allele", allele, sep="")
            }else{
              stopifnot(!missing(strand))
              strand <- match.arg(strand, c("sense", "antisense"))
              what <- paste(strand, "Allele", allele, sep="")
            }
            assayDataElement(object, what)
          })

setMethod("getM", "AlleleSet",
          function(object){
            both <- bothStrands(object)
            ffmat <- all(unlist(eapply(assayData(object), is.ffmatrix)))
            ismat <- all(unlist(eapply(assayData(object), is.matrix)))
            stopifnot(ffmat || ismat)
            
            if (!both){
              if (ismat){
                tmp <- A(object)-B(object)
              }else{
                tmp <- ff(vmode="double", dim=dim(object))
                for (i in 1:ncol(object))
                  tmp[,i] <- A(object)[,i]-B(object)[,i]
              }
            }else{
              if (ismat){
                tmp <- array(NA, dim=c(dim(object), 2),
                             dimnames=list(featureNames(object),
                               sampleNames(object),
                               c("antisense", "sense")))
                tmp[,,1] <- A(object, "antisense")-B(object, "antisense")
                tmp[,,2] <- A(object, "sense")-B(object, "sense")
              }else{
                tmp <- ff(vmode="double", dim=c(dim(object), 2))
                for (i in 1:ncol(object)){
                  tmp[, i, 1] <- A(object, "antisense")[,i]-B(object, "antisense")[,i]
                  tmp[, i, 2] <- A(object, "sense")[,i]-B(object, "sense")[,i]
                }
              }
            }
            return(tmp)
          })

setMethod("getA", "AlleleSet",
          function(object){
            both <- bothStrands(object)
            ffmat <- all(unlist(eapply(assayData(object), is.ffmatrix)))
            ismat <- all(unlist(eapply(assayData(object), is.matrix)))
            stopifnot(ffmat || ismat)
##            rm(ffmat, ismat)
            
            if (!both){
              if (ismat){
                tmp <- (A(object)+B(object))/2
              }else{
                tmp <- ff(vmode="double", dim=dim(object))
                for (i in 1:ncol(object))
                  tmp[,i] <- (A(object)[,i]+B(object)[,i])/2
              }
            }else{
              if (ismat){
                tmp <- array(NA, dim=c(dim(object), 2),
                             dimnames=list(featureNames(object),
                               sampleNames(object),
                               c("antisense", "sense")))
                tmp[,,1] <- (A(object, "antisense")+B(object, "antisense"))/2
                tmp[,,2] <- (A(object, "sense")+B(object, "sense"))/2
              }else{
                tmp <- ff(vmode="double", dim=c(dim(object), 2))
                for (i in 1:ncol(object)){
                  tmp[, i, 1] <- (A(object, "antisense")[,i]+B(object, "antisense")[,i])/2
                  tmp[, i, 2] <- (A(object, "sense")[,i]+B(object, "sense")[,i])/2
                }
              }
            }
            return(tmp)
          })

test_annotation <- function(){
	library(oligoClasses)
	library(genomewidesnp6Crlmm)
	m <- matrix(NA, 2,1, dimnames=list(c("SNP_A-8575125", "CN_473963"), NULL))
	gad <- GenomeAnnotatedDataFrameFrom(m, "genomewidesnp6Crlmm", genome="hg19")
	##checkIdentical(position(gad), c(564621L, 61723L))
	checkIdentical(chromosome(gad), rep(1L,2))

	## genome annotated data frame with additional columns
	gd <- new("GenomeAnnotatedDataFrame",
		  position=1:10,
		  chrom=1:10,
		  isSnp=TRUE,
		  arm=1)
	checkTrue(validObject(gd))
	## other approach
	library(Biobase)
	pD <- pData(gd)
	mD <- varMetadata(gd)
	gd <- new("GenomeAnnotatedDataFrame",
		  data=pD,
		  varMetadata=mD)
	checkTrue(validObject(gd))

	gd <- gd[1:5, ]
	checkTrue(validObject(gd))

	x <- matrix(1:25, 5, 5, dimnames=list(c("rs10000092","rs1000055", "rs100016", "rs10003241", "rs10004197"), NULL))
	## preferred
	gd <- GenomeAnnotatedDataFrameFrom(x, annotationPkg="human370v1cCrlmm", genome="hg18")
	checkTrue(is(gd, "GenomeAnnotatedDataFrame"))
	## searches for hg19 by default
	## checkException(gd <- GenomeAnnotatedDataFrameFrom(x, annotationPkg="human370v1cCrlmm"))
	checkTrue(is(gd, "GenomeAnnotatedDataFrame"))
	gd <- GenomeAnnotatedDataFrameFrom(x, annotationPkg="human370v1cCrlmm", genome="")
	checkTrue(is(gd, "GenomeAnnotatedDataFrame"))
	## request a build that is not available
	## checkException(GenomeAnnotatedDataFrameFrom(x, annotationPkg="human370v1cCrlmm", genome="hg19"))
}

##test_coersionToGRanges <- function(){
##	library(GenomicRanges)
##	data(oligoSetExample)
##	## RangedDataHMM and AnnotatedDataFrame/GenomeAnnotatedDataFrame
##	rd.hmm <- RangedDataHMM(IRanges(start=49825223, end=54637167),
##				chrom=1, state=3)
##	if(FALSE){ ## not exported yet
##		checkTrue(validObject(new("GRangesHMM")))
##		gr <- GRangesHMM(seqnames="chr1", ranges=IRanges(1,3),
##				 strand="*", seqlengths=c("chr1"=1000),
##				 numberProbes=5L, state=3L)
##		checkTrue(validObject(gr))
##		library(BSgenome.Hsapiens.UCSC.hg18)
##		library(BSgenome.Hsapiens.UCSC.hg19)
##		seqlengths <- seqlengths(Hsapiens)
##		obj <- as.GRangesHMM(rd.hmm, seqlengths=seqlengths(Hsapiens))
##		checkTrue(validObject(obj))
##		checkException(as.GRangesHMM(rd.hmm))
##	}
##}

setMethod("initialize", signature(.Object="CopyNumberSet"),
          function(.Object,
                   assayData = assayDataNew(copyNumber = copyNumber,
                                            cnConfidence = cnConfidence, ...),
                   phenoData = annotatedDataFrameFrom(assayData, byrow=FALSE),
                   experimentData = new("MIAME"),
                   annotation = character(),
                   protocolData = phenoData[,integer(0)],
                   copyNumber = new("matrix"),
                   cnConfidence = matrix(numeric(),
                                            nrow=nrow(copyNumber), ncol=ncol(copyNumber),
                                            dimnames=dimnames(copyNumber)),
		   featureData=GenomeAnnotatedDataFrameFrom(assayData, annotation, genome=genome),
		   genome=c("hg19", "hg18"),
                   ...) {
		  if(nrow(copyNumber)>0){
			  if(!is(copyNumber[, 1], "integer")) stop("copyNumber should be supplied as a matrix of integers (original scale * 100). See integerMatrix in the oligoClasses package for the conversion to integer matrices")
		  }
		  .Object <- callNextMethod(.Object,
					    assayData = assayData,
					    phenoData = phenoData,
					    featureData = featureData,
					    experimentData = experimentData,
					    annotation = annotation,
					    protocolData = protocolData)
		  if(nrow(assayData[["copyNumber"]]) == 0){
			  .Object@genome <- ""
		  } else{
			  .Object@genome <- match.arg(genome)
		  }
		  return(.Object)
          })

setValidity("CopyNumberSet", function(object){
	assayDataValidMembers(assayData(object), c("copyNumber", "cnConfidence"))
	msg <- isValidGenomeAnnotatedDataFrame(featureData(object))
	if(is.character(msg)) return(msg) else TRUE
})



setAs("CNSet", "CopyNumberSet",
      function(from){
	      new("CopyNumberSet",
		  copyNumber=totalCopynumber(from, i=1:nrow(from), j=1:ncol(from)),
		  annotation=annotation(from),
		  featureData=featureData(from),
		  phenoData=phenoData(from),
		  experimentData=experimentData(from),
		  protocolData=protocolData(from))
      })

##setMethod("initialize", "oligoSnpSet",
##	  function(.Object,
##		   call=new("matrix"),
##		   callProbability=matrix(numeric(), nrow=nrow(call), ncol=ncol(call), dimnames=dimnames(call)),
##		   copyNumber=matrix(numeric(), nrow=nrow(call), ncol=ncol(call),  dimnames=dimnames(call)),
##		   ##cnConfidence=matrix(numeric(), nrow=nrow(call), ncol=ncol(call), dimnames=dimnames(call)),
##		   assayData=Biobase::assayDataNew(call=call,
##		   callProbability=callProbability,
##		   copyNumber=copyNumber, ...),
##		   annotation=character(),
##		   phenoData,
##		   featureData, ##=GenomeAnnotatedDataFrameFrom(call, annotation),
##		   experimentData,
##		   protocolData,
##		   genome=c("hg19", "hg18"),
##		   ...){
##		  if(nrow(copyNumber)>0){
##			  if(!is(copyNumber[, 1], "integer")) stop("copyNumber should be supplied as a matrix of integers (original scale * 100). See integerMatrix in the oligoClasses package for the conversion to integer matrices")
##		  }
##		  nms <- names(list(...))
##		  if(length(nms) > 0){
##			  ## check that each element in ... is a matrix of integers
##			  for(i in seq_along(nms)){
##				  elt <- list(...)[[nms[i]]]
##				  if(nrow(elt) > 0)
##					  if(!is(elt[,1], "integer")) stop("all assay data elements must be integers. For copy number, use original scale * 100 and for B allele frequencies use original scale * 1000. See integerMatrix in the oligoClasses package for the conversion to integer matrices")
##			  }
##		  }
##		  if(missing(featureData))
##			  featureData <- GenomeAnnotatedDataFrameFrom(assayData, annotation)
##		  if(missing(phenoData))
##			  phenoData <- Biobase::annotatedDataFrameFrom(call, byrow=FALSE)
##		  if(missing(experimentData))
##			  experimentData <- new("MIAME")
##		  if(missing(protocolData))
##			  protocolData <- phenoData[, integer(0)]
##		  .Object@genome <- match.arg(genome)
##		  .Object <- callNextMethod(.Object,
##					    assayData=assayData,
##					    annotation=annotation,
##					    featureData=featureData,
##					    experimentData=experimentData,
##					    phenoData=phenoData,
##					    protocolData=protocolData,
##					    ...)
##		  return(.Object)
##	  })

##harmomonizeAssayData <- function(assayData){
##	nms <- names(ls(assayData))
##	nr <- rep(NA, length(nms))
##	for(i in seq_along(nms)){
##		elt <- assayData[[nms[i]]]
##		nr[i] <- nrow(elt)
##	}
##}

setMethod("initialize", "oligoSnpSet",
	  function(.Object,
		   call=new("matrix"),
		   callProbability=matrix(numeric(), nrow=nrow(call), ncol=ncol(call), dimnames=dimnames(call)),
		   copyNumber=matrix(numeric(), nrow=nrow(call), ncol=ncol(call),  dimnames=dimnames(call)),
		   ##cnConfidence=matrix(numeric(), nrow=nrow(call), ncol=ncol(call), dimnames=dimnames(call)),
		   assayData=Biobase::assayDataNew(call=call,
		   callProbability=callProbability,
		   copyNumber=copyNumber, ...),
		   annotation=character(),
		   phenoData,
		   featureData, ##=GenomeAnnotatedDataFrameFrom(call, annotation),
		   experimentData,
		   protocolData,
		   genome=c("hg19", "hg18"),
		   ...){
		  if(nrow(copyNumber)>0){
			  if(!is(copyNumber[, 1], "integer")) stop("copyNumber should be supplied as a matrix of integers (original scale * 100). See integerMatrix in the oligoClasses package for the conversion to integer matrices")
		  }
		  nms <- names(list(...))
		  if(length(nms) > 0){
			  ## check that each element in ... is a matrix of integers
			  for(i in seq_along(nms)){
				  elt <- list(...)[[nms[i]]]
				  if(nrow(elt) > 0)
					  if(!is(elt[,1], "integer")) stop("all assay data elements must be integers. For copy number, use original scale * 100 and for B allele frequencies use original scale * 1000. See integerMatrix in the oligoClasses package for the conversion to integer matrices")
			  }
		  }
		  genome <- match.arg(genome)
		  if(missing(featureData))
			  featureData <- GenomeAnnotatedDataFrameFrom(assayData, annotation, genome=genome)
		  if(missing(phenoData))
			  phenoData <- Biobase::annotatedDataFrameFrom(call, byrow=FALSE)
		  if(missing(experimentData))
			  experimentData <- new("MIAME")
		  if(missing(protocolData))
			  protocolData <- phenoData[, integer(0)]
		  .Object <- callNextMethod(.Object,
					    assayData=assayData,
					    annotation=annotation,
					    featureData=featureData,
					    experimentData=experimentData,
					    phenoData=phenoData,
					    protocolData=protocolData,
					    ...)
		  .Object@genome <- genome
		  return(.Object)
	  })

setValidity("oligoSnpSet", function(object){
	##nms <- ls(assayData(object))
	Biobase::assayDataValidMembers(assayData(object), c("call", "callProbability", "copyNumber"))
	msg <- isValidGenomeAnnotatedDataFrame(featureData(object))
	if(nrow(copyNumber(object)) > 0){
		if(!is.integer(copyNumber(object)[,1])) return("copyNumber should be a matrix of integers (original scale * 100). Use integerMatrix(x, 100) for converting 'x' to a matrix of integers.")
	}
	if("baf" %in% ls(assayData(object))){
		b <- assayData(object)[["baf"]]
		if(nrow(b) > 0){
			if(!is.integer(b[,1])) return("B allele frequencies should be a matrix of integers (original scale * 1000). See integerMatrix(x, 1000) for converting 'x' to a matrix of integers.")
		}
	}
	if(nrow(object) > 0){
		genome <- genomeBuild(object)
		if(!genome %in% c("hg18", "hg19")) return("Supported values for genome are hg18 and hg19")
	}
	if(is.character(msg)) return(msg)
	validObject(phenoData(object))
})

## RS: ask BC about this... initialization method for CNSet does not work when this is uncommented
setValidity("AlleleSet",
            function(object){
              grp1 <- c("alleleA", "alleleB")
              grp2 <- c("senseAlleleA", "senseAlleleB",
                        "antisenseAlleleA", "antisenseAlleleB")
              elem <- assayDataElementNames(object)
              ok <- all(grp1 %in% elem) || all(grp2 %in% elem)
              f <- function(x) paste("'", x, "'", collapse=" + ", sep="")
              if (!ok){
                paste("Elements of 'AlleleSet' must be:",
                      f(grp1), "OR", f(grp2))
              }else{
                TRUE
              }
            })
setMethod("initialize", "SnpSuperSet", function(.Object,  ...) callNextMethod(.Object, ...))


initializeLmFrom <- function(object){
	nr <- nrow(object)
	nc <- length(unique(batch(object)))
	if(nc > 1) nc <- nc+1 ## add extra column for grand mean
	lm <- assayDataNew(N.AA=initializeBigMatrix("N.AA", nr, nc),
			   N.AB=initializeBigMatrix("N.AB", nr, nc),
			   N.BB=initializeBigMatrix("N.BB", nr, nc),
			   medianA.AA=initializeBigMatrix("medianA.AA", nr, nc),
			   medianA.AB=initializeBigMatrix("medianA.AB", nr, nc),
			   medianA.BB=initializeBigMatrix("medianA.BB", nr, nc),
			   medianB.AA=initializeBigMatrix("medianB.AA", nr, nc),
			   medianB.AB=initializeBigMatrix("medianB.AB", nr, nc),
			   medianB.BB=initializeBigMatrix("medianB.BB", nr, nc),
			   madA.AA=initializeBigMatrix("madA.AA", nr, nc, vmode="double"),
			   madA.AB=initializeBigMatrix("madA.AB", nr, nc, vmode="double"),
			   madA.BB=initializeBigMatrix("madA.BB", nr, nc, vmode="double"),
			   madB.AA=initializeBigMatrix("madB.AA", nr, nc, vmode="double"),
			   madB.AB=initializeBigMatrix("madB.AB", nr, nc, vmode="double"),
			   madB.BB=initializeBigMatrix("madB.BB", nr, nc, vmode="double"),
			   tau2A.AA=initializeBigMatrix("tau2A.AA", nr, nc, vmode="double"),
			   tau2A.BB=initializeBigMatrix("tau2A.BB", nr, nc, vmode="double"),
			   tau2B.AA=initializeBigMatrix("tau2B.AA", nr, nc, vmode="double"),
			   tau2B.BB=initializeBigMatrix("tau2B.BB", nr, nc, vmode="double"),
			   nuA=initializeBigMatrix("nuA", nr, nc, vmode="double"),
			   nuB=initializeBigMatrix("nuB", nr, nc, vmode="double"),
			   phiA=initializeBigMatrix("phiA", nr, nc, vmode="double"),
			   phiB=initializeBigMatrix("phiB", nr, nc, vmode="double"),
			   phiPrimeA=initializeBigMatrix("phiPrimeA", nr, nc, vmode="double"),
			   phiPrimeB=initializeBigMatrix("phiPrimeB", nr, nc, vmode="double"),
			   corrAB=initializeBigMatrix("corrAB", nr, nc, vmode="double"),
			   corrBB=initializeBigMatrix("corrBB", nr, nc, vmode="double"),
			   corrAA=initializeBigMatrix("corrAA", nr, nc, vmode="double"),
			   flags=initializeBigMatrix("flags", nr, nc))
	return(lm)
}

initializeLmFrom2 <- function(object, batch){
	nr <- nrow(object)
	nc <- length(unique(batch))
	if(nc > 1) nc <- nc+1 ## add extra column for grand mean
	lm <- assayDataNew(N.AA=initializeBigMatrix("N.AA", nr, nc),
			   N.AB=initializeBigMatrix("N.AB", nr, nc),
			   N.BB=initializeBigMatrix("N.BB", nr, nc),
			   medianA.AA=initializeBigMatrix("medianA.AA", nr, nc),
			   medianA.AB=initializeBigMatrix("medianA.AB", nr, nc),
			   medianA.BB=initializeBigMatrix("medianA.BB", nr, nc),
			   medianB.AA=initializeBigMatrix("medianB.AA", nr, nc),
			   medianB.AB=initializeBigMatrix("medianB.AB", nr, nc),
			   medianB.BB=initializeBigMatrix("medianB.BB", nr, nc),
			   madA.AA=initializeBigMatrix("madA.AA", nr, nc, vmode="double"),
			   madA.AB=initializeBigMatrix("madA.AB", nr, nc, vmode="double"),
			   madA.BB=initializeBigMatrix("madA.BB", nr, nc, vmode="double"),
			   madB.AA=initializeBigMatrix("madB.AA", nr, nc, vmode="double"),
			   madB.AB=initializeBigMatrix("madB.AB", nr, nc, vmode="double"),
			   madB.BB=initializeBigMatrix("madB.BB", nr, nc, vmode="double"),
			   tau2A.AA=initializeBigMatrix("tau2A.AA", nr, nc, vmode="double"),
			   tau2A.BB=initializeBigMatrix("tau2A.BB", nr, nc, vmode="double"),
			   tau2B.AA=initializeBigMatrix("tau2B.AA", nr, nc, vmode="double"),
			   tau2B.BB=initializeBigMatrix("tau2B.BB", nr, nc, vmode="double"),
			   nuA=initializeBigMatrix("nuA", nr, nc, vmode="double"),
			   nuB=initializeBigMatrix("nuB", nr, nc, vmode="double"),
			   phiA=initializeBigMatrix("phiA", nr, nc, vmode="double"),
			   phiB=initializeBigMatrix("phiB", nr, nc, vmode="double"),
			   phiPrimeA=initializeBigMatrix("phiPrimeA", nr, nc, vmode="double"),
			   phiPrimeB=initializeBigMatrix("phiPrimeB", nr, nc, vmode="double"),
			   corrAB=initializeBigMatrix("corrAB", nr, nc, vmode="double"),
			   corrBB=initializeBigMatrix("corrBB", nr, nc, vmode="double"),
			   corrAA=initializeBigMatrix("corrAA", nr, nc, vmode="double"),
			   flags=initializeBigMatrix("flags", nr, nc))
	if(nc > 1) {
		sampleNames(lm) <- c(unique(batch), "grandMean")
	} else sampleNames(lm) <- unique(batch)
	return(lm)
}


setMethod("initialize", "CNSet",
	  function(.Object,
		   alleleA=new("matrix"),
		   alleleB=alleleA,
		   call=alleleA,
		   callProbability=alleleA,
		   assayData=assayDataNew(alleleA=alleleA,
		                          alleleB=alleleB,
		                          call=call,
		                          callProbability=callProbability, ...),
		   phenoData=annotatedDataFrameFrom(assayData, byrow=FALSE),
		   protocolData=phenoData[, integer(0)],
		   experimentData=new("MIAME"),
		   annotation=character(),
		   featureData,
		   batch=character(ncol(alleleA)),
		   batchStatistics=initializeLmFrom2(alleleA, batch),
		   genome=c("hg19", "hg18"),
		   mixtureParams=new("matrix"),
		   datadir=list("", integer(), ""), ...){
		  genome <- match.arg(genome)
		  if(missing(featureData))
			  featureData <- GenomeAnnotatedDataFrameFrom(assayData, annotation, genome=genome)
		  .Object@mixtureParams <- mixtureParams
		  .Object@batch <- batch
		  .Object@batchStatistics <- batchStatistics
		  .Object <- callNextMethod(.Object,
					    assayData=assayData,
					    phenoData=phenoData,
					    featureData=featureData,
					    experimentData=experimentData,
					    annotation=annotation,
					    protocolData=protocolData, ...)
		  .Object@datadir <- datadir
		  .Object@genome <- genome
		  if(nrow(.Object)==0) .Object@genome <- character()
		  return(.Object)
})

setValidity("CNSet", function(object){
	if(!assayDataValidMembers(assayData(object), c("alleleA", "alleleB", "call", "callProbability"))){
		return("assay data members must be 'alleleA', 'alleleB', 'call', 'callProbability'")
	}
	if(length(batch(object)) != ncol(object)){
 		return("'batch' must be the same length as the number of samples.  ")
 	}
	if(nrow(object) > 0){
		genome <- genomeBuild(object)
		if(!genome %in% c("hg18", "hg19")) print("Supported entries for genome are hg18 and hg19")
	}
	msg <- isValidGenomeAnnotatedDataFrame(featureData(object))
	if(is.character(msg)) return(msg) else TRUE
})

initializeGenotypeSummaryFrom <- function(object){
	nr <- nrow(object)
	nc <- 3
	bns <- batchNames(object)
	elem.names <- paste("N_", bns, sep="")
	nGt <- vector("list", length(bns))
	for(i in seq_along(bns)) nGt[[i]] <- initializeBigMatrix(elem.names[i], nr, nc)
	names(nGt) <- elem.names
	numberGt <- do.call(assayDataNew, nGt)

	elem.names <- paste("mns_", bns, sep="")
	mns <- vector("list", length(bns))
	for(i in seq_along(bns)) mns[[i]] <- initializeBigMatrix(elem.names[i], nr, nc)
	mns <- do.call(assayDataNew, mns)

	elem.names <- paste("mads_", bns, sep="")
	mads <- vector("list", length(bns))
	for(i in seq_along(bns)) mads[[i]] <- initializeBigMatrix(elem.names[i], nr, nc)
	mads <- do.call(assayDataNew, mads)
	return(list(numberGenotypes=numberGt, means=mns, mads=mads))
}


setMethod("initialize", "BeadStudioSet",
	  function(.Object,
		   assayData=assayDataNew(baf = baf, lrr = lrr, ...),
		   phenoData = annotatedDataFrameFrom(assayData, byrow=FALSE),
		   featureData = GenomeAnnotatedDataFrameFrom(assayData, annotation),
		   experimentData = new("MIAME"),
		   annotation = character(),
		   protocolData = phenoData[,integer(0)],
		   baf = new("matrix"),
		   lrr = matrix(numeric(),
                		   nrow=nrow(baf),
		                   ncol=ncol(baf),
                    		   dimnames=dimnames(baf)),
		   genome=c("hg19", "hg18"),
		   ...) {
		  .Object <- callNextMethod(.Object,
					    assayData = assayData,
					    phenoData = phenoData,
					    featureData = featureData,
					    experimentData = experimentData,
					    annotation = annotation,
					    protocolData = protocolData, ...)
		  if(nrow(assayData[["baf"]]) == 0){
			  .Object@genome <- ""
		  } else{
			  .Object@genome <- match.arg(genome)
		  }
	return(.Object)
})

setValidity("BeadStudioSet", function(object) {
	if(!is.null(lrr(object))){
		if(nrow(lrr(object)) > 0)
			if(!is.integer(lrr(object)[,1])) return("lrr should be a matrix of integers (original scale * 100). Use integerMatrix(x, 100) for converting 'x' to a matrix of integers.")
		if(nrow(baf(object)) > 0){
			b <- baf(object)[,1]
			if(!is.integer(b)) return("B allele frequencies should be a matrix of integers (original scale * 1000). See integerMatrix(x, 1000) for converting 'x' to a matrix of integers.")
		}
	}
	return(all(is.element(c("lrr","baf"), assayDataElementNames(object))))
})

loader <- function(theFile, envir, pkgname){
	theFile <- file.path(system.file(package=pkgname),
			     "extdata", theFile)
	if (!file.exists(theFile))
		stop("File ", theFile, " does not exist in ", pkgname)
	load(theFile, envir=envir)
}

requireAnnotation <- function(pkgname, lib=.libPaths()[1], verbose=TRUE){
	stopifnot(is.character(pkgname), !missing(pkgname))
	status <- suppressWarnings(require(pkgname, character.only=TRUE, quietly=!verbose))
	if (!status)
		status <- pdPkgFromBioC(pkgname, lib=lib, verbose=verbose)
	status
}


## Package Downloader/Installer
## returns TRUE if installed and FALSE otherwise
pdPkgFromBioC <- function(pkgname, lib=.libPaths()[1], verbose=TRUE) {
  if (length(lib) > 1) {
    warning("Ignoring all but first element of argument lib.")
    lib <- lib[1]
  }

  if (verbose){
    message("Attempting to obtain '", pkgname, "' from BioConductor website.")
    message("Checking to see if your internet connection works...")
  }

  if (testBioCConnection()) {
    ## Check for file permissions
    if (file.access(lib, mode=0) < 0){
      if (verbose) message("Directory '", lib, "' does not seem to exist.")
      return(FALSE)
    }

    if (file.access(lib, mode=2) < 0){
      if (verbose) message("You do not have write access to '", lib, "'.")
      return(FALSE)
    }

    biocContribUrl <- sapply(repositories(), contrib.url)
    biocPkgs <- available.packages(biocContribUrl)
    if (! pkgname %in% biocPkgs[, "Package"]) {
      if (verbose)
        message("Package '", pkgname, "' was not found in the BioConductor repository.\n",
                "The 'pdInfoBuilder' package can often be used in situations like this.")
      return(FALSE)
    } else {
      install.packages(pkgname, lib=lib,
                       repos=repositories(),
                       dependencies=TRUE)
      status <- require(pkgname, character.only=TRUE, quietly=!verbose)
      if (status){
        return(TRUE)
      }else{
        if (verbose)
          message("There was a problem during download or installation.\n",
                  "Package '", pkgname, "' cannot be loaded. Please, try again.")
        return(FALSE)
      }
    }
  } else {
    if (verbose)
      message("Could not access the Bioconductor repository.\n",
              "Please check your internet connection.")
    return(FALSE)
  }
}



list.celfiles <-   function(..., listGzipped=FALSE){
    files <- list.files(...)
    if (listGzipped){
      return(files[grep("\\.[cC][eE][lL]\\.[gG][zZ]$|\\.[cC][eE][lL]$", files)])
    }else{
      return(files[grep("\\.[cC][eE][lL]$", files)])
    }
}

celfileDate <- function(filename) {
	h <- affyio::read.celfile.header(filename, info="full")
	date <- grep("/", strsplit(h$DatHeader, " ")[[1]], value=TRUE)
	if(length(date) < 1){
		##try something else
		results <- h$ScanDate
	} else{
		date <- strsplit(date, split="/")[[1]]
		CC <- ifelse(substr(date[3],1,1)=="9", "19", "20")
		results <- as.character(as.Date(paste(paste(CC, date[3], sep=""), date[1],
						      date[2], sep="-")))
	}
	results
}

celfileName <- function(object){
	if(!is(object, "CNSet")) stop("object must be CNSet")
	vl <- varLabels(protocolData(object))
	dirnames <- rep(object@datadir[[1]], object@datadir[[2]])
	if("filename" %in% vl){
		fns <- file.path(dirnames, protocolData(object)$filename)
	} else {
		fns <- file.path(dirnames, basename(sampleNames(object)))
	}
	if(!all(file.exists(fns))) stop("not all files exist")
	fns
}



## a bar that I like to use when sending messages to the user
getBar <- function(width=getOption("width"))
  paste(rep("=", width), collapse="")

isPackageLoaded <- function(pkg){
  stopifnot(is.character(pkg))
  pkg <- paste("package:", pkg, sep="")
  pkg %in% search()
}


checkExists <- function(.name, .path=".", .FUN, .FUN2, .save.it=TRUE, .load.it, ...){
	##default of load.it depends on whether the object exists in .GlobalEnv
	if(exists(.name)){
		message("Exists in .GlobalEnv")
		if(missing(.load.it)){
			message(".load.it is missing. Setting .load.it to FALSE")
			.load.it <- FALSE
		}
		if(.load.it){
			fname <- file.path(.path, paste(.name, ".rda", sep=""))
			if(file.exists(fname)){
				message(".load.it is TRUE")
				message("Loading ", fname)
				load(fname)
				if(!exists(".object")) .object <- get(.name)
				return(.object)
			} else {
				message(fname, " does not exist")
				message("Running ", .FUN)
				.object <- .FUN(...)
				if(.save.it) {
					message("Saving ", fname)
					save(.object, file=fname)
				}
				return(.object)
			}
		} else {
			message(".load.it is FALSE. Nothing to do")
			.object <- get(.name)
			return(.object)
		}
	} else{
		message(.name, " does not exist in .GlobalEnv")
		fname <- file.path(.path, paste(.name, ".rda", sep=""))
		if(file.exists(fname)){
			message(fname, " exists")
			if(missing(.load.it)){
				message(".load.it is missing. Setting .load.it to TRUE")
				.load.it <- TRUE
			}
			if(.load.it){
				message("Loading ", fname)
				.tmp <- ls()
				load(fname)
				if(!exists(".object")) .object <- tryCatch(get(.name), error=function(e) NULL)
				##extremely ad-hoc
				if(is.null(.object)) .object <- get(ls()[!(ls() %in% .tmp) & !(ls() %in% c(".object", ".tmp"))])
				return(.object)
			} else {
				message(".load.it is FALSE.  Running .FUN")
				.object <- .FUN(...)
				if(.save.it) {
					message("Saving ", fname)
					save(.object, file=fname)
				}
				return(.object)
			}
		} else {
			message(fname, " does not exist. Running .FUN")
			.object <- .FUN(...)
			if(.save.it) {
				message("Saving ", fname)
				save(.object, file=fname)
			}
			return(.object)
		}
	}
}

library2 <- function(...){
	suppressPackageStartupMessages(library(...))
}

\name{makeFeatureGRanges}
\alias{makeFeatureGRanges}

\title{
  Construct a GRanges object from several possible feature-level classes
}
\description{
  Construct a GRanges object from several possible feature-level
  classes. The conversion is useful for subsequent ranged-data queries,
  such as \code{findOverlaps}, \code{countOverlaps}, etc.
}
\usage{
makeFeatureGRanges(object, ...)
}

\arguments{
  \item{object}{
    A \code{gSet}-derived object containing chromosome and physical
  position for the markers on the array.
}

\item{\dots}{
  See the \code{makeFeatureGRanges} method for \code{GenomeAnnotatedDataFrame}.
  }
}

\value{
  A \code{GRanges} object.
}

\author{
R. Scharpf
}

\seealso{
 \code{\link{findOverlaps}}, \code{\linkS4class{GRanges}}, \code{\linkS4class{GenomeAnnotatedDataFrame}}
}
\examples{
  library(oligoClasses)
	library(GenomicRanges)
	library(Biobase)
	library(foreach)
	registerDoSEQ()
	data(oligoSetExample, package="oligoClasses")
	oligoSet <- oligoSet[chromosome(oligoSet) == 1, ]
  makeFeatureGRanges(oligoSet)
}
\keyword{manip}

\name{splitIndicesByLength}
\alias{splitIndicesByNode}
\alias{splitIndicesByLength}

\title{
  Tools to distribute objects across nodes or by length.
}

\description{
  Tools to distribute objects across nodes or by length.
}

\usage{
splitIndicesByLength(x, lg, balance=FALSE)
splitIndicesByNode(x)
}

\arguments{
  \item{x}{object to be split}
  \item{lg}{length}
  \item{balance}{logical. Currently ignored}
}

\details{
  \code{splitIndicesByLength} splits \code{x} in groups of length \code{lg}.

  \code{splitIndicesByNode} splits \code{x} in N groups (where N is the
  number of compute nodes available).

}

\value{
  List.
}

\author{
  Benilton S Carvalho
}

\seealso{
  split
}
\examples{
x <- 1:100
splitIndicesByLength(x, 8)
splitIndicesByLength(x, 8, balance=TRUE)
splitIndicesByNode(x)
}

\keyword{manip}

\name{CNSet-class}
\Rdversion{1.1}
\docType{class}
\alias{CNSet-class}
\alias{CNSet}
\alias{[,CNSet-method}
\alias{[,CNSet,ANY-method}
\alias{A,CNSet-method}
\alias{A<-,CNSet-method}
\alias{allele,CNSet-method}
\alias{B,CNSet-method}
\alias{B<-,CNSet-method}
\alias{batch,CNSet-method}
\alias{batchNames,CNSet-method}
\alias{batchNames<-,CNSet-method}
\alias{batchStatistics,CNSet-method}
\alias{batchStatistics<-,CNSet,AssayData-method}
\alias{calls,CNSet-method}
\alias{calls<-,CNSet,matrix-method}
\alias{close,CNSet-method}
\alias{coerce,CNSetLM,CNSet-method}
\alias{coerce,CNSet,CopyNumberSet-method}
\alias{coerce,CNSet,oligoSnpSet}
\alias{coerce,CNSet,oligoSnpSet-method}
\alias{confs,CNSet-method}
\alias{confs<-,CNSet,matrix-method}
\alias{corr,CNSet,character-method}
\alias{flags,CNSet-method}
\alias{initialize,CNSet-method}
\alias{initialize,CNSetLM-method}
%\alias{lM,CNSet-method}
\alias{nu,CNSet,character-method}
\alias{open,CNSet-method}
\alias{phi,CNSet,character-method}
\alias{show,CNSet-method}
\alias{snpCallProbability,CNSet-method}
\alias{sigma2,CNSet,character-method}
\alias{tau2,CNSet,character-method}
\alias{updateObject,CNSet-method}

\title{Class "CNSet"}
\description{

	CNSet is a container for intermediate data and parameters
	 pertaining to allele-specific copy number estimation. Methods
	 for CNSet objects, including accessors for linear model
	 parameters and allele-specific copy number are included here.

}
\section{Objects from the Class}{

		 An object from the class is not generally intended to
		 be initialized by the user, but returned by the
		 \code{genotype} function in the \code{crlmm} package.

		 The following creates a very basic \code{CNSet} with
		 \code{assayData} containing the required elements.

	 \code{new(CNSet, alleleA=new("matrix"), alleleB=new("matrix"), call=new("matrix"),
		   callProbability=new("matrix"), batch=new("factor"))}

}
\section{Slots}{
  \describe{
    \item{\code{batch}:}{Object of class \code{"factor"} ~~ }
    \item{\code{batchStatistics}:}{Object of class \code{"AssayData"} ~~ }
    \item{\code{assayData}:}{Object of class \code{"AssayData"} ~~ }
    \item{\code{phenoData}:}{Object of class \code{"AnnotatedDataFrame"} ~~ }
    \item{\code{featureData}:}{Object of class \code{"AnnotatedDataFrame"} ~~ }
    \item{\code{experimentData}:}{Object of class \code{"MIAME"} ~~ }
    \item{\code{annotation}:}{Object of class \code{"character"} ~~ }
    \item{\code{protocolData}:}{Object of class
      \code{"AnnotatedDataFrame"} ~~ }
    \item{\code{datadir}:}{Object of class \code{"list"}~~}
    \item{\code{mixtureParams}:}{Object of class \code{"matrix"}~~}
    \item{\code{.__classVersion__}:}{Object of class \code{"Versions"} ~~ }
  }
}

\section{Methods}{

  The argument \code{object} for the following methods is a \code{CNSet}.

  \describe{
    \item{}{\code{object[i, j]}: subset the \code{CNSet} object by
    markers (i) and/or samples (j). }

    \item{}{\code{A(objet)}: accessor for the normalized intensities of
    allele A}

  \item{}{\code{A(object) <- value}: replace intensities for the A
    allele intensities by \code{value}. The object \code{value} must be
    a \code{matrix}, \code{ff_matrix}, or \code{ffdf}.}


    \item{}{\code{allele(object, allele)}: accessor for the normalized
    intensities for the A or B allele. The argument for \code{allele}
    must be either 'A' or 'B'}

  \item{}{\code{B(objet)}: accessor for the normalized intensities of
    allele B}

  \item{}{\code{B(object) <- value}: replace intensities for the B
    allele intensities by \code{value}. The object \code{value} must be
    a \code{matrix}, \code{ff_matrix}, or \code{ffdf}.}

  \item{}{\code{batch(object)}: vector of batch labels for each sample.}

  \item{}{\code{batchNames(object)}: the unique batch names}

  %\item{batchNames<-}{\code{signature(object = "CNSet")}: ... }

  \item{}{\code{batchNames(object) <- value}: relabel the batches}

  \item{}{\code{calls(object)}: accessor for genotype calls coded as 1
    (AA), 2 (AB), or 3 (BB).  Nonpolymorphic markers are \code{NA}.}

    \item{}{\code{confs(object)}: accessor for the genotype confidence scores.}

  \item{}{\code{close(object)}: close any open file connections to
  \code{ff} objects stored in the \code{CNSet} object.}

   %\item{coerce}{\code{signature(from="CNSet")}: ... }
   \item{}{\code{as(object, "oligoSnpSet")}: coerce a \code{CNSet}
   object to an object of class \code{oligoSnpSet} -- a container for
   the total copy number and genotype calls.}

%    \item{corr}{\code{signature(object = "CNSet", allele =
%	"character")}: ... }

    \item{}{\code{corr(object)}: the correlation of the A and B
    intensities within each genotype.}

  %\item{flags}{\code{signature(object="CNSet")}: SNP flags }
  \item{}{\code{flags(object)}:  flags to indicate possible problems with
  the copy number estimation.  Not fully implemented at this point.}

   \item{}{\code{new("CNSet")}: instantiating a \code{CNSet} object.}

   \item{}{\code{nu(object, allele)}: accessor for the intercept
   (background) for the A and B alleles.  The value of \code{allele}
   must be 'A' or 'B'.}

  \item{}{\code{open(object)} open file connections for all \code{ff}
    objects stored in the \code{CNSet} object.}

   \item{}{\code{nu(object, allele)}: accessor for the slope for the A
    and B alleles.  The value of \code{allele} must be 'A' or 'B'.}

   \item{}{\code{sigma2(object, allele)}: accessor for the within
   genotype variance}

   \item{}{\code{tau2(object, allele)}: accessor for background variance}
 }
 }

\author{
R. Scharpf
}

\examples{
	new("CNSet")
}
\keyword{classes}

\name{GenomeAnnotatedDataFrameFrom-methods}
\docType{methods}
\alias{GenomeAnnotatedDataFrameFrom}
\alias{GenomeAnnotatedDataFrameFrom,AssayData-method}
\alias{GenomeAnnotatedDataFrameFrom,ff_or_matrix-method}
\alias{GenomeAnnotatedDataFrameFrom,NULL-method}
\alias{GenomeAnnotatedDataFrameFrom,array-method}
\alias{GenomeAnnotatedDataFrameFrom,list-method}

\title{Methods for Function GenomeAnnotatedDataFrameFrom in Package oligoClasses}
\description{
  \code{GenomeAnnotatedDataFrameFrom} is a convenience for creating
  \code{\linkS4class{GenomeAnnotatedDataFrame}} objects.
}

\section{Methods}{

  Use the method with \code{GenomeAnnotatedDataFrameFrom(object,
    annotationPkg, genome, ...)}; the argument \code{annotationPkg}
    \emph{must} be specified for \code{matrix} and \code{AssayData}
    classes.

\describe{

  \item{\code{signature(object="assayData")}}{

	  This method creates an \code{GenomeAnnotatedDataFrame} using
    feature names and dimensions of an \code{\link{AssayData}} object as
    a template.

  }


  \item{\code{signature(object="matrix")}}{

    This method creates an \code{GenomeAnnotatedDataFrame} using row
    names and dimensions of a \code{\link{matrix}} object as a template.

  }


  \item{\code{signature(object="NULL")}}{

	  This method (called with 'NULL' as the object) creates an
    empty \code{GenomeAnnotatedDataFrame}.

  }

  \item{\code{signature(object="array")}}{

	  This method (called with 'array' as the object) creates a
	  GenomeAnnotatedDataFrame using the first dimension of the
	  array (rows are the number of features).
  }

}}

\author{R Scharpf}

\examples{
	require(Biobase)
	minReqVersion <- "1.0.2"
	require(human370v1cCrlmm)
	if (packageDescription("human370v1cCrlmm", fields='Version') >= minReqVersion){
		x <- matrix(1:25, 5, 5,
			    dimnames=list(c("rs10000092","rs1000055", "rs100016", "rs10003241", "rs10004197"), NULL))
		gd <- GenomeAnnotatedDataFrameFrom(x, annotationPkg="human370v1cCrlmm",
						   genome="hg18")
		pData(gd)
		chromosome(gd)
		position(gd)
	}
}

\keyword{methods}

\name{Deprecated}
\title{oligoClasses Deprecated}
\alias{featuresInRange}
\alias{featuresInRange,SnpSet2,RangedDataCNV-method}
\alias{RangedDataCNV-class}
\alias{RangedDataHMM-class}
\alias{RangedDataCNV}
\alias{RangedDataHMM}
\alias{RangedDataCBS}
\alias{RangedDataCBS-class}
\alias{RangedDataCopyNumber-class}
\alias{state,RangedDataCNV-method}
%\alias{coverage2}
\alias{coverage2,RangedDataCNV-method}
\alias{mean,RangedDataCBS-method}
\alias{sampleNames,RangedDataCNV-method}
\alias{chromosome,RangedDataCNV-method}
\alias{findOverlaps,RangedDataCNV,SnpSet-method}
\alias{findOverlaps,RangedDataCNV,CNSet-method}
\alias{findOverlaps,RangedDataCNV,RangedDataCNV-method}
\alias{findOverlaps,RangedDataHMM,RangedDataHMM-method}
\alias{findOverlaps,RangedDataCNV,AnnotatedDataFrame-method}
\alias{findOverlaps,AnnotatedDataFrame,RangedDataCNV-method}
\alias{sampleNames<-,RangedDataCNV,character-method}
\description{ The function, class, or data object you asked for has been
  deprecated.}
\keyword{internal}

\name{gSetList-class}
\Rdversion{1.1}
\docType{class}
\alias{gSetList-class}
\alias{$,gSetList-method}
\alias{$<-,gSetList-method}
\alias{[,gSetList-method}
\alias{[,gSetList,ANY-method}
\alias{[[<-,gSetList,ANY,ANY,BafLrrSet-method}
\alias{annotation,gSetList-method}
\alias{assayDataList,gSetList-method}
\alias{chromosome,gSetList-method}
\alias{coerce,gSetList,list-method}
\alias{dims,gSetList-method}
\alias{elementNROWS,gSetList-method}
\alias{featureDataList,gSetList-method}
\alias{genomeBuild,gSetList-method}
\alias{genomeBuild<-,gSetList,character-method}
\alias{initialize,gSetList-method}
\alias{length,gSetList-method}
\alias{makeFeatureGRanges,gSetList-method}
\alias{position,gSetList-method}
\alias{sampleNames,gSetList-method}
\alias{sampleNames<-,gSetList,character-method}
\alias{show,gSetList-method}


\title{Virtual Class for Lists of eSets}
\description{
  Virtual Class for Lists of eSets.
}
\section{Objects from the Class}{A virtual Class: No objects may be created from it.}
\section{Slots}{
  \describe{
    \item{\code{assayDataList}:}{Object of class \code{"AssayData"} ~~ }
    \item{\code{phenoData}:}{Object of class \code{"AnnotatedDataFrame"} ~~ }
    \item{\code{protocolData}:}{Object of class \code{"AnnotatedDataFrame"} ~~ }
    \item{\code{experimentData}:}{Object of class \code{"MIAME"} ~~ }
    \item{\code{featureDataList}:}{Object of class \code{"list"} ~~ }
    \item{\code{chromosome}:}{Object of class \code{"vector"} ~~ }
    \item{\code{annotation}:}{Object of class \code{"character"} ~~ }
    \item{\code{genome}:}{Object of class \code{"character"} ~~ }
  }
}

\section{Accessors}{

  \code{object}  is an instance of a \code{gSetList}-derived class.

  \describe{
    \item{}{
      \code{annotation(object)}:

      character string indicating the package used to provide annotation
      for the features on the array.
    }

    \item{}{
      \code{chromosome(object)}:

      Returns the chromosome corresponding to each element in the
      \code{gSetList} object

    }

    \item{}{
      \code{elementNROWS(object)}: Returns the number of rows for each
      list of assays.  In most \code{gSetList}-derived classes, the
      assays are organized by chromosome and \code{elementNROWS}
      returns the number of markers for each chromosome.
    }


    \item{}{
      \code{genomeBuild(object)}, \code{genomeBuild(object) <- value}:

      Get or set the UCSC genome build. Supported builds are hg18 and hg19.

    }

  }

}

\section{Coercion}{
  \code{object}  is an instance of a \code{gSetList}-derived class.

  \describe{
    \item{}{
      \code{makeFeatureGRanges(object, ...)}:

      Create a GRanges object for the featureData.  The featureData is
      stored as a list.  This method stacks the featureData from each
      list element.  Metadata columns in the GRanges object include
      physical position ('position'), a SNP indicator ('isSnp'), and the
      chromosome. The genome build is extracted from \code{object} using
      the method \code{genomeBuild}.

      }

  }

}

\author{
R. Scharpf
}

\seealso{
  \code{\linkS4class{oligoSetList}}, \code{\linkS4class{BeadStudioSetList}}
}
\examples{
showClass("gSetList")
}
\keyword{classes}

\name{annotationPackages}
\alias{annotationPackages}
\title{Annotation Packages}
\description{
  \code{annotationPackages} will return a character vector of the names of annotation packages.
}
\usage{
annotationPackages()
}
\value{
  a character vector of the names of annotation packages
}

\name{assayDataList-methods}
\docType{methods}
\alias{assayDataList}
\alias{assayDataList-methods}

\alias{assayDataList,oligoSetList-method}
\title{Accessor for slot assayDataList in Package \pkg{oligoClasses} }
\description{
  Accessor for slot assayDataList in Package \pkg{oligoClasses}
}
\section{Methods}{
\describe{

\item{\code{signature(object = "gSetList")}}{
  An object inheriting from class \code{gSetList}.
}

\item{\code{signature(object = "oligoSetList")}}{
  An object inheriting from class \code{gSetList}.
}
}}
\keyword{methods}
\keyword{manip}

\name{length-methods}
\docType{methods}
\alias{length-methods}
\alias{length,FeatureSet-method}
\title{Number of samples for FeatureSet-like objects.}
\description{
  Number of samples for FeatureSet-like objects.
}
\section{Methods}{
\describe{
\item{x = "FeatureSet"}{Number of samples}
}}
\keyword{methods}

\name{AlleleSet-class}
\Rdversion{1.1}
\docType{class}
\alias{AlleleSet-class}
\alias{AlleleSet}
\alias{allele}
\alias{allele,AlleleSet-method}
\alias{allele,SnpFeatureSet-method}
\alias{bothStrands}
\alias{bothStrands,AlleleSet-method}
\alias{bothStrands,SnpFeatureSet-method}
\alias{db,AlleleSet-method}
\alias{getA,AlleleSet-method}
\alias{getM,AlleleSet-method}

\title{Class "AlleleSet"}
\description{A class for storing the locus-level summaries of the normalized intensities}
\section{Objects from the Class}{
		 Objects can be created by calls of the form \code{new("AlleleSet", assayData, phenoData, featureData, experimentData, annotation, protocolData, ...)}.
}
\section{Slots}{
  \describe{
    \item{\code{assayData}:}{Object of class \code{"AssayData"} ~~ }
    \item{\code{phenoData}:}{Object of class \code{"AnnotatedDataFrame"} ~~ }
    \item{\code{featureData}:}{Object of class \code{"AnnotatedDataFrame"} ~~ }
    \item{\code{experimentData}:}{Object of class \code{"MIAME"} ~~ }
    \item{\code{annotation}:}{Object of class \code{"character"} ~~ }
    \item{\code{protocolData}:}{Object of class \code{"AnnotatedDataFrame"} ~~ }
    \item{\code{.__classVersion__}:}{Object of class \code{"Versions"} ~~ }
  }
}
\section{Extends}{
Class \code{"\linkS4class{eSet}"}, directly.
Class \code{"\linkS4class{VersionedBiobase}"}, by class "eSet", distance 2.
Class \code{"\linkS4class{Versioned}"}, by class "eSet", distance 3.
}
\section{Methods}{
  \describe{
    \item{allele}{\code{signature(object = "AlleleSet")}: extract allele
    specific summaries. For 50K (XBA and Hind) and 250K (Sty and
    Nsp) arrays, an additional argument (strand) must be used (allowed
    values: 'sense', 'antisense'.}
    \item{bothStrands}{\code{signature(object = "AlleleSet")}: tests if
      data contains allele summaries on both strands for a given SNP.}
    \item{bothStrands}{\code{signature(object = "SnpFeatureSet")}: tests if
     data contains allele summaries on both strands for a given SnpFeatureSet.}
    \item{db}{\code{signature(object = "AlleleSet")}: link to database connection.}
    \item{getA}{\code{signature(object = "AlleleSet")}: average
      intensities (across alleles)}
    \item{getM}{\code{signature(object = "AlleleSet")}: log-ratio
      (Allele A vs. Allele B)}
  }
}
\author{R. Scharpf}

\seealso{
    \code{\linkS4class{SnpSuperSet}}, \code{\linkS4class{CNSet}}
}
\examples{
showClass("AlleleSet")
## an empty AlleleSet
x <- new("matrix")
new("AlleleSet", senseAlleleA=x, senseAlleleB=x,
    antisenseAlleleA=x, antisenseAlleleB=x)
##or
new("AlleleSet", alleleA=x, alleleB=x)
}
\keyword{classes}

\name{initializeBigMatrix}
\alias{initializeBigVector}
\alias{initializeBigMatrix}
\alias{initializeBigArray}

\title{
  Initialize big matrices/vectors.
}
\description{
  Initialize big matrices or vectors appropriately (conditioned on the
  status of support for large datasets - see Details).
}
\usage{
initializeBigMatrix(name=basename(tempfile()), nr=0L, nc=0L, vmode = "integer", initdata = NA)
initializeBigVector(name=basename(tempfile()), n=0L, vmode = "integer",
  initdata = NA)
initializeBigArray(name=basename(tempfile()), dim=c(0L,0L,0L),
  vmode="integer", initdata=NA)
}

\arguments{
  \item{name}{prefix to be used for file stored on disk}
  \item{nr}{number of rows}
  \item{nc}{number of columns}
  \item{n}{length of the vector}
  \item{vmode}{mode - "integer", "double"}
  \item{initdata}{Default is NA} %%FIXME
  \item{dim}{Integer vector indicating the dimensions of the array to initialize}
}
\details{

  These functions are meant to be used by developers. They provide means
  to appropriately create big vectors or matrices for packages like
  oligo and crlmm (and friends). These objects are created conditioned
  on the status of support for large datasets.

}
\value{
  If the 'ff' package is loaded (in the search path), then an 'ff'
  object is returned. A regular R vector or array is returned otherwise.
}

\examples{
x <- initializeBigVector("test", 10)
class(x)
x
if (isPackageLoaded("ff"))
  finalizer(x) <- "delete"
rm(x)
initializeBigMatrix(nr=5L, nc=5L)
initializeBigArray(dim=c(10, 5, 3))
}

\keyword{ manip }

\name{sampleNames-methods}
\docType{methods}
\alias{sampleNames-methods}
\alias{sampleNames,FeatureSet-method}

\title{Sample names for FeatureSet-like objects}
\description{
  Returns sample names for FeatureSet-like objects.
}
\section{Methods}{
  \describe{
    \item{object = "FeatureSet"}{Sample names}
  }
  }

\keyword{methods}

\name{CopyNumberSet-class}
\Rdversion{1.1}
\docType{class}
\alias{CopyNumberSet-class}
\alias{CopyNumberSet}
\alias{cnConfidence,CopyNumberSet-method}
\alias{cnConfidence<-,CopyNumberSet,matrix-method}
\alias{copyNumber,CopyNumberSet-method}
\alias{copyNumber<-,CopyNumberSet,matrix-method}
\alias{initialize,CopyNumberSet-method}
\alias{checkOrder,CopyNumberSet-method}

\title{Class \code{"CopyNumberSet"}}
\description{
  Container for storing total copy number estimates and confidence
  scores of the copy number estimates.
}
\section{Objects from the Class}{
Objects can be created by calls of the form \code{new("CopyNumberSet", assayData, phenoData, featureData, experimentData, annotation, protocolData, copyNumber, cnConfidence, ...)}.
}
\section{Slots}{
  \describe{
    \item{\code{assayData}:}{Object of class \code{"AssayData"} ~~ }
    \item{\code{phenoData}:}{Object of class \code{"AnnotatedDataFrame"} ~~ }
    \item{\code{featureData}:}{Object of class \code{"AnnotatedDataFrame"} ~~ }
    \item{\code{experimentData}:}{Object of class \code{"MIAxE"} ~~ }
    \item{\code{annotation}:}{Object of class \code{"character"} ~~ }
    \item{\code{protocolData}:}{Object of class \code{"AnnotatedDataFrame"} ~~ }
    \item{\code{.__classVersion__}:}{Object of class \code{"Versions"} ~~ }
  }
}
\section{Extends}{
Class \code{"\linkS4class{eSet}"}, directly.
Class \code{"\linkS4class{VersionedBiobase}"}, by class "eSet", distance 2.
Class \code{"\linkS4class{Versioned}"}, by class "eSet", distance 3.
}
\section{Methods}{
  \describe{
    \item{cnConfidence}{\code{signature(object = "CopyNumberSet")}: ... }
    \item{cnConfidence<-}{\code{signature(object = "CopyNumberSet", value = "matrix")}: ... }
    \item{coerce}{\code{signature(from = "CNSet", to = "CopyNumberSet")}: ... }
    \item{copyNumber}{\code{signature(object = "CopyNumberSet")}: ... }
    \item{copyNumber<-}{\code{signature(object = "CopyNumberSet", value = "matrix")}: ... }
    \item{initialize}{\code{signature(.Object = "CopyNumberSet")}: ... }
	 }
}
\author{
  R. Scharpf
}

\note{

  This container is primarily for platforms for which genotypes are
  unavailable.  As \code{oligoSnpSet} extends this class, methods
  related to total copy number that do not depend on genotypes can be
  defined at this level.


}

\seealso{

  For genotyping platforms, total copy number estimates and genotype
  calls can be stored in the \code{\linkS4class{oligoSnpSet}} class.

}
\examples{
showClass("CopyNumberSet")
cnset <- new("CopyNumberSet")
ls(Biobase::assayData(cnset))
}
\keyword{classes}

\name{db}
\alias{db}
\alias{db-methods}
\alias{db,FeatureSet-method}
\alias{db,DBPDInfo-method}
\alias{db,SnpSet-method}
\alias{db,SnpCnvQSet-method}
\alias{db,SnpQSet-method}
\title{Get the connection to the SQLite Database}
\description{
  This function will return the SQLite connection to the database
  associated to objects used in oligo.
}
\usage{
db(object)
}
\arguments{
  \item{object}{Object of valid class. See methods.}
}
\section{Methods}{
\describe{
\item{object = "FeatureSet"}{object of class FeatureSet}
\item{object = "SnpCallSet"}{object of class SnpCallSet}
\item{object = "DBPDInfo"}{object of class DBPDInfo}
\item{object = "SnpLevelSet"}{object of class SnpLevelSet}
}}
\value{
  SQLite connection.
}
\author{Benilton Carvalho}
\examples{
## db(object)
}
\keyword{methods}

\name{isSnp-methods}
\docType{methods}
\alias{isSnp-methods}
\alias{isSnp}
\alias{isSnp,character-method}
\alias{isSnp,SnpSet-method}
\alias{isSnp,gSet-method}
\alias{isSnp,GenomeAnnotatedDataFrame-method}
\title{ Methods for Function isSnp in package oligoClasses~~}
\description{
 ~~ Methods for function \code{isSnp} in package \pkg{oligoClasses} ~~
}
\section{Methods}{
\describe{

  Return an indicator for whether the marker is polymorphic (value 1) or
  nonpolymorphic (value 0).

\item{\code{signature(object = "character", pkgname = "character")}}{
  Return an indicator for whether the vector of marker identifiers in
  \code{object} is polymorphic.  \code{pkgname} must be one of the
  supported annotation packages specific to the platform.
}

\item{\code{signature(object = "eSet", pkgname = "ANY")}}{
  If 'isSnp' is included in \code{fvarLabels(object)}, an indicator for
  polymorphic markers is returned. Otherwise, an error is thrown.
}

\item{\code{signature(object = "GenomeAnnotatedDataFrame", pkgname =
  "ANY")}}{ Accessor for indicator of whether the marker is polymorphic.
  If annotation was not available due to a missing or non-existent
  annotation package, the value returned by the accessor will be a
  vector of zero's.

}
}
}

\keyword{methods}

\name{parStatus}
\alias{parStatus}

\title{
  Checks if oligo/crlmm can use parallel resources.
}

\description{
  Checks if oligo/crlmm can use parallel resources (needs ff and snow
  package, in addition to options(cluster=makeCluster(...)).
}
\usage{
parStatus()
}
\value{logical}

\author{
  Benilton S Carvalho
}

\keyword{manip}

\name{checkExists}
\alias{checkExists}
\title{
	Checks to see whether an object exists and, if not, executes the appropriate function.
}
\description{

	Only loads an object if the object name is not in the global
	environment.  If not in the global environment and the file
	exists, the object is loaded (by default). If the file does
	not exist, the function FUN is run.

}

\usage{
checkExists(.name, .path = ".", .FUN, .FUN2, .save.it=TRUE, .load.it, ...)
}


\arguments{
  \item{.name}{
  Character string giving name of object in global environment
}
  \item{.path}{
  Path to where the object is saved.
}
  \item{.FUN}{
  Function to be executed if <name> is not in the global environment and the file does not exist.
}
  \item{.FUN2}{

  Not currently used.
	  
}
 \item{.save.it}{

 Logical.  Whether to save the object to the directory indicaged by
 \code{path}. This argument is ignored if the object was loaded from
 file or already exists in the .GlobalEnv.

}

\item{.load.it}{

Logical.  If load.it is TRUE, we try to load the object from the
indicated \code{path}.  The returned object will replace the object in
the .GlobalEnv unless the object is bound to a different name (symbol)
when the function is executed.

}

\item{\dots}{

	Additional arguments passed to FUN.
  
}
}

\value{

	Could be anything -- depends on what FUN, FUN2 perform.  

	Future versions could return a 0 or 1 indicating whether the
	function performed as expected.

}

\author{
R. Scharpf
}

\examples{
path <- tempdir()
dir.create(path)
x <- 3+6
x <- checkExists("x", .path=path, .FUN=function(y, z) y+z, y=3, z=6)
rm(x)
x <- checkExists("x", .path=path, .FUN=function(y, z) y+z, y=3, z=6)
rm(x)
x <- checkExists("x", .path=path, .FUN=function(y, z) y+z, y=3, z=6)
rm(x)
##now there is a file called x.rda in tempdir().  The file will be loaded
x <- checkExists("x", .path=path, .FUN=function(y, z) y+z, y=3, z=6)
rm(x)
unlink(path, recursive=TRUE)
}
\keyword{manip}

\name{gSet-class}
\Rdversion{1.1}
\docType{class}
\alias{gSet-class}
\alias{gSet}
\alias{checkOrder,gSet-method}
\alias{db,gSet-method}
\alias{genomeBuild,gSet-method}
\alias{genomeBuild<-,gSet,character-method}
\alias{getArm}
\alias{getArm,gSet-method}
\alias{initialize,gSet-method}
\alias{makeFeatureGRanges,gSet-method}
\alias{show,gSet-method}

\title{Container for objects with genomic annotation on SNPs}
\description{
  Container for objects with genomic annotation on SNPs
}
\section{Objects from the Class}{A virtual Class: No objects may be created from it.}
\section{Slots}{
  \describe{
    \item{\code{featureData}:}{Object of class \code{"GenomeAnnotatedDataFrame"} ~~ }
    \item{\code{assayData}:}{Object of class \code{"AssayData"} ~~ }
    \item{\code{phenoData}:}{Object of class \code{"AnnotatedDataFrame"} ~~ }
    \item{\code{experimentData}:}{Object of class \code{"MIAxE"} ~~ }
    \item{\code{annotation}:}{Object of class \code{"character"} ~~ }
    \item{\code{protocolData}:}{Object of class
      \code{"AnnotatedDataFrame"} ~~ }
    \item{\code{genome}:}{Object of class \code{"character"} ~~ }
    \item{\code{.__classVersion__}:}{Object of class \code{"Versions"} ~~ }
  }
}
\section{Extends}{
Class \code{"\linkS4class{eSet}"}, directly.
Class \code{"\linkS4class{VersionedBiobase}"}, by class "eSet", distance 2.
Class \code{"\linkS4class{Versioned}"}, by class "eSet", distance 3.
}
\section{Methods}{
  The \code{object} for the below methods is a class that extends the
  virtual class \code{gSet}.
  \describe{
    \item{}{\code{checkOrder(object)}: checks that the object is ordered
      by chromosome and physical position. Returns \code{logical}.}
    \item{}{\code{chromosome(object)}: accessor for chromosome in the
      \code{GenomeAnnotatedDataFrame} slot.}
    \item{}{\code{chromosome(object) <- value}: replacement method for chromosome in the
      \code{GenomeAnnotatedDataFrame} slot. \code{value} must be an
      \code{integer} vector.}
    \item{}{
      \code{db(object)}: database connection
    }
    \item{}{

       \code{genomeBuild(object)}, \code{genomeBuild(object) <- value}:

        Get or set the UCSC genome build. Supported builds are hg18 and hg19.

      }

      \item{}{

	\code{getArm(object)}:  Character vector indicating the chromosomal arm for
	each marker in \code{object}.

      }


    \item{}{\code{isSnp(object)}: whether the marker is
      polymorphic. Returns a \code{logical} vector.}

    \item{}{

      \code{makeFeatureGRanges(object)}:  Construct an instance of the
      \code{GRanges} class from a \code{GenomeAnnotatedDataFrame}.

    }

    \item{}{\code{position(object)}: \code{integer} vector of the
      genomic position}
    \item{}{
      \code{show(object)}:

      Print a concise summary of \code{object}.

    }
  }
}

\author{
R. Scharpf
}


\seealso{
\code{\link{chromosome}}, \code{\link{position}}, \code{\link{isSnp}}
}
\examples{
showClass("gSet")
}
\keyword{classes}

\name{ff_or_matrix-class}
\Rdversion{1.1}
\docType{class}
\alias{ff_or_matrix-class}

\title{Class \code{"ff_or_matrix"}}
\description{
  A class union of 'ffdf', 'ff_matrix', and 'matrix'
}

\section{Objects from the Class}{A virtual Class: No objects may be created from it.}
\section{Methods}{
  \describe{
    \item{GenomeAnnotatedDataFrameFrom}{\code{signature(object = "ff_or_matrix")}: ... }
	 }
}

\author{
R. Scharpf
}


%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
  \code{\link[ff]{ff}},   \code{\link[ff]{ffdf}}
}
\examples{
showClass("ff_or_matrix")
}
\keyword{classes}

\name{pdPkgFromBioC}
\Rdversion{1.1}
\alias{pdPkgFromBioC}

\title{
  Get packages from BioConductor.
}
\description{
  This function checks if a given package is available on BioConductor
  and installs it, in case it is.
}
\usage{
pdPkgFromBioC(pkgname, lib = .libPaths()[1], verbose = TRUE)
}

\arguments{
  \item{pkgname}{
    character. Name of the package to be installed.
}
  \item{lib}{
    character. Path where to install the package at.
}
  \item{verbose}{
    logical. Verbosity flag.
}
}
\details{
  Internet connection required.
}
\value{
  Logical: TRUE if package was found, downloaded and installed; FALSE otherwise.
}
\author{
  Benilton Carvalho
}

\seealso{
  download.packages
}
\examples{
\dontrun{
pdPkgFromBioC("pd.mapping50k.xba240")
}
}
\keyword{data}

\name{chromosome2integer}
\alias{chromosome2integer}
\alias{integer2chromosome}
\title{Converts chromosome to integer}
\description{
	Coerces character string for chromosome in the pd. annotation packages to integers
}
\usage{
	chromosome2integer(chrom)
        integer2chromosome(intChrom)
}
\arguments{
  \item{chrom}{A one or 2 letter character string (e.g, "1", "X", "Y",
    "MT", "XY") }
  \item{intChrom}{An integer vector with values 1-25 possible}
}
\details{
  This is useful when sorting SNPs in an object by chromosome and
  physical position -- ensures that the sorting is done in the same way
  for different objects.
}
\value{
  \code{integer2chromosome} returns a vector of character string
  indicating the chromosome the same length
  as \code{intChrom}.  \code{chromosome2integer} returns a vector of
  integers the same length as the number of elements in the \code{chrom} vector.
}
\examples{
	chromosome2integer(c(1:22, "X", "Y", "XY", "M"))
	integer2chromosome(chromosome2integer(c(1:22, "X", "Y", "XY", "M")))
}
\author{R. Scharpf}
\keyword{manip}

\name{kind}
\alias{kind}
\alias{kind,AffySNPPDInfo-method}
\alias{kind,AffySNPCNVPDInfo-method}
\alias{kind,AffyExonPDInfo-method}
\alias{kind,ExpressionPDInfo-method}
\alias{kind,TilingPDInfo-method}
\alias{kind,AffyExpressionPDInfo-method}
\alias{kind,AffyGenePDInfo-method}
\alias{kind,AffyHTAPDInfo-method}
\alias{kind,GenericPDInfo-method}
\alias{kind,FeatureSet-method}

\title{Array type}
\description{
  Retrieves the array type.
}
\usage{
kind(object)
}

\arguments{
  \item{object}{\code{FeatureSet} or \code{DBPDInfo} object}
}
\value{
  String: "Expression", "Exon", "SNP" or "Tiling"
}
\examples{
if (require(pd.mapping50k.xba240)){
 data(sfsExample)
 Biobase::annotation(sfsExample) <- "pd.mapping50k.xba240"
 kind(sfsExample)
}
}

\keyword{manip}

\name{library2}
\alias{library2}
\title{
  Supress package startup messages when loading a library
}
\description{
  Supress package startup messages when loading a library
}
\usage{
library2(...)
}
\arguments{
  \item{\dots}{ arguments to \code{library}
}
}


\author{
R. Scharpf
}

\seealso{
\code{\link{library}}
}
\examples{
library2("Biobase")
}
\keyword{manip}

\name{integerMatrix}
\alias{integerMatrix}
\alias{integerArray}
\title{
  Coerce numeric matrix (or array) to a matrix (array) of integers, retaining dimnames.
}
\description{
  Coerce numeric matrix to matrix of integers, retaining dimnames.
}
\usage{
integerMatrix(x, scale = 100)
integerArray(x, scale=100)
}
\arguments{
  \item{x}{a \code{matrix} or \code{array}}
  \item{scale}{scalar (numeric).  If not 1, \code{x} is multiplied by
    \code{scale} prior to coercing to a matrix of integers.}
}

\value{
  A \code{matrix} or \code{array} of integers.
}

\author{
R. Scharpf
}


\examples{
x <- matrix(rnorm(10), 5, 2)
rownames(x) = letters[1:5]
i <- integerMatrix(x, scale=100)
}
\keyword{manip}

\name{geometry}
\alias{geometry}
\alias{geometry,DBPDInfo-method}
\alias{geometry,FeatureSet-method}

\title{Array Geometry Information}
\description{
  For a given array, \code{geometry} returns the physical geometry of it.
}
\usage{
geometry(object)
}
\arguments{
  \item{object}{\code{PDInfo} or \code{FeatureSet} object}
}
\examples{
if (require(pd.mapping50k.xba240))
 geometry(pd.mapping50k.xba240)
}
\keyword{manip}

\name{generics}
\alias{baf}
\alias{lrr}

\title{ Miscellaneous generics.  Methods defined in packages that depend
  on oligoClasses}
\description{Miscellaneous generics.  Methods defined in packages that depend
  on oligoClasses
}
\usage{
baf(object)
lrr(object)
}
\arguments{
  \item{object}{A \code{eSet}-derived class.}
}
\author{
R. Scharpf
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{misc}

\name{requireClusterPkgSet}
\alias{requireClusterPkg}
\alias{requireClusterPkgSet}
\alias{requireClusterPkg-deprecated}
\alias{requireClusterPkgSet-deprecated}

\title{
  DEPRECATED FUNCTIONS.
  Package loaders for clusters.
}
\description{
  Package loaders for clusters.
}

\usage{
requireClusterPkgSet(packages)
requireClusterPkg(pkg, character.only)
}

\arguments{
  \item{packages}{character vector with the names of the packages to be
    loaded on the compute nodes.}
  \item{pkg}{name of a package given as a name or literal character string}	
  \item{character.only}{a logical indicating whether `pkg' can be
          assumed to be a character string}
}
\details{
  \code{requireClusterPkgSet} applies \code{require} for a set of
  packages on the cluster nodes.

  \code{requireClusterPkg} applies \code{require} for *ONE* package on
  the cluster nodes and accepts every argument taken by \code{require}.
}
\value{
  Logical.
}

\author{
  Benilton S Carvalho
}

\seealso{require}

\keyword{manip}

\name{DBPDInfo-class}
\docType{class}
\alias{initialize,DBPDInfo-method}
\alias{annotation,DBPDInfo-method}
\alias{DBPDInfo-class}
\alias{AffySNPPDInfo-class}
\alias{AffySNPCNVPDInfo-class}
\alias{show,DBPDInfo-method}
\alias{AffyExpressionPDInfo-class}
\alias{AffyTilingPDInfo-class}
\alias{AffyGenePDInfo-class}
\alias{AffyExonPDInfo-class}
\alias{AffySTPDInfo-class}
\alias{SNPPDInfo-class}
\alias{SNPCNVPDInfo-class}
\alias{NgsTilingPDInfo-class}
\alias{TilingPDInfo-class}
\alias{ExpressionPDInfo-class}
\alias{NgsExpressionPDInfo-class}
\alias{GenericPDInfo-class}

\alias{DBPDInfo}
\alias{AffySNPPDInfo}
\alias{AffySNPCNVPDInfo}
\alias{show,DBPDInfo-method}
\alias{AffyExpressionPDInfo}
\alias{AffyTilingPDInfo}
\alias{AffyGenePDInfo}
\alias{AffyExonPDInfo}
\alias{AffySTPDInfo}
\alias{SNPPDInfo}
\alias{SNPCNVPDInfo}
\alias{NgsTilingPDInfo}
\alias{TilingPDInfo}
\alias{ExpressionPDInfo}
\alias{NgsExpressionPDInfo}
\alias{GenericPDInfo}

\title{Class "DBPDInfo"}
\description{A class for Platform Design Information objects, stored
  using a database approach}
\section{Objects from the Class}{
Objects can be created by calls of the form \code{new("DBPDInfo", ...)}.
}
\section{Slots}{
	 \describe{
    \item{\code{getdb}:}{Object of class \code{"function"}  }
    \item{\code{tableInfo}:}{Object of class \code{"data.frame"}  }
    \item{\code{manufacturer}:}{Object of class \code{"character"}  }
    \item{\code{genomebuild}:}{Object of class \code{"character"}  }
    \item{\code{geometry}:}{Object of class \code{"integer"} with length
    2 (rows x columns)}
  }
}
\section{Methods}{
  \describe{
    \item{annotation}{string describing annotation package associated to
      object}
    }
}
\keyword{classes}

\name{celfileName}
\alias{celfileName}
\title{
  Extracts complete cel file name from a CNSet object
}
\description{
  Returns the complete cel file (including path) for a CNSet object
}
\usage{
celfileName(object)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{object}{
    An object of class \code{CNSet}
}
}

\value{
  Character string vector.
}
\author{
  R. Scharpf
}
\note{
  If the CEL files for an experiment are relocated, the \code{datadir}
  should be updated accordingly. See examples.
}

\examples{
  \dontrun{
    if(require(crlmm)){
         data(cnSetExample, package="crlmm")
	 celfileName(cnSetExample)
    }
  }
}
%         datadir=list(dirname="/thumper/ctsa/snpmicroarray/hapmap/raw/affy/1m",
%  n=2L)
%	 fnames <- list.files("/thumper/ctsa/snpmicroarray/hapmap/raw/affy/1m", pattern=".CEL$")
%	 fnames <- fnames[c(grep(sampleNames(cnSetExample)[1], fnames),
%			    grep(sampleNames(cnSetExample)[2], fnames))]
%	 protocolData(cnSetExample)$filename <- fnames
%	 tmp@datadir <- list(dir="/thumper/ctsa/snpmicroarray/hapmap/raw/affy/1m", 2L)
%	 protocolData(tmp) <- protocolData(cnSetExample)
%
%	 data(cnSetExample2)
%	 tmp <- updateObjectFromSlots(cnSetExample2)
%	 tmp@datadir <- list(dir="/thumper/ctsa/snpmicroarray/hapmap/raw/affy/phase3_1m", n=1258L)
%	 protocolData(tmp)$filename <- tmp$celFiles
%	 phenoData(tmp)=phenoData(tmp)[, -4]
%	 cnSetExample2=tmp
%    }
\keyword{manip}

\name{requireAnnotation}
\Rdversion{1.1}
\alias{requireAnnotation}
\title{
  Helper function to load packages.
}
\description{
  This function checkes the existence of a given package and loads it if
  available. If the package is not available, the function checks its
  availability on BioConductor, downloads it and installs it.
}
\usage{
requireAnnotation(pkgname, lib=.libPaths()[1], verbose = TRUE)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{pkgname}{
    character. Package name (usually an annotation package).
  }
  \item{lib}{
    character. Path where to install packages at.
    }
  \item{verbose}{
    logical. Verbosity flag.
}
}
\value{
  Logical: TRUE if package is available or FALSE if package unavailable
  for download.
}
\author{
  Benilton Carvalho
}

\seealso{
  install.packages
}
\examples{
\dontrun{
requirePackage("pd.mapping50k.xba240")
}
}

\keyword{data}

\name{SnpSet2-class}
\Rdversion{1.1}
\docType{class}
\alias{SnpSet2-class}
\alias{calls,SnpSet2-method}
\alias{calls<-,SnpSet2,matrix-method}
\alias{confs,SnpSet2-method}
\alias{confs<-,SnpSet2,matrix-method}
\alias{exprs,SnpSet2-method}
\alias{initialize,SnpSet2-method}

\title{Class \code{"SnpSet2"}}

\description{

  A container for genotype calls and confidence scores.  Similar to the
  \code{SnpSet} class in \pkg{Biobase}, but \code{SnpSet2} extends
  \code{gSet} directly whereas \code{SnpSet} extends \code{eSet}.
  Useful properties of \code{gSet} include the \code{genome} slot and
  the \code{GenomeAnnotatedDataFrame}.

}

\section{Objects from the Class}{
Objects can be created by calls of the form \code{new("SnpSet2", assayData, phenoData, featureData, experimentData, annotation, protocolData, call, callProbability, genome, ...)}.
%%  ~~ describe objects here ~~
}
\section{Slots}{
  \describe{
    \item{\code{genome}:}{Object of class \code{"character"} indicating
      the UCSC genome build. Supported builds are 'hg18' and 'hg19'.}
    \item{\code{assayData}:}{Object of class \code{"AssayData"}.}
    \item{\code{phenoData}:}{Object of class \code{"AnnotatedDataFrame"}.}
    \item{\code{featureData}:}{Object of class \code{"AnnotatedDataFrame"}.}
    \item{\code{experimentData}:}{Object of class \code{"MIAxE"}.}
    \item{\code{annotation}:}{Object of class \code{"character"} ~~ }
    \item{\code{protocolData}:}{Object of class \code{"AnnotatedDataFrame"} ~~ }
    \item{\code{.__classVersion__}:}{Object of class \code{"Versions"} ~~ }
  }
}
\section{Extends}{
Class \code{"\linkS4class{gSet}"}, directly.
Class \code{"\linkS4class{eSet}"}, by class "gSet", distance 2.
Class \code{"\linkS4class{VersionedBiobase}"}, by class "gSet", distance 3.
Class \code{"\linkS4class{Versioned}"}, by class "gSet", distance 4.
}

\section{Accessors}{

  The argument \code{object} for the following methods is an instance of the
  \code{SnpSet2} class.

  \describe{

    \item{}{
      \code{calls(object)}: \code{calls(object) <- value}:

      Gets or sets the genotype calls. \code{value} can be a
      \code{matrix} or a \code{ff_matrix}.
    }

    \item{}{
      \code{confs(object)}: \code{confs(object) <- value}:

      Gets or sets the genotype confidence scores. \code{value} can be a
      \code{matrix} or a \code{ff_matrix}.
    }

    \item{}{
      \code{snpCall(object)}: \code{snpCallProbability(object) <- value}:

      Gets or sets the genotype confidence scores.
    }
  }
}

\author{
R. Scharpf
}


\seealso{
\code{\linkS4class{SnpSet}}
}
\examples{
showClass("SnpSet2")
new("SnpSet2")
}
\keyword{classes}

\name{oligoSet}
\alias{oligoSet}
\docType{data}
\title{An example instance of oligoSnpSet class}
\description{
	An example instance of the \code{oligoSnpSet} class
}
\usage{data(oligoSetExample)}
\source{
	Created from the simulated locusLevelData provided in this package.
}
\seealso{\code{\link{locusLevelData}}}
\examples{
	\dontrun{
		## 'oligoSetExample' created by the following
		data(locusLevelData)
		oligoSet <- new("oligoSnpSet",
				copyNumber=integerMatrix(log2(locusLevelData[["copynumber"]]/100), 100),
				call=locusLevelData[["genotypes"]],
				callProbability=locusLevelData[["crlmmConfidence"]],
				annotation=locusLevelData[["platform"]],
				genome="hg19")
		oligoSet <- oligoSet[!is.na(chromosome(oligoSet)), ]
		oligoSet <- oligoSet[chromosome(oligoSet) < 3, ]
	}
	data(oligoSetExample)
	oligoSet
}
\keyword{datasets}

\name{AssayDataList}
\alias{AssayDataList}
\title{Create a list of assay data elements}
\description{The eSetList-derived classes have an assayDataList slot
  instead of an assayData slot.
}
\usage{
AssayDataList(storage.mode = c("lockedEnvironment", "environment", "list"), ...)
}

\arguments{
  \item{storage.mode}{See \code{assayDataNew}.}
  \item{\dots}{Named lists of matrices}
}

\value{
  environment
}
\author{
R.Scharpf
}

\seealso{
  \code{\link{assayDataNew}}
}
\examples{
r <- replicate(5, matrix(rnorm(25),5,5), simplify=FALSE)
r <- lapply(r, function(x,dns) {dimnames(x) <- dns; return(x)}, dns=list(letters[1:5], LETTERS[1:5]))
ad <- AssayDataList(r=r)
ls(ad)
}
\keyword{manip}

\name{fileConnections}
\alias{open}
\alias{openff}
\alias{openff,CNSet-method}
\alias{close}
\alias{closeff}
\alias{closeff,CNSet-method}
\alias{open,matrix-method}
\alias{open,numeric-method}
\alias{open,array-method}
\alias{close,matrix-method}
\alias{close,numeric-method}
\alias{close,array-method}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
  Open and close methods for matrices and numeric vectors
}
\description{

  \code{CNSet} objects can contain \code{ff}-derived objects that
  contain pointers to files on disk, or ordinary matrices.  Here we
  define open and close methods for ordinary matrices and vectors that
  that simply pass back the original matrix/vector.

}
\usage{
open(con, ...)
openff(object)
closeff(object)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{con}{
    matrix or vector
  }
  \item{object}{ A \code{CNSet} object.}
  \item{\dots}{Ignored}
}

\value{
  not applicable
}
\author{
R. Scharpf
}

\examples{
open(rnorm(15))
open(matrix(rnorm(15), 5,3))
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{manip}

\name{manufacturer-methods}
\docType{methods}
\alias{manufacturer}
\alias{manufacturer-methods}
\alias{manufacturer,DBPDInfo-method}
\alias{manufacturer,FeatureSet-method}
\title{Manufacturer ID for FeatureSet-like objects.}
\description{
  Manufacturer ID for FeatureSet-like and DBPDInfo-like objects.
}
\section{Methods}{
\describe{
\item{object = "FeatureSet"}{Manufacturer ID}
\item{object = "PDInfo"}{Manufacturer ID}
}}
\keyword{methods}

\name{sqsExample}
\alias{sqsExample}
\docType{data}
\title{SnpQSet Example}
\description{
  Example of SnpQSet instance.
}
\usage{data(sqsExample)}
\format{
  Belongs to SnpQSet class.
}
\examples{
data(sqsExample)
class(sqsExample)
}
\keyword{datasets}

\name{getSequenceLengths}
\alias{getSequenceLengths}
%\alias{setSequenceLengths}

\title{Load chromosome sequence lengths for UCSC genome build hg18 or hg19}
\description{Load chromosome sequence lengths for UCSC genome build hg18 or hg19}
\usage{
getSequenceLengths(build)
%setSequenceLengths(build, names)
}
\arguments{
  \item{build}{
    character string: "hg18" or "hg19"
  }

%  \item{names}{
%
%    Chromosome names  (e.g, 'chr1', 'chr2', ...)
%
%  }

}
\details{The chromosome sequence lengths for UCSC builds hg18 and hg19
  were extracted from the packages BSgenome.Hsapiens.UCSC.hg18 and
  BSgenome.Hsapiens.UCSC.hg19, respectively.
}
\value{

  Names integer vector of chromosome lengths.

}

\author{
R. Scharpf
}

\examples{
getSequenceLengths("hg18")
getSequenceLengths("hg19")

if(require("GenomicRanges")){
## from GenomicRanges
	sl <- getSequenceLengths("hg18")[c("chr1", "chr2", "chr3")]
	gr <-
		GRanges(seqnames =
			Rle(c("chr1", "chr2", "chr1", "chr3"), c(1, 3, 2, 4)),
			ranges =
			IRanges(1:10, width = 10:1, names = head(letters,10)),
			strand =
			Rle(strand(c("-", "+", "*", "+", "-")),
			    c(1, 2, 2, 3, 2)),
			score = 1:10,
			GC = seq(1, 0, length=10),
			seqlengths=sl)
	metadata(gr) <- list(genome="hg18")
	gr
	metadata(gr)
}


}
\keyword{attribute}

\name{ldSetOptions}
\alias{ldSetOptions}
\alias{ldStatus}
\alias{ldPath}

\title{
  Set/check large dataset options.
}
\description{
  Set/check large dataset options.
}
\usage{
ldSetOptions(nsamples=100, nprobesets=20000, path=getwd(), verbose=FALSE)
ldStatus(verbose=FALSE)
ldPath(path)
}

\arguments{
  \item{nsamples}{number of samples to be processed at once.}
  \item{nprobesets}{number of probesets to be processed at once.}
  \item{path}{path where to store large dataset objects.}
  \item{verbose}{verbosity (logical).}
}

\details{
  Some functions in oligo/crlmm can process data in batches to minimize
  memory footprint. When using this feature, the 'ff' package resources
  are used (and possibly combined with cluster resources set in
  options() via 'snow' package).

  Methods that are executed on a sample-by-sample manner can use
  ocSamples() to automatically define how many samples are processed at
  once (on a compute node). Similarly, methods applied to probesets can
  use ocProbesets(). Users should set these options appropriately.

  \code{ldStatus} checks the support for large datasets.

  \code{ldPath} checks where ff files are stored.
}

\author{
  Benilton S Carvalho
}

\seealso{ocSamples, ocProbesets}

\examples{
ldStatus(TRUE)
}

\keyword{manip}

\name{AssayData-methods}
\Rdversion{1.1}
\docType{methods}
\alias{corr}
\alias{flags,AssayData-method}
\alias{nu}
\alias{phi}
\alias{batchNames,AssayData-method}
\alias{batchNames<-,AssayData-method}
\alias{nu,AssayData,character-method}
\alias{phi,AssayData,character-method}

\title{Methods for class AssayData in the oligoClasses package}
\description{

  Batch statistics used for estimating copy number are stored as
AssayData in the 'batchStatistics' slot of the CNSet class. Each element
in the AssayData must have the same number of rows and columns.  Rows
correspond to features and columns correspond to batch.

}
\section{Objects from the Class}{A virtual Class: No objects may be created from it.}
\section{Methods}{
  \describe{
    \item{batchNames}{\code{signature(object = "AssayData")}: ... }
    \item{batchNames<-}{\code{signature(object = "AssayData")}: ... }
    \item{corr}{\code{signature(object = "AssayData", allele = "character")}: ... }
    \item{nu}{\code{signature(object = "AssayData", allele = "character")}: ... }
    \item{phi}{\code{signature(object = "AssayData", allele = "character")}: ... }
%    \item{sigma2}{\code{signature(object = "AssayData", allele = "character")}: ... }
%    \item{tau2}{\code{signature(object = "AssayData", allele = "character")}: ... }
	 }
}

\section{Details}{

\code{lM}:  Extracts entire list of linear model parameters.

\code{corr}: The within-genotype correlation of log2(A) and log2(B) intensities.

\code{nu}: The intercept for the linear model.  The linear model is
fit to the A and B alleles independently.

\code{phi}: The slope for the linear model.  The linear model is fit
independently to the A and B alleles.

%\code{sigma2}: For allele A, sigma2 is calculated as the squared MAD
%of the log2(intensity) for allele 'A' among subjects with genotype AA.
%For allele B, sigma2 is calculated as the squared MAD of the
%log2(intensity) for allele 'B' among subjects with genotype BB.
%sigma2 can be interpreted as a robust estimate of the signal variance.
%
%\code{tau2}: For allele A, tau2 is calculated as the squared MAD of
%the log2(intensity) for allele 'A' among subjects with genotype BB.
%For allele B, tau2 is calculated as the squared MAD of the
%log2(intensity) for allele 'B' among subjects with genotype AA.  tau2
%can be interpeted as a robust estimate of the background variance.

}

\seealso{

	\code{\link{CNSet-class}}

}

\examples{
library(crlmm)
library(Biobase)
data(cnSetExample, package="crlmm")
cnSet <- cnSetExample
isCurrent(cnSet)
assayDataElementNames(batchStatistics(cnSet))
## Accessors for linear model parameters
## -- Included here primarily as a check that accessors are working
## -- Values are all NA until CN estimation is performed using the crlmm package
##
## subsetting
cnSet[1:10, ]
## names of elements in the object
## accessors for parameters
nu(cnSet, "A")[1:10, ]
nu(cnSet, "B")[1:10, ]
phi(cnSet, "A")[1:10, ]
phi(cnSet, "B")[1:10, ]
}

\keyword{classes}

\name{checkOrder}
\alias{checkOrder}
\alias{chromosomePositionOrder}
\title{Checks whether a eSet-derived class is ordered by chromosome and
  physical position}
\description{
Checks whether a \code{eSet}-derived class (e.g., a \code{SnpSet} or
\code{CNSet} object) is ordered by chromosome and
  physical position
}
\usage{
checkOrder(object, verbose = FALSE)
chromosomePositionOrder(object, ...)
}
\arguments{
  \item{object}{
    A \code{SnpSet} or \code{CopyNumberSet}.
  }
  \item{verbose}{
    Logical.
  }
  \item{\dots}{
    additional arguments to \code{order}
  }
}
\details{
  Checks whether the object is ordered by chromosome and physical position.
}
\value{ Logical
}
\author{
R. Scharpf
}


\seealso{
\code{\link{order}}
}
\examples{
data(oligoSetExample)
if(!checkOrder(oligoSet)){
   oligoSet <- chromosomePositionOrder(oligoSet)
}
checkOrder(oligoSet)
}
\keyword{manip}

\name{FeatureSet-class}
\docType{class}
\alias{show,FeatureSet-method}
\alias{FeatureSet-class}
\alias{FeatureSet}
\alias{initialize,FeatureSet-method}
\alias{GeneFeatureSet-class}
\alias{ExpressionFeatureSet-class}
\alias{ExonFeatureSet-class}
\alias{SnpFeatureSet-class}
\alias{SnpCnvFeatureSet-class}
\alias{TilingFeatureSet-class}
\alias{TilingFeatureSet2-class}
\alias{GenericFeatureSet-class}
\alias{GeneFeatureSet}
\alias{ExpressionFeatureSet}
\alias{ExonFeatureSet}
\alias{SnpFeatureSet}
\alias{SnpCnvFeatureSet}
\alias{TilingFeatureSet}
\alias{TilingFeatureSet2}
\alias{GenericFeatureSet}

\title{"FeatureSet" and "FeatureSet" Extensions}
\description{Classes to store data from Expression/Exon/SNP/Tiling arrays at the feature level.}
\section{Objects from the Class}{
  The FeatureSet class is VIRTUAL. Therefore users are not able to
  create instances of such class.

  Objects for FeatureSet-like classes can be created by calls of the form:
  \code{new(CLASSNAME, assayData, manufacturer, platform, exprs,
    phenoData, featureData, experimentData, annotation, ...)}.
  But the preferred way is using parsers like
  \code{\link[oligo]{read.celfiles}} and \code{\link[oligo]{read.xysfiles}}.
}
\section{Slots}{
  \describe{
    \item{\code{manufacturer}:}{Object of class \code{"character"}  }
    \item{\code{assayData}:}{Object of class \code{"AssayData"}  }
    \item{\code{phenoData}:}{Object of class \code{"AnnotatedDataFrame"}  }
    \item{\code{featureData}:}{Object of class \code{"AnnotatedDataFrame"}  }
    \item{\code{experimentData}:}{Object of class \code{"MIAME"}  }
    \item{\code{annotation}:}{Object of class \code{"character"}  }
    \item{\code{.__classVersion__}:}{Object of class \code{"Versions"}  }
  }
}

\section{Methods}{
 \describe{
    \item{show}{\code{signature(.Object = "FeatureSet")}: show object contents }
    \item{bothStrands}{\code{signature(.Object = "SnpFeatureSet")}:
      checks if object contains data for both strands simultaneously
      (50K/250K Affymetrix SNP chips - in this case it returns TRUE); if
      object contains data for one strand at a time (SNP 5.0 and SNP 6.0
      - in this case it returns FALSE)}
    }
}
\author{Benilton Carvalho}

\seealso{\code{\link[Biobase:class.eSet]{eSet}}, \code{\link[Biobase:class.VersionedBiobase]{VersionedBiobase}}, \code{\link[Biobase:class.Versioned]{Versioned}}}

\examples{
set.seed(1)
tmp <- 2^matrix(rnorm(100), ncol=4)
rownames(tmp) <- 1:25
colnames(tmp) <- paste("sample", 1:4, sep="")
efs <- new("ExpressionFeatureSet", exprs=tmp)
}
\keyword{classes}

\name{chromosome-methods}
\docType{methods}
\alias{chromosome-methods}
\alias{chromosome}
\alias{chromosome<-}
\alias{chromosome,AnnotatedDataFrame-method}
\alias{chromosome,SnpSet-method}
\alias{chromosome,gSet-method}
\alias{chromosome,GenomeAnnotatedDataFrame-method}
%\alias{chromosome,RangedDataCNV-method}
\alias{chromosome<-,SnpSet,integer-method}
\alias{chromosome<-,gSet,integer-method}
\alias{chromosome<-,GenomeAnnotatedDataFrame,integer-method}
\alias{chromosome,GRanges-method}
\alias{chromosome,GRangesList-method}
\title{ Methods for function chromosome in package oligoClasses}
\description{
 Methods for function \code{chromosome} in package \pkg{oligoClasses} ~~
}
\section{Methods}{

  The methods for \code{chromosome} extracts the chromosome (represented
  as an integer) for each marker in a \code{eSet}-derived class or a
  \code{AnnotatedDataFrame}-derived class.

  \describe{



\item{\code{signature(object = "AnnotatedDataFrame")}}{
  Accessor for chromosome.
}

\item{\code{signature(object = "eSet")}}{ If 'chromosome' is included in
    \code{fvarLabels(object)}, the integer representation of the
    chromosome will be returned. Otherwise, an error is thrown.  }

  \item{\code{signature(object = "GenomeAnnotatedDataFrame")}}{

  Accessor for chromosome.  If annotation was not available due to a
  missing or non-existent annotation package, the value returned by the
  accessor will be a vector of zero's.}

  \item{}{\code{(chromosome(object) <- value)}: Assign chromosome to the
  \code{AnnotatedDataFrame} slot of an \code{eSet}-derived \code{object}.}

\item{\code{signature(object = "RangedDataCNV")}}{Accessor for chromosome.}
}
}

\note{

  Integer representation: chr X = 23, chr Y = 24, chr XY = 25.  Symbols
  M, Mt, and MT are coded as 26.

}

\examples{
chromosome2integer(c(1:22, "X", "Y", "XY", "M"))
}

\seealso{\code{\link{chromosome2integer}}}
\keyword{methods}

\name{featureDataList-methods}
\docType{methods}
\alias{featureDataList}
\alias{featureDataList-methods}
\title{ Accessor for slot \code{featureDataList} in Package \pkg{oligoClasses} ~~}
\description{
 Accessor for slot \code{featureDataList} in Package \pkg{oligoClasses} ~~
}
\section{Methods}{
\describe{

\item{\code{signature(object = "gSetList")}}{
  An object inheriting from class \code{gSetList}.
}
}}
\keyword{methods}
\keyword{manip}

\name{getBar}
\alias{getBar}

\title{
  Gets a bar of a given length.
}
\description{
  Gets a bar of a given length.
}
\usage{
getBar(width = getOption("width"))
}

\arguments{
  \item{width}{desired length of the bar.}
}

\value{character string.}

\author{
  Benilton S Carvalho
}

\examples{
message(getBar())
}

\keyword{manip}

\name{batch}
\alias{batch}
\alias{batchNames}
\alias{batchNames<-}

\title{
	The batch variable for the samples.
}

\description{

Copy number estimates are susceptible to systematic differences between
  groups of samples that were processed at different times or by
  different labs.  While 'batch' is often unknown, a useful surrogates
  is often the scan date of the arrays (e.g., the month of the calendar
  year) or the 96 well chemistry plate on which the samples were arrayed
  during lab processing.

}

\usage{
batch(object)
batchNames(object)
batchNames(object) <- value
}

\arguments{
  \item{object}{
  An object of class \code{CNSet}.
}

  \item{value}{

  For 'batchNames', the value must be a character string corresponding
  of the unique batch names.

}

}

\value{

  The method 'batch' returns a \code{character} vector that has the same
  length as the number of samples in the \code{CNSet} object.

}

\author{
R. Scharpf
}

\seealso{
\code{\link{CNSet-class}}
}
\examples{
a <- matrix(1:25, 5, 5)
colnames(a) <- letters[1:5]
object <- new("CNSet", alleleA=a, batch=rep("batch1", 5))
batch(object)
batchNames(object)
}
\keyword{methods}

\name{ocLapply}
\alias{ocLapply}

\title{
lapply-like function that parallelizes code when possible.
}
\description{
ocLapply is an lapply-like function that checks if ff/snow are loaded
and if the cluster variable is set to execute FUN on a cluster. If these
requirements are not available, then lapply is used.
}
\usage{
ocLapply(X, FUN, ..., neededPkgs)
}

\arguments{
  \item{X}{first argument to FUN.}
  \item{FUN}{function to be executed.}
  \item{\dots}{additional arguments to FUN.}
  \item{neededPkgs}{packages needed to execute FUN on the compute nodes.}
}

\details{
  \code{neededPkgs} is needed when parallel computing is expected to be
  used. These packages are loaded on the compute nodes before the
  execution of FUN.
}

\value{
  A list of length length(X).
}

\author{
  Benilton S Carvalho
}

\seealso{lapply, parStatus}

\keyword{manip}

\name{affyPlatforms}
\alias{affyPlatforms}
\title{Available Affymetrix platforms for SNP arrays}
\description{
  Provides a listing of available Affymetrix platforms currently
  supported by the R package oligo
}
\usage{
affyPlatforms()
}


\value{
  A vector of class character.
}
\author{R. Scharpf}
\examples{
affyPlatforms()
}
\keyword{list}
\keyword{misc}

\name{ff_matrix-class}
\Rdversion{1.1}
\docType{class}
\alias{ff_matrix-class}
\alias{annotatedDataFrameFrom,ff_matrix-method}
\title{Class "ff_matrix"}
\description{
  ~~ A concise (1-5 lines) description of what the class is. ~~
}
\section{Objects from the Class}{A virtual Class: No objects may be created from it.}
\section{Slots}{
  \describe{
    \item{\code{.S3Class}:}{Object of class \code{"character"} ~~ }
  }
}
\section{Extends}{
Class \code{"\linkS4class{oldClass}"}, directly.
}
\section{Methods}{
  \describe{
    \item{annotatedDataFrameFrom}{\code{signature(object = "ff_matrix")}: ... }
	 }
}
\examples{
showClass("ff_matrix")
}
\keyword{classes}

\name{exprs-methods}
\docType{methods}
\alias{exprs-methods}
%\alias{exprs,ExpressionSet-method}
\alias{exprs,FeatureSet-method}
\alias{se.exprs,FeatureSet-method}
%\alias{exprs,SnpSet-method}
\title{Accessor for the 'exprs' slot}
\description{
  Accessor for the 'exprs'/'se.exprs' slot of FeatureSet-like objects
}
\section{Methods}{
\describe{
\item{object = "ExpressionSet"}{Expression matrix for objects of this
  class. Usually results of preprocessing algorithms, like RMA.}
\item{object = "FeatureSet"}{General container 'exprs' inherited from eSet}
\item{object = "SnpSet"}{General container 'exprs' inherited from eSet,
  not yet used.}
}}
\keyword{methods}

\name{getA}
\alias{getA}
\alias{getM}
\alias{getA,SnpQSet-method}
\alias{getM,SnpQSet-method}
\alias{getA,SnpCnvQSet-method}
\alias{getM,SnpCnvQSet-method}
\alias{getM,TilingFeatureSet2-method}
\alias{getA,TilingFeatureSet2-method}

\alias{A}
\alias{A,AlleleSet-method}
\alias{A<-}
\alias{A<-,AlleleSet-method}
\alias{A<-,AlleleSet,matrix-method}
\alias{B}
\alias{B,AlleleSet-method}
\alias{B<-}
\alias{B<-,AlleleSet-method}
\alias{B<-,AlleleSet,matrix-method}
\alias{open,AlleleSet-method}
\alias{close,AlleleSet-method}



%- Also NEED an '\alias' for EACH other topic documented here.
\title{Compute average log-intensities / log-ratios}
\description{
  Methods to compute average log-intensities and log-ratios across
  alleles, within strand.
}
\usage{
getA(object)
getM(object)
A(object, ...)
B(object, ...)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{object}{\code{SnpQSet}, \code{SnpCnvQSet} or
    \code{TilingFeatureSet2} object.}
%  \item{con}{\code{AlleleSet} or \code{AlleleSet} extension.}
  \item{...}{arguments to be passed to \code{allele} - 'sense' and
    'antisense' are valid values if the array is pre-SNP_5.0}
}

\details{

  For SNP data, SNPRMA summarizes the SNP information into 4 quantities (log2-scale):
  \itemize{
    \item{antisenseThetaA}{antisense allele A. (Not applicable for Affymetrix 5.0 and 6.0 platforms.)}
    \item{antisenseThetaB}{antisense allele B. (Not applicable for Affymetrix 5.0 and 6.0 platforms.)}
    \item{senseThetaA}{sense allele A.  (Not applicable for Affymetrix 5.0 and 6.0 platforms.)}
    \item{senseThataB}{sense allele B.  (Not applicable for Affymetrix 5.0 and 6.0 platforms.)}
    \item{alleleA}{Affymetrix 5.0 and 6.0 platforms}
    \item{alleleB}{Affymetrix 5.0 and 6.0 platforms}
  }

  The average log-intensities are given by:
  \code{(antisenseThetaA+antisenseThetaB)/2} and
  \code{(senseThetaA+senseThetaB)/2}.

  The average log-ratios are given by:
  \code{antisenseThetaA-antisenseThetaB} and
  \code{senseThetaA-senseThetaB}.

  For Tiling data, \code{getM} and \code{getA} return the log-ratio and
  average log-intensities computed across channels:
  \code{M = log2(channel1)-log2(channel2)}
  \code{A = (log2(channel1)+log2(channel2))/2}

  When large data support is enabled with the ff package, the
  AssayData elements of an \code{AlleleSet} object can be
  \code{ff_matrix} or \code{ffdf}, in which case pointers to the ff
  object are stored in the assay data.  The functions \code{open} and
  \code{close} can be used to open or close the connection,
  respectively.

}
\value{
  A 3-dimensional array (SNP's x Samples x Strand) with the requested
  measure, when the input SNP data (50K, 250K).

  A 2-dimensional array (SNP's x Samples), when the input is from SNP
  5.0 and SNP 6.0 arrays.

  A 2-dimensional array if the input is from Tiling arrays.
}

\seealso{\code{\link[oligo]{snprma}}}
\keyword{manip}

\name{SnpSet-methods}
%\docType{methods}
\alias{calls}
\alias{calls,SnpSet-method}
\alias{calls<-}
\alias{calls<-,SnpSet,matrix-method}
\alias{confs}
\alias{confs,SnpSet-method}
\alias{confs<-}
\alias{confs<-,SnpSet,matrix-method}
\alias{checkOrder,SnpSet-method}

\title{Accessors and methods for SnpSet objects}

\description{
  Utility functions for accessing data in \code{SnpSet} objects.
}

\usage{
calls(object)
calls(object) <- value
confs(object, transform=TRUE)
confs(object) <- value
}

\arguments{
  \item{object}{A \link{SnpSet} object.}
  \item{transform}{Logical. Whether to transform the integer
  representation of the confidence score (for memory efficiency) to a
  probability. See details.}
\item{value}{A matrix.}
}

\details{

  \code{calls} returns the genotype calls. CRLMM stores genotype calls
  as integers (1 - AA; 2 - AB; 3 - BB).

  \code{confs} returns the confidences associated with the genotype
  calls. The current implementation of CRLMM stores the confidences as
  integers to save memory on disk by using the transformation:

  round(-1000*log2(1-p)),

  where 'p' is the posterior probability of the call.  \code{confs} is
  a convenience function that transforms the integer representation
  back to a probability.  Note that if the assayData elements of the
  \code{SnpSet} objects are \code{ff_matrix} or \code{ffdf}, the
  \code{confs} function will return a warning. For such objects, one
  should first subset the \code{ff} object and coerce to a matrix,
  then apply the above conversion.  The function
  \code{snpCallProbability} for the \code{callProbability} slot of
  \code{SnpSet} objects.  See the examples below.

  \code{checkOrder} checks whether the object is ordered by chromosome
  and physical position, evaluating to TRUE or FALSE.

}

\note{
  Note that the replacement method for \code{confs<-} expects a matrix
  of probabilities and will automatically convert the probabilities to
  an integer representation.  See details for the conversion.

  The accessor \code{\link{snpCallProbability}} is an accessor for the
  'callProbability' element of the \code{assayData}.  The name can be
  misleading, however, as the accessor will not return a probability if
  the call probabilities are represented as integers.

}

%\section{Methods}{
%	\describe{
%	\item{\code{initialize(SnpSet)}:}{Object instantiation, used by
%	  \code{new}; not to be called directly by the user.}
%	\item{\code{calls(object)}:}{accessor for genotype calls}
%	\item{\code{confs(object)}:}{accessor for crlmm genotype confidence scores}
%	}
%}
\seealso{

  The helper functions \code{\link{p2i}} converts probabilities to
  integers and \code{\link{i2p}} converts integers to probabilities.

  See \code{\link{order}} and \code{\link{checkOrder}}.

}

\examples{

	theCalls <- matrix(sample(1:3, 20, rep=TRUE), nc=2)
	p <- matrix(runif(20), nc=2)
	integerRepresentation <- matrix(as.integer(round(-1000*log(1-p))), 10, 2)
	obj <- new("SnpSet2", call=theCalls, callProbability=integerRepresentation)
	calls(obj)
        confs(obj)  ## coerces to probability scale
        int <- Biobase::snpCallProbability(obj) ## not necessarily a probability
        p3 <- i2p(int)  ## to convert back to a probability

}
\keyword{manip}

\name{SummarizedExperiment-methods}
\alias{baf,RangedSummarizedExperiment-method}
\alias{chromosome,RangedSummarizedExperiment-method}
\alias{isSnp,RangedSummarizedExperiment-method}
\alias{lrr,RangedSummarizedExperiment-method}
\alias{baf,SummarizedExperiment-method}
\alias{chromosome,SummarizedExperiment-method}
\alias{isSnp,SummarizedExperiment-method}
\alias{lrr,SummarizedExperiment-method}
\title{Methods for RangedSummarizedExperiment objects}
\description{
  Methods for \link{RangedSummarizedExperiment}.
}
\usage{
\S4method{baf}{RangedSummarizedExperiment}(object)
\S4method{chromosome}{RangedSummarizedExperiment}(object,...)
\S4method{isSnp}{RangedSummarizedExperiment}(object, ...)
\S4method{lrr}{RangedSummarizedExperiment}(object)

}

\arguments{
  \item{object}{
    A \link{RangedSummarizedExperiment} object.
  }
  \item{...}{ignored}
}

\details{

  \code{baf} and \code{lrr} are accessors for the B allele
  frequencies and log R ratio assays (matrices or arrays), respectively,

  \code{chromosome} returns the \code{seqnames} of the \code{rowRanges}.

  \code{isSnp} returns a logical vector for each marker in
  \code{rowRanges} indicating whether the marker targets a SNP
  (nonpolymorphic regions are FALSE).

}

\seealso{
  \code{\linkS4class{RangedSummarizedExperiment}}
}


\keyword{methods}

\name{batchStatistics}
\alias{batchStatistics}
\alias{batchStatistics<-}
\title{

	Accessor for batch statistics uses for copy number estimation
	and storage of model parameters

}

\description{

	The \code{batchStatistics} slot contains statistics estimated
	from each batch that are used to derive copy number estimates.  

}
\usage{
batchStatistics(object)
batchStatistics(object) <- value
}
\arguments{
  \item{object}{  An object of class \code{CNSet}}
  \item{value}{An object of class \code{AssayData}}
}
\details{

	An object of class \code{AssayData} for slot
	\code{batchStatistics} is initialized automatically when
	creating a new \code{CNSet} instance.  Required in the call to
	\code{new} is a factor called \code{batch} whose unique values
	determine the number of columns for each assay data
	element. 

}

\value{

	\code{batchStatics} is an accessor for the slot
	\code{batchStatistics} that returns an object of class
	\code{AssayData}. 

}

\seealso{
	\code{\link{CNSet-class}}, \code{\link{batchNames}}, \code{\link{batch}}
}
\keyword{manip}
\keyword{methods}

\name{oligoSnpSet-methods}
\docType{methods}
\alias{oligoSnpSet-class}
\alias{initialize,oligoSnpSet-method}
\alias{baf,oligoSnpSet-method}
\alias{baf<-,oligoSnpSet-method}
\alias{coerce,oligoSnpSet,data.frame-method}
\alias{copyNumber,oligoSnpSet-method}
\alias{copyNumber<-,oligoSnpSet,matrix-method}
\alias{calls,oligoSnpSet-method}
\alias{calls<-,oligoSnpSet,matrix-method}
\alias{cnConfidence,oligoSnpSet-method}
\alias{cnConfidence<-,oligoSnpSet,matrix-method}
\alias{callsConfidence,oligoSnpSet-method}
\alias{callsConfidence<-,oligoSnpSet,matrix-method}
\alias{position<-,oligoSnpSet,integer-method}
\alias{updateObject,oligoSnpSet-method}
\title{Methods for oligoSnpSet class}
\description{Methods for oligoSnpSet class}

\section{Methods}{

  In the following code, \code{object} is an instance of the
  \code{oligoSnpSet} class.

  \describe{

    \item{}{
      \code{new("oligoSnpSet", ...)}:
      Instantiates an object of class \code{oligoSnpSet}.  The assayData
      elements of the \code{oligoSnpSet} class can include matrices of
      genotype calls, confidence scores for the genotype calls, B allele
      frequencies, absolute or relative copy number, and confidence
      scores for the copy number estimates. Each matrix should be
      coerced to an integer scale prior to assignment to the
      \code{oligoSnpSet} object.  Validity methods defined for the class
      will fail if the matrices are not integers. See examples for
      additional details.
    }

    \item{}{
      \code{baf(object)}:
      Accessor for integer representation of the B allele frequencies.
      The value returned by this method can be divided by 1000 to obtain
      B allele frequencies on the original [0,1] scale.
    }

    \item{}{
      \code{baf(object) <- value}:
      Assign an integer representation of the B allele frequencies to
      the 'baf' element of the assayData slot.  \code{value} must be a
      matrix of integers. See the examples for help converting BAFs to a
      matrix of integers.
    }
  }

}

%\examples{}


\keyword{methods}

\name{ocSamples}
\alias{ocSamples}
\alias{ocProbesets}

\title{
  Cluster and large dataset management utilities.
}
\description{
  Tools to simplify management of clusters via 'snow' package and large
  dataset handling through the 'bigmemory' package.
}
\usage{
ocSamples(n)
ocProbesets(n)
}

\arguments{
  \item{n}{integer representing the maximum number of samples/probesets
    to be processed simultaneously on a compute node.}
}

\details{
  Some methods in the oligo/crlmm packages, like \code{backgroundCorrect},
  \code{normalize}, \code{summarize} and \code{rma} can use a cluster
  (set through the 'foreach' package). The use of cluster features is
  conditioned on the availability of the 'ff' (used to
  provide shared objects across compute nodes) and 'foreach' packages.

  To use a cluster, 'oligo/crlmm' checks for three requirements: 1) 'ff'
  is loaded; 2) an adaptor for the parallel backend (like 'doMPI',
  'doSNOW', 'doMC') is loaded and registered.

  If only the 'ff' package is available and loaded (in addition
  to the caller package - 'oligo' or 'crlmm'), these methods will allow
  the user to analyze datasets that would not fit in RAM at the expense
  of performance.

  In the situations above (large datasets and cluster), oligo/crlmm uses the
  options \code{ocSamples} and \code{ocProbesets} to limit the
  amount of RAM used by the machine(s). For example, if ocSamples is
  set to 100, steps like background correction and normalization process
  (in RAM) 100 samples simultaneously on each compute node. If
  ocProbesets is set to 10K, then summarization processes 10K
  probesets at a time on each machine.
}

\section{Warning}{
  In both scenarios (large dataset and/or cluster use), there
  is a penalty in performance because data are written to disk (to
  either minimize memory footprint or share data across compute nodes).
}

\author{
  Benilton Carvalho
}

\examples{
   if(require(doMC)) {
       registerDoMC()
       ## tasks like summarize()
   }
}
\keyword{manip}

\name{is.ffmatrix}
\alias{is.ffmatrix}

\title{
Check if object is an ff-matrix object.
}
\description{
Check if object is an ff-matrix object.
}
\usage{
is.ffmatrix(object)
}

\arguments{
  \item{object}{object to be checked}
}

\value{
  Logical.
}

\note{
  This function is meant to be used by developers.
}

\examples{
if (isPackageLoaded("ff")){
  x1 <- ff(vmode="double", dim=c(10, 2))
  is.ffmatrix(x1)
}
x1 <- matrix(0, nr=10, nc=2)
is.ffmatrix(x1)

}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{manip}

\name{platform-methods}
\docType{methods}
\alias{platform}
\alias{platform-methods}
\alias{platform,FeatureSet-method}
\title{Platform Information}
\description{
  Platform Information
}
\section{Methods}{
\describe{
\item{object = "FeatureSet"}{platform information}
}}
\keyword{methods}

\name{locusLevelData}
\alias{locusLevelData}
\docType{data}
\title{Basic data elements required for the HMM}
\description{
  This object is a list containing the basic data elements required for the HMM
}
\usage{data(locusLevelData)}
\format{
  A list
}
\details{
  
  The basic assay data elements that can be used for fitting the HMM
  are:

  1.  a mapping of platform identifiers to chromosome and physical
  position

  2. (optional) a matrix of copy number estimates

  3. (optional) a matrix of confidence scores for the copy number
  estimates (e.g., inverse standard deviations)
  
  4. (optional) a matrix of genotype calls

  5. (optional) CRLMM confidence scores for the genotype calls

  At least (2) or (4) is required.  The locusLevelData is a list that
  contains (1), (2), (4), and (5).
  
}
\source{
  
  A HapMap sample on the Affymetrix 50k platform.  Chromosomal
  alterations were simulated.  The last 100 SNPs on chromosome 2 are, in
  fact, a repeat of the first 100 SNPs on chromosome 1 -- this was added
  for internal use.
  
}

\examples{
data(locusLevelData)
str(locusLevelData)
}
\keyword{datasets}

\name{genomeBuild}
\alias{genomeBuild}
\alias{genomeBuild<-}
\alias{genomeBuild,DBPDInfo-method}
\alias{genomeBuild,FeatureSet-method}

\title{Genome Build Information}
\description{
  Returns the genome build. This information comes from the
  annotation package and is given as an argument during the package
  creation process.
}
\usage{
genomeBuild(object)
}

\value{ character string  }

\note{Supported builds are UCSC genome builds are 'hg18' and 'hg19'.}

\arguments{
  \item{object}{Supported objects include \code{PDInfo},
  \code{FeatureSet}, and any \code{gSet}-derived or
  \code{eSetList}-derived object.  }
}

\examples{
  showMethods("genomeBuild", where="package:oligoClasses")
}

\keyword{manip}

\name{list.celfiles}
\alias{list.celfiles}

\title{List CEL files.}
\description{
  Function used to get a list of CEL files.
}
\usage{
	list.celfiles(..., listGzipped=FALSE)
}

\arguments{
  \item{\dots}{Passed to \code{\link{list.files}}}
  \item{listGzipped}{Logical. List .CEL.gz files?}
}
\value{
  Character vector with filenames.
}

\note{
  Quite often users want to use this function to pass filenames to other
  methods. In this situations, it is safer to use the argument 'full.names=TRUE'.
}
\seealso{\code{\link{list.files}}}
\examples{
if (require(hapmapsnp5)){
  path <- system.file("celFiles", package="hapmapsnp5")

  ## only the filenames
  list.celfiles(path)

  ## the filenames with full path...
  ## very useful when genotyping samples not in the working directory
  list.celfiles(path, full.names=TRUE)
}else{
  ## this won't return anything
  ## if in the working directory there isn't any CEL
  list.celfiles(getwd())
}
}
\keyword{IO}
\keyword{utilities}

\name{scqsExample}
\alias{scqsExample}
\docType{data}
\title{SnpCnvQSet Example}
\description{
  Example of SnpCnvQSet object.
}
\usage{data(scqsExample)}
\format{
  Object belongs to SnpCnvQSet class.
}
\examples{
data(scqsExample)
class(scqsExample)
}
\keyword{datasets}

\name{pmFragmentLength-methods}
\docType{methods}
\alias{pmFragmentLength}
\alias{pmFragmentLength-methods}
\alias{pmFragmentLength,AffySNPPDInfo-method}
\title{Information on Fragment Length}
\description{
  This method will return the fragment length for PM probes.
}
\section{Methods}{
\describe{
\item{object = "AffySNPPDInfo"}{On \code{AffySNPPDInfo} objects, it will
return the fragment length that contains the SNP in question.}
}}
\keyword{methods}

\name{BeadStudioSetList-class}
\Rdversion{1.1}
\docType{class}
\alias{BeadStudioSetList-class}
\alias{BafLrrSetList-class}
\alias{oligoSetList-class}
\alias{[[,BeadStudioSetList,ANY,ANY-method}
\alias{[[,BafLrrSetList,ANY,ANY-method}
\alias{[[<-,BafLrrSetList,ANY,ANY,BafLrrSet-method}
\alias{baf,BeadStudioSetList-method}
\alias{baf,BafLrrSetList-method}
\alias{baf,oligoSetList-method}
\alias{calls,oligoSetList-method}
\alias{clone2}
\alias{clone2,BafLrrSetList-method}
\alias{copyNumber,oligoSetList-method}
\alias{initialize,BeadStudioSetList-method}
\alias{lrr,BeadStudioSetList-method}
\alias{lrr,BafLrrSetList-method}
\alias{lrr<-,BafLrrSetList,matrix-method}
\alias{updateObject,BeadStudioSetList-method}

\title{List classes with assay data listed by chromosome}

\description{
  Container for log R ratios and B allele frequencies stored by chromosome.
}


\section{Slots}{
  \describe{
    \item{\code{assayDataList}:}{Object of class \code{"AssayData"} ~~ }
    \item{\code{phenoData}:}{Object of class \code{"AnnotatedDataFrame"} ~~ }
    \item{\code{featureDataList}:}{Object of class \code{"list"} ~~ }
    \item{\code{chromosome}:}{Object of class \code{"integer"} ~~ }
    \item{\code{annotation}:}{Object of class \code{"character"} ~~ }
    \item{\code{genome}:}{Object of class \code{"character"} indicating
  the genome build. Valid entries are "hg18" and "hg19". }
  }
}

\section{Methods defined for the class}{
  \describe{
    \item{}{\code{clone2(object, id, prefix="",...)}

      Performs a deep copy of the ff objects in the assay data elements
  of \code{object}.  A new object of the same class will be
  instantiated.  The ff objects in the instantiated object will point to
  ff files on disk with prefix given by the argument \code{prefix}.

  A use-case for such a function is that one may want to perform wave
  correction on the log R ratios in \code{object}, but keep a copy of
  the original unadjusted log R ratios.  If \code{object} is not copied
  using \code{clone2} prior to wave correction, the log R ratios will be
  updated on disk and the original, unadjusted log R ratios will no
  longer be available.

  }
}
}

\section{Accessors}{
  \describe{
    \item{}{\code{baf(object)}An accessor for the B allele frequencies
  (BAFs).  The accessor returns a list where each element of the list is
  a matrix of the BAFs for the corresponding element in the SetList
  object.  While the BAFs have a range [0, 1], they are often saved
  internally as integers by multiplying the original BAFs by 1000.
  Users can restore the original scale by dividing by 1000.}

  \item{}{\code{lrr(object)} An accessor for the log R ratios, an
  estimate of the copy number (presumably relative to diploid copy
  number) at each marker on a SNP array.  The accessor returns a list
  where each element of the list is a matrix of the log R ratios for the
  corresponding element in the SetList object.  The log R ratios are
  often saved internally as integers by multiplying the original LRRs by
  100 in order to reduce the memory footprint of large studies.  Users
  can restore the original scale by dividing by 100.}
  }
}

\author{
R. Scharpf
}
\seealso{
  See supporting packages for methods defined for the class.
}

\keyword{classes}

\name{setCluster}
\alias{setCluster}
\alias{getCluster}
\alias{delCluster}
\alias{setCluster-deprecated}
\alias{getCluster-deprecated}
\alias{delCluster-deprecated}

\title{
  DEPRECATED FUNCTIONS.
  Cluster and large dataset management utilities.
}
\description{
  Tools to simplify management of clusters via 'snow' package and large
  dataset handling through the 'bigmemory' package.
}
\usage{
setCluster(...)
getCluster()
delCluster()
}

\arguments{
  \item{\dots}{arguments to be passed to \code{makeCluster} in the
    'snow' package.}
}

\details{
  Some methods in the oligo/crlmm packages, like \code{backgroundCorrect},
  \code{normalize}, \code{summarize} and \code{rma} can use a cluster
  (set through 'snow' package). The use of cluster features is
  conditioned on the availability of the 'bigmemory' (used to
  provide shared objects across compute nodes) and 'snow' packages.

  To use a cluster, 'oligo/crlmm' checks for three requirements: 1)
  'ff' is loaded; 2) 'snow' is loaded; and 3) the 'cluster'
  option is set (e.g., via options(cluster=makeCluster(...)) or
  setCluster(...)).

  If only the 'ff' package is available and loaded (in addition
  to the caller package - 'oligo' or 'crlmm'), these methods will allow
  the user to analyze datasets that would not fit in RAM at the expense
  of performance.

  In the situations above (large datasets and cluster), oligo/crlmm uses the
  options \code{ocSamples} and \code{ocProbesets} to limit the
  amount of RAM used by the machine(s). For example, if ocSamples is
  set to 100, steps like background correction and normalization process
  (in RAM) 100 samples simultaneously on each compute node. If
  ocProbesets is set to 10K, then summarization processes 10K
  probesets at a time on each machine.
}

\section{Warning}{
  In both scenarios (large dataset and/or cluster use), there
  is a penalty in performance because data are written to disk (to
  either minimize memory footprint or share data across compute nodes).
}

\author{
  Benilton Carvalho
}
\keyword{manip}

\name{ffdf-class}
\Rdversion{1.1}
\docType{class}
\alias{ffdf-class}
\alias{list_or_ffdf-class}


\title{Class "ffdf"}

\description{

	Extended package ff's class definitions for ff to S4.	

}
\section{Objects from the Class}{A virtual Class: No objects may be created from it.}
\section{Slots}{
  \describe{
    \item{\code{.S3Class}:}{Object of class \code{ffdf} ~~ }
  }
}
\section{Extends}{
Class \code{"\linkS4class{oldClass}"}, directly.
Class \code{"\linkS4class{list_or_ffdf}"}, directly.
}
\section{Methods}{
No methods defined with class "ffdf" in the signature.
}
\keyword{classes}

\name{i2p}
\alias{i2p}
\alias{p2i}

\title{

	Functions to convert probabilities to integers, or integers to probabilities.

}

\description{

	Probabilities estimated in the \code{crlmm} package are often
	stored as integers to save memory.  We provide a few utility
	functions to go back and forth between the probability and
	integer representations.

}
\usage{
i2p(i)
p2i(p)
}

\arguments{
  \item{i}{  A matrix or vector of integers.}
  \item{p}{  A matrix or vector of probabilities.}
}

\value{

The value returned by \code{i2p} is 

1 - exp(-i/1000)

The value returned by \code{2pi} is 

  as.integer(-1000*log(1-p))

}

\seealso{ \code{\link{confs}}}
\examples{
	i2p(693)
	p2i(0.5)
	i2p(p2i(0.5))
}
\keyword{manip}

\name{createFF}
\alias{createFF}

\title{
  Create ff objects.
}
\description{
  Creates ff objects (array-like) using settings (path) defined by oligoClasses.
}
\usage{
createFF(name, dim, vmode = "double", initdata = NULL)
}

\arguments{
  \item{name}{Prefix for filename.}
  \item{dim}{Dimensions.}
  \item{vmode}{Mode.}
  \item{initdata}{NULL.}
}

\value{
  ff object.
}

\note{
  This function is meant to be used by developers.
}

\seealso{
  ff
}

\keyword{manip}

\name{position-methods}
\docType{methods}
\alias{position-methods}
\alias{position}
\alias{position,AnnotatedDataFrame-method}
\alias{position,SnpSet-method}
\alias{position,gSet-method}
\alias{position,GenomeAnnotatedDataFrame-method}
\title{Methods for function position in Package oligoClasses}
\description{
   Methods for function \code{position} in package \pkg{oligoClasses}
}
\section{Methods}{

  The methods for \code{position} extracts the physical position stored
  as an integer for each marker in a \code{eSet}-derived class or a
  \code{AnnotatedDataFrame}-derived class.

\describe{

\item{\code{signature(object = "AnnotatedDataFrame")}}{
  Accessor for physical position.
}

\item{\code{signature(object = "eSet")}}{
  If 'position' is included in \code{fvarLabels(object)}, the physical
  position will be returned. Otherwise, an error is thrown.
}

\item{\code{signature(object = "GenomeAnnotatedDataFrame")}}{
  Accessor for physical position.  If annotation was not available  due
  to a missing or non-existent annotation package, the value  returned
  by the accessor will be a vector of zero's.
}
}
}
\keyword{methods}

\name{SnpSuperSet-class}
\Rdversion{1.1}
\docType{class}
\alias{SnpSuperSet-class}
\alias{SnpSuperSet}
\alias{initialize,SnpSuperSet-method}

\title{Class "SnpSuperSet"}
\description{A class to store locus-level summaries of the quantile normalized intensities, genotype calls, and genotype confidence scores}
\section{Objects from the Class}{
\code{new("SnpSuperSet", allelea=alleleA, alleleB=alleleB, call=call, callProbability, ...)}.
}
\section{Slots}{
  \describe{
    \item{\code{assayData}:}{Object of class \code{"AssayData"} ~~ }
    \item{\code{phenoData}:}{Object of class \code{"AnnotatedDataFrame"} ~~ }
    \item{\code{featureData}:}{Object of class \code{"AnnotatedDataFrame"} ~~ }
    \item{\code{experimentData}:}{Object of class \code{"MIAME"} ~~ }
    \item{\code{annotation}:}{Object of class \code{"character"} ~~ }
    \item{\code{protocolData}:}{Object of class \code{"AnnotatedDataFrame"} ~~ }
    \item{\code{.__classVersion__}:}{Object of class \code{"Versions"} ~~ }
  }
}
\section{Extends}{
Class \code{"\linkS4class{AlleleSet}"}, directly.
Class \code{"\linkS4class{SnpSet}"}, directly.
Class \code{"\linkS4class{eSet}"}, by class "AlleleSet", distance 2.
Class \code{"\linkS4class{VersionedBiobase}"}, by class "AlleleSet", distance 3.
Class \code{"\linkS4class{Versioned}"}, by class "AlleleSet", distance 4.
}
\section{Methods}{
No methods defined with class "SnpSuperSet" in the signature.
}
\author{R. Scharpf}
\seealso{
	\code{\linkS4class{AlleleSet}}
}
\examples{
showClass("SnpSuperSet")
## empty object from the class
x <- new("matrix")
new("SnpSuperSet", alleleA=x, alleleB=x, call=x, callProbability=x)
}
\keyword{classes}

\name{sfsExample}
\alias{sfsExample}
\docType{data}
\title{SnpFeatureSet Example}
\description{
  Example of SnpFeatureSet object.
}
\usage{data(sfsExample)}
\format{
  Object belongs to SnpFeatureSet class
}
\examples{
data(sfsExample)
class(sfsExample)
}
\keyword{datasets}

\name{GenomeAnnotatedDataFrame-class}
\Rdversion{1.1}
\docType{class}
\alias{GenomeAnnotatedDataFrame-class}
\alias{GenomeAnnotatedDataFrame}
\alias{coerce,AnnotatedDataFrame,GenomeAnnotatedDataFrame-method}
\alias{getArm,GenomeAnnotatedDataFrame-method}
\alias{initialize,GenomeAnnotatedDataFrame-method}
\alias{makeFeatureGRanges,GenomeAnnotatedDataFrame-method}
\alias{position<-}
\alias{position<-,GenomeAnnotatedDataFrame,integer-method}
\alias{updateObject,GenomeAnnotatedDataFrame-method}

\title{Class \code{"GenomeAnnotatedDataFrame"}}
\description{
  AnnotatedDataFrame with genomic coordinates (chromosome, position)
}

\section{Slots}{
  \describe{
    \item{\code{varMetadata}:}{Object of class \code{"data.frame"} ~~ }
    \item{\code{data}:}{Object of class \code{"data.frame"} ~~ }
    \item{\code{dimLabels}:}{Object of class \code{"character"} ~~ }
    \item{\code{.__classVersion__}:}{Object of class \code{"Versions"} ~~ }
  }
}

\section{Extends}{
Class \code{"\linkS4class{AnnotatedDataFrame}"}, directly.
Class \code{"\linkS4class{Versioned}"}, by class "AnnotatedDataFrame", distance 2.
}

\section{Coercion to or from other classes}{
  \describe{
    \item{}{

      \code{as(from, "GenomeAnnotatedDataFrame")}:

      Coerce an object of class \code{AnnotatedDataFrame} to a
      \code{GenomeAnnotatedDataFrame}.

    }

    \item{}{
      \code{makeFeatureGRanges(object, genome, ...)}:

      Construct a \code{GRanges} instance from a
      \code{GenomeAnnotatedDataFrame} object.  \code{genome} is a
      character string indicating the UCSC build. Supported builds are
      "hg18" and "hg19", but are platform specific.  In particular, some
      platforms only support build hg19 at this time.


    }

  \item{}{
    \code{updateObject(object)}:

    For updating a \code{GenomeAnnotatedDataFrame}

  }

  }
}

\section{Accessors}{
  \describe{
    \item{}{
      \code{chromosome(object)}, \code{chromosome(object) <- value}

      Get or set chromosome.

    }

    \item{}{
      \code{isSnp(object)}:

      Many platforms include polymorphic and nonpolymorphic markers.  isSnp
      evalutes to \code{TRUE} if the marker is polymorphic.

    }


    \item{}{
      \code{position(ojbect)}:

      Physical position in the genome

    }

  \item{}{

    \code{getArm(object, genome)}:

    Retrieve character vector indicating the chromosome arm of each
    marker in \code{object}.  \code{genome} should indicate which genome
    build was used to define the chromosomal locations (currently, only
    UCSC genome builds 'hg18' and 'hg19' supported for this function).

    }

  }

}

\author{
R. Scharpf
}

\name{GRanges-methods}
\docType{methods}
%\alias{coverage2,GRanges-method}
%\alias{coverage2,GRangesList-method}
\alias{state}
\alias{coverage2}
\alias{numberProbes}
\alias{coverage2,GRanges-method}
\alias{coverage2,GRangesList-method}
\alias{numberProbes,GRanges-method}
\alias{numberProbes,GRangesList-method}
\alias{findOverlaps,GRanges,gSet-method}
\alias{findOverlaps,GRangesList,gSet-method}
\alias{genomeBuild,GRanges-method}
\alias{sampleNames,GRanges-method}
\alias{sampleNames,GRangesList-method}
\alias{state,GRanges-method}
\alias{state,GRangesList-method}

\title{Methods for GRanges objects}

\description{Methods for GRanges objects}

\section{findOverlaps methods}{

  \describe{

    \item{}{
      \code{findOverlaps(query, subject, ...)}:

      Find the feature indices in \code{subject} that overlap the
      genomic intervals in \code{query}, where \code{query} is a
      \code{GRanges} object and subject is a \code{gSet}-derived object.
      Additional arguments to the \code{findOverlaps} method in the
      package \pkg{IRanges} can be passed through the \code{\dots}
      operator.

  }

}
}

\section{Accessors}{

  \code{object}  is an instance of the \code{GRanges} class.

  \describe{

    \item{}{
      \code{coverage2(object)}:

      For the \code{GRanges} and \code{GRangesList} objects returned by
      the hidden Markov model implemented in the "VanillaICE" package
      and the segmentation algorithm in the "MinimumDistance" package,
      the intervals are annotated by the number of probes (markers) for
      SNPs and nonpolymorphic regions.  \code{coverage2} and
      \code{numberProbes} are convenient accessors for these
      annotations.

    }

    \item{}{
      \code{genomeBuild(object)}:

      Accessor for the UCSC genome build.

    }

    \item{}{
      \code{numberProbes(object)}:

      Integer vector indicating the number of probes (markers) for each
      range in \code{object}.  Equivalent to \code{coverage2}.

    }

    \item{}{
      \code{state(object)}:

      Accessor for the \code{elementMetadata} column 'state', when
      applicable. State is used to contain the index of the inferred
      copy number state for various \code{hmm} methods defined in the
      \pkg{VanillaICE}.

    }

  }
  }

  \seealso{\code{\linkS4class{GRanges}}}

  \examples{
	  library(IRanges)
	  library(GenomicRanges)
	  gr1 <- GRanges(seqnames = "chr2", ranges = IRanges(3, 6),
			 state=3L, numberProbes=100L)
	  ## convenience functions
	  state(gr1)
	  numberProbes(gr1)

	  gr2 <- GRanges(seqnames = c("chr1", "chr1"),
			 ranges = IRanges(c(7,13), width = 3),
			 state=c(2L, 2L), numberProbes=c(200L, 250L))
	  gr3 <- GRanges(seqnames = c("chr1", "chr2"),
			 ranges = IRanges(c(1, 4), c(3, 9)),
			 state=c(1L, 4L), numberProbes=c(300L, 350L))
	  ## Ranges organized by sample
	  grl <- GRangesList("sample1" = gr1, "sample2" = gr2, "sample3" = gr3)
	  sampleNames(grl) ## same as names(grl)
	  numberProbes(grl)
	  chromosome(grl)
	  state(grl)
	  gr <- stack(grl)
	  sampleNames(gr)
	  chromosome(gr)
	  state(gr)
  }

\keyword{methods}

\name{efsExample}
\alias{efsExample}
\docType{data}
\title{ExpressionFeatureSet Object}
\description{
  Example of ExpressionFeatureSet Object.
}
\usage{data(efsExample)}
\format{
  Object belongs to ExpressionFeatureSet class.
}
\examples{
data(efsExample)
class(efsExample)
}
\keyword{datasets}

\name{BeadStudioSet-class}
\Rdversion{1.1}
\docType{class}
\alias{BeadStudioSet-class}
\alias{BafLrrSet-class}
\alias{BeadStudioSet}
\alias{baf,BeadStudioSet-method}
\alias{baf<-,BeadStudioSet-method}
\alias{baf<-}
\alias{copyNumber,BeadStudioSet-method}
\alias{copyNumber<-,BeadStudioSet,ANY-method}
\alias{coerce,BeadStudioSet,data.frame-method}
\alias{initialize,BeadStudioSet-method}
\alias{lrr,BeadStudioSet-method}
\alias{lrr<-,BeadStudioSet-method}
\alias{lrr<-,BeadStudioSet,ANY-method}
\alias{lrr<-,BafLrrSet-method}
\alias{lrr<-,BafLrrSet,ANY-method}
\alias{lrr<-}
\alias{show,BeadStudioSet-method}
\alias{updateObject,BeadStudioSet-method}

\title{Class \code{"BeadStudioSet"}}
\description{
  A container for log R ratios and B allele frequencies from SNP arrays.
}
\section{Objects from the Class}{
  Objects can be created by calls of the form \code{new("BeadStudioSet", assayData, phenoData, featureData, experimentData, annotation, protocolData, baf, lrr, ...)}.
}
\section{Slots}{
  \describe{
    \item{\code{featureData}:}{Object of class \code{"GenomeAnnotatedDataFrame"} ~~ }
    \item{\code{assayData}:}{Object of class \code{"AssayData"} ~~ }
    \item{\code{phenoData}:}{Object of class \code{"AnnotatedDataFrame"} ~~ }
    \item{\code{experimentData}:}{Object of class \code{"MIAxE"} ~~ }
    \item{\code{annotation}:}{Object of class \code{"character"} ~~ }
    \item{\code{protocolData}:}{Object of class
      \code{"AnnotatedDataFrame"} ~~ }
    \item{\code{genome}:}{Object of class \code{"character"} ~~ }
    \item{\code{.__classVersion__}:}{Object of class \code{"Versions"} ~~ }
  }
}
\section{Extends}{
Class \code{"\linkS4class{gSet}"}, directly.
Class \code{"\linkS4class{eSet}"}, by class "gSet", distance 2.
Class \code{"\linkS4class{VersionedBiobase}"}, by class "gSet", distance 3.
Class \code{"\linkS4class{Versioned}"}, by class "gSet", distance 4.
}
\section{Methods}{
  In the methods below, \code{object} has class \code{BeadStudioSet}.
  \describe{
    \item{}{\code{baf(object)}: accessor for the matrix of B allele frequencies.}
    \item{}{\code{baf(object) <- value} replacement
    method for B allele frequencies: \code{value} must be a matrix of integers.}
    \item{}{\code{as(object, "data.frame")}: coerce to data.frame with column headers 'lrr',
      'baf', 'x' (physical position with unit Mb), 'id', and 'is.snp'.
      Used for plotting with lattice.}
    \item{}{\code{copyNumber(object)}:  accessor for log R ratios.}
    \item{}{\code{copyNumber(object) <- value}:  replacement method for
      the log R ratios}
    \item{initialize}{\code{signature(.Object = "BeadStudioSet")}:
      constructs an instance of the class}
    \item{}{\code{lrr(object)}: accessor for matrix of log R ratios}
    \item{}{\code{lrr(object) <- value} replacement method for log R
      ratios: \code{value} should be a matrix or a \code{ff_matrix}.}
    \item{}{\code{show(object)}: print a short summary of the
      \code{BeadStudioSet} object.}
    \item{}{\code{updateObject(object)}: update a \code{BeadStudioSet} object.}
  }
}


\author{
R. Scharpf
}

\examples{
new("BeadStudioSet")
}
\keyword{classes}

\name{flags}
\alias{flags}

\title{
	
	Batch-level summary of SNP flags.	

}
\description{
	
	Used to flag SNPs with low minor allele frequencies, or for
	possible problems during the CN estimation step.  Currently,
	this is primarily more for internal use.
	
}
\usage{
flags(object)
}
\arguments{
  \item{object}{
  An object of class \code{CNSet}
}
}

\value{

	A \code{matrix} or \code{ff_matrix} object with rows
	corresponding to markers and columns corresponding to batch.

}

\seealso{
	\code{\link{batchStatistics}}
}
\examples{
x <- matrix(runif(250*96*2, 0, 2), 250, 96*2)
test1 <- new("CNSet", alleleA=x, alleleB=x, call=x, callProbability=x,
	      batch=as.character(rep(letters[1:2], each=96)))
dim(flags(test1))
}
\keyword{manip}
\keyword{methods}

\name{celfileDate}
\alias{celfileDate}
\title{ Cel file dates}
\description{ Parses cel file dates from the header of .CEL files for the Affymetrix platform}
\usage{
	celfileDate(filename)
}
\arguments{
  \item{filename}{
  Name of cel file
}
}
\value{
	character string
}
\author{H. Jaffee}
\examples{
require(hapmapsnp6)
path <- system.file("celFiles", package="hapmapsnp6")
celfiles <- list.celfiles(path, full.names=TRUE)
dts <- sapply(celfiles, celfileDate)
}
\keyword{manip}

\name{CopyNumberSet-methods}
\docType{methods}
\alias{CopyNumberSet-methods}
\alias{copyNumber}
\alias{copyNumber<-}
\alias{cnConfidence}
\alias{cnConfidence<-}
\title{Methods for class CopyNumberSet.}
\description{
	Accessors and CopyNumberSet
}

\usage{

copyNumber(object, ...)
cnConfidence(object)
copyNumber(object) <- value
cnConfidence(object) <- value

}

\arguments{

\item{object}{\code{CopyNumberSet} object or derived class}
\item{\dots}{Ignored for \code{CopyNumberSet} and \code{oligoSnpSet}. }
\item{value}{matrix}
}

\value{

	\code{copyNumber} returns a matrix of copy number estimates or
	relative copy number estimates.  Since the copy number estimates
	are stored as integers (copy number * 100), the matrix returned
	by the \code{copyNumber} accessor will need to be divided by a
	factor of 100 to transform the measurements back to the original
	copy number scale.

	\code{cnConfidence} returns a matrix of confidence scores for
	the copy number estimates.  These are also represented as
	integers and will require a back-transformation to the original
	scale.

}
\keyword{methods}
\keyword{manip}

\examples{
	library(Biobase)
	data(locusLevelData)
	path <- system.file("extdata", package="oligoClasses")
	fd <- readRDS(file.path(path, "genomeAnnotatedDataFrameExample.rds"))
	## the following command creates an 'oligoSnpSet' object, storing
	## an integer representation of the log2 copy number in the 'copyNumber' element
	## of the assayData.  Genotype calls and genotype confidence scores are also stored
	## in the assayData.
	oligoSet <- new("oligoSnpSet",
			copyNumber=integerMatrix(log2(locusLevelData[["copynumber"]]/100), 100),
			call=locusLevelData[["genotypes"]],
			callProbability=integerMatrix(locusLevelData[["crlmmConfidence"]], 1),
			annotation=locusLevelData[["platform"]],
			featureData=fd,
			genome="hg19")

	## There are several accessors for the oligoSnpSet class.
	icn <- copyNumber(oligoSet)
	range(icn) ## integer scale
	lcn <- icn/100
	range(lcn) ## log2 copy number

	## confidence scores for the genotypes are also represented on an integer scale
	ipr <- snpCallProbability(oligoSet)
	range(ipr) ## integer scale

	## for genotype confidence scores, the helper function i2p
	## converts back to a probability scale
	pr <- i2p(ipr)
	range(pr)

	## The helper function confs is a shortcut, extracting the
	## integer-based confidence scores and transforming to the
	## probability scale
	pr2 <- confs(oligoSet)
	all.equal(pr, pr2)

	## To extract information on the annotation of the SNPs, one can use
	position(oligoSet)
	chromosome(oligoSet)
	## the position and chromosome coordinates were extracted from build hg19
	genomeBuild(oligoSet)
}

\name{isPackageLoaded}
\alias{isPackageLoaded}

\title{
  Check if package is loaded.
}
\description{
  Checks if package is loaded.
}
\usage{
isPackageLoaded(pkg)
}

\arguments{
  \item{pkg}{
    Package to be checked.
}
}
\details{
  Checks if package name is in the search path.
}
\value{
  Logical.
}

\seealso{
  search
}
\examples{
isPackageLoaded("oligoClasses")
isPackageLoaded("ff")
isPackageLoaded("snow")
}

\keyword{manip}
